function strong=BoostROC(doPrints, clase1, clase2, T, test)

PRINT_=1;
if nargin<5
    test.c1=zeros(1,size(clase1,2));
    test.c2=ones(1,size(clase1,2));
end
[Nc1,dim]=size(clase1);
Nc2=size(clase2,1);

TOL=1.0e-16;
onesD=ones(dim,1);
graph=0;
N=floor(0.9*min(Nc1,Nc2));

% Set de los valores de trabajo
clear strong;
initHyp=1;
w2=ones(1,Nc2);
w1=ones(1,Nc1);
fprintf('Performing %d rounds of boosting...\n',T);
old_err=1;
for t=initHyp:T
    if PRINT_==1
        if(doPrints && mod(t,100) == 0)
%             fprintf('Boosting round %d - ',t);
%         elseif(mod(t,100) == 0)
            fprintf('Boosting round %d/%d - ',t, T);
%         elseif(t == T)
%             fprintf('Boosting round %d/%d - ',t, T);
        end
    end
    
    % normalize weights for Adaboost...
    tw=sum(w1)+sum(w2);
    w1=w1/tw;
    w2=w2/tw;
        
    % Aprendemos el WEAK segun la distribucion dada por los pesos
    [weak.thr,weak.p] = SingleWeakLearnerROC(clase1,w1,clase2,w2);
    
    dummy=ones(size([clase1;clase2],1),1);
    % Clasificamos con el weak actual
    clases = (dummy*weak.p).*[clase1;clase2]<dummy*(weak.p.*weak.thr);
    
    % Seleccionamos la caracteristica con menor error 
    error=sum([w1,w2]'*ones(size(clase1,2),1)'.*(clases~=[ones(size(clase1));zeros(size(clase2))]),1);
    [val,feature]=min(error);
    
  
    % Rellenamos la estructura strong con los datos del weak correspondiente
    strong(t).err=val;
    strong(t).feature=feature;
    if PRINT_==1
        if(doPrints)
            fprintf(' - Current Weak Error: %.03f\n',strong(t).err);
        end
    end
    strong(t).thr=weak.thr(feature);
    strong(t).p=weak.p(feature);
    beta=strong(t).err/(1-strong(t).err);
    strong(t).beta=beta;
    strong(t).alpha=-log10(beta+eps);
    
    % Recalculamos los pesos
    % para la clase1...buscamos los bien clasificados
    fe= (strong(t).p*clase1(:,feature) < strong(t).p*strong(t).thr);     
    w1=w1.*(beta.^(fe))'; %esta alreves que en el articulo   
    nfe= (strong(t).p*clase2(:,feature) >= strong(t).p*strong(t).thr); 
    w2=w2.*(beta.^(nfe))'; 
    
    cout=StrongEvalROC([clase1;clase2],strong);
    erRATE=sum(cout~=[ones(Nc1,1);zeros(Nc2,1)])/(Nc1+Nc2);
    strong(t).erRATE=erRATE;
    if PRINT_==1
        if(doPrints && mod(t,100) == 0)
%             fprintf('Strong Error Rate: %.04f -\n',strong(t).erRATE);
%         elseif(mod(t,100) == 0)
            fprintf('Strong Error Rate: %.04f -\n',strong(t).erRATE);
%         elseif(t == T)
%             fprintf('Strong Error Rate: %.04f -\n',strong(t).erRATE);
        end
    end
    
    cout=StrongEvalROC([test.c1;test.c2],strong);
    erTEST=sum(cout~=[ones(size(test.c1,1),1);zeros(size(test.c2,1),1)])/(size(test.c1,1)+size(test.c2,1));
    strong(t).erTEST=erTEST;
    if graph==1
        plot([strong.erRATE],'r');hold on;plot([strong.err]);drawnow
    end
    
    if strong(t).err==0.5
        return;
    end
    if strong(t).erRATE<eps
        fprintf('Boosting round %d/%d - ',t, T);
        fprintf('Strong Error Rate: %.04f -\n',strong(t).erRATE);
        return;
    end

end
