function [randOut rest] = randSubsample(dataIn,outSize)
% usage: [randOut rest] = randSubsample(dataIn,outSize)
%
% it makes a random subsample of dataIn, if the size of dataIn is more than
% "outSize", otherwise randOut = dataIn
% it lso returns "rest", i.e., "dataIn - dataOut"

% created: in 2007...
% updated: 27/03/2012

% fciompi@maia.ub.es

outSize = round(outSize);

if(size(dataIn,1)>outSize)
    randIdx = [];
    L = 0;
    while(L<outSize)
        idx = randi(size(dataIn,1),1,outSize-L);
        randIdx = [randIdx idx];
        randIdx = unique(randIdx);
        L = length(randIdx);    
    end
    randOut = dataIn(randIdx,:);
    dataIn(randIdx,:) = [];
    rest = dataIn;    
else
    randOut = dataIn;
end






