%%
%   Divides the set of photos in a folder into smaller groups for being
%   able to process their distances.
function numFolders = dividePhotoGroup()

    global main_path;
    global main_folder;
    global format;
    global doRename;
    global maxSize;
    global ini;
    global fin;

    path = main_path;
    if(doRename)
        folder = [main_folder '_renamed' '_' num2str(ini) 'to' num2str(fin) '_slides'];
    else
        folder = [main_folder '_' num2str(ini) 'to' num2str(fin) '_slides'];
    end
    
    
    slides = load([path '\' folder '\' 'result_slide.mat']);
    slides = slides.result;
    
    fileList = dir([path '\' folder '\*' format]);
    
    numFolders = 1;
    len = length(slides);
    if(maxSize < len)
        for i = 1:maxSize:len
            j = i;
            count = 1;
            result = struct('id_photo', {}, 'id_subphoto', {}, 'w', {}, 'h', {}, 'maxW', {}, 'maxH', {}, 'x', {}, 'y', {}); % new struct for storing the slides info
            folderName = [path '\' folder '-part' num2str(numFolders)];
            mkdir(folderName);
            while(j < (i+maxSize) && j <= len)
                
                result(count) = slides(j);
                copyfile([path '\' folder '\' fileList(j).name], [folderName '\' fileList(j).name],'f');
                delete([path '\' folder '\' fileList(j).name]);
                
                disp(['dividePhotoGroup(): Image ' fileList(j).name ' saved in folder -part' num2str(numFolders)]);
                
                j = j+1;
                count = count+1;
            end
            save([folderName '\' 'result_slide.mat'], 'result');
            numFolders = numFolders + 1;
        end
        disp('dividePhotoGroup(): Done');
    end

    numFolders = numFolders - 1;
end