function extractFeaturesTMP()

global main_path;
    global months;
    global maxDate;
    global havePosition;
    global haveDate;
    global hsize;
    global sigma;
    global filter;

    folders_original = {'Dishes images_renamed_1to100_slides-part1-part1', 'Dishes images_renamed_1to100_slides-part1-part2', 'Dishes images_renamed_1to100_slides-part2-part1', 'Dishes images_renamed_1to100_slides-part2-part2'};
    folders = {'Dishes images_renamed_1to100_slides-part1-part1_89x120', 'Dishes images_renamed_1to100_slides-part1-part2_89x120', 'Dishes images_renamed_1to100_slides-part2-part1_89x120', 'Dishes images_renamed_1to100_slides-part2-part2_89x120'};

    
    
main_path = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY\Videos';
months = {'Jan'; 'Feb'; 'Mar'; 'Apr'; 'May'; 'Jun'; 'Jul'; 'Aug'; 'Sep'; 'Oct'; 'Nov'; 'Dec'};
    % day month year hour minute second
    maxDate = {31; 12; 2030; 23; 59; 59}; % stores the max value for each element in a date-time
    havePosition = true; % indicates if we must include the Position (for cropped photos) in the features set
    haveDate = true; % indicates if we must include the Time or we just use (0 0 0 0 0 0)
    hsize = 6;
    sigma = 3;
    filter = fspecial('gaussian', hsize, sigma);
    
    for i = 1:length(folders)
        folders_original{i} = [main_path '\' folders_original{i}];
        folders{i} = [main_path '\' folders{i}];
    end
    
path = main_path;

    len = length(folders);
    % for each folder with images (each day)
    for i = 1:len
        fileList = dir([folders{i} '/*.jpg']);
        fileList_original = dir([folders_original{i} '/*.jpg']);
        len2 = length(fileList);
        
        % Only for cropped photos
        if(havePosition)
            slides_data = load([folders_original{i} '/result_slide.mat']);
            slides_data = slides_data.result;
        end
        
        F = [];
        % for each image in this folder
        for j = 1:len2
            % we get its features
            if(havePosition)
                F = [F getFeatures([folders{i} '/' fileList(j).name], fileList_original(j).date, slides_data(j))];
            else
                F = [F getFeatures([folders{i} '/' fileList(j).name], fileList_original(j).date, false)];
            end
%             disp(['Folder ' folders{i} ' image ' fileList(j).name ' done: ' num2str(j) '/' num2str(len2)]);
            if(mod(j,100) == 0)
                disp(['extractFeatures(): Folder ' folders{i} ' done: ' num2str(j) '/' num2str(len2)]);
            end
        end
        F = F';
        save([folders{i} '/features.mat'], 'F');
        disp(['extractFeatures(): Features from images in folder ' folders{i} ' saved.']);
    end
    
end


%% Calculates the features for a given image with the specified date
% The format of the features is:
%   6 x Time + 3 x RGB + 81 x HOG + 4 x Position
function features = getFeatures(imgDir, date, slide)

    features = [];
    global main_path;
    global months;
    global maxDate;
    global havePosition;
    global haveDate;
    
    global filter;
    
    path = main_path;
    img = imread([imgDir]);
    
    % we get the desired format for the date
    date = regexp(date,' ','split');
    date = [regexp(date(1),'-','split') regexp(date(2),':','split')];
    found = false;
    i = 1;
    while(~found)
        if(months{i} == date{1}{2})
            found = true;
        end
        i = i+1;
    end
    date{1}(2) = {num2str(i-1)};
    
    
    %% We insert the first set of features, the ones describing the DATE
    % day, month, year, hour, minute, second
    count = 1;
    for i = 1:2
        for j = 1:3
            if(haveDate)
                features = [features; ((str2num(date{i}{j}) / maxDate{count}))];
            else
                features = [features; 0];
            end
            count = count+1;
        end
    end
    
    %% We get the features related to the COLOUR
    % R, G, B
    color = extractFeatureColor(img);
    for i = 1:3
        features = [features; (color(i)/255)];
    end
    
    %% We get the features related to the HOG gradient
    % Gaussian filter
    img = rgb2gray(img);
    img = imfilter(img, filter);
    
    hog81 = HOGparam(img, 3,3,9);
    
    features = vertcat(features, hog81);

    
    %% We get the position data if the photos were cropped
    if(havePosition)
        features = [features; slide.x/slide.maxW];
        features = [features; slide.y/slide.maxH];
        features = [features; slide.w/slide.maxW];
        features = [features; slide.h/slide.maxH];
    end
    
end