function mainPreprocessing()

    global main_path;
    global main_folder;
    global resetCountName;
    global format;
    global doRename;
    global initPer;
    global finPer;
    global jumpPer;
    global diffSlide;
    global ini;
    global fin;
    global maxSize;
    global proportions;
    global months;
    global maxDate;
    global havePosition;
    global haveDate;
    global hsize;
    global sigma;
    global filter;
    
    %% General options
    main_path = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY\Videos';
    main_folder = '0BC25B01-7420-DD20-A1C8-3B2BD6C87CB0';
    format = '.jpg';
    
    %% RenameImages() options
    doRename = false;
    resetCountName = true; % If set to true all the images will be renamed starting by the number 000001.
    
    %% SlidingWindow() options
    initPer = 75;   % Initial percentatge rate of the source fotos
    finPer = 25;    % Final percentatge rate of the source fotos
    jumpPer = 10;   % Difference between the proportions of a set of sliding window photos and the next
    diffSlide = 10;  % Difference (in relative percentatge) between every slide of the same slidingWindow
    % 75, 25, 10, 10 by default
    
    ini = 3;    % initial and final IDs of the photos that will be processed (1 and len by default)
    fin = 62;
    
    %% DividePhotoGroup() options
    maxSize = 4000; % Maximum number of photos in a -partX folder
    
    %% RescaleImagesCropped() options
    proportions = [89 120]; % the final proportions for all the images 
    %resizeRate = 20; % the times we must divide the image's proportions
    
    %% ExtractFeatures() options
    months = {'Jan'; 'Feb'; 'Mar'; 'Apr'; 'May'; 'Jun'; 'Jul'; 'Aug'; 'Sep'; 'Oct'; 'Nov'; 'Dec'};
    % day month year hour minute second
    maxDate = {31; 12; 2030; 23; 59; 59}; % stores the max value for each element in a date-time
    havePosition = true; % indicates if we must include the Position (for cropped photos) in the features set
    haveDate = true; % indicates if we must include the Time or we just use (0 0 0 0 0 0)
    hsize = 6;
    sigma = 3;
    filter = fspecial('gaussian', hsize, sigma);
    
    %% Images Preprocessing
    if(doRename)
        renameImages(); % Renames the images that are stored in 'folder' and saves them to 'folder_renamed'
    else
        
    slidingWindow(); % Creates slides with the given options of the files in 'folder_renamed' and saves them to 'folder_renamed_slides'
    
    numFoldersCreated = dividePhotoGroup(); % Divides all the fotos in the previous folder in -parts with a maximum of 'maxSize' fotos

    rescaleImagesCropped(numFoldersCreated); % Creates a rescaled copy of each image from all the folders

    extractFeatures(numFoldersCreated); % Calculates the features for all the rescaled fotos in all the folders
    
    extractEuclidDist(numFoldersCreated); % Calculates the euclidean distances for all the previously created features
    
    disp(' ');
    disp('PREPROCESSING FINISHED.');
    disp(' ');
end