
% Allows us to visualize how important are the HOG gradients on a single image.
function HOGVisualizationTest()

    %% Initial Parameters
    original_path = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY\Videos\Dishes images_renamed_1to100_slides-part1-part1';
    folder_path = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY\Videos\Dishes images_renamed_1to100_slides-part1-part1_89x120';
    image_name = '003501.jpg';
    HOG = [3 3 9];
    firstHOG = 10;
    lenHOG = HOG(1) * HOG(2) * HOG(3);
    base_angle = 220;
    increment_angle = 360/HOG(3);
    % higlights the most important features
    highlight = true;
    nHighlight = 25;
    
    hsize = 6;
    sigma = 3;
%     hsize = 20;
%     sigma = 5;
    
    
    
    %% Finds the index of our image
    fileList = dir([folder_path '/*.jpg']);
    found = false;
    len = length(fileList);
    i = 1;
    while(i <= len && ~found)
        if(strcmp(fileList(i).name, image_name))
            found = true;
            i = i-1;
        end
        i = i+1;
    end
    
    %% Gets the HOG features of our image
    img_small = rgb2gray(imread([folder_path '/' image_name]));
    
%     img_small2 = img_small;
    G = fspecial('gaussian', hsize, sigma);
    img_small2 = imfilter(img_small, G);

    [features grad_x grad_y] = HOGparam(img_small2, 3, 3, 9);
    features = features';
    
    figure
    subplot(2,3,1), subimage(img_small)
    axis off;
    subplot(2,3,4), subimage(img_small2)
    axis off;
    
    title(['Square Matrix Size = [' num2str(hsize) ' ' num2str(hsize) ']   Sigma = ' num2str(sigma)]);
    
    if(highlight)
        [aux_features, idx] = sort(features, 2, 'descend');
        for i = 1:lenHOG
            if(i <= nHighlight)
                features(idx(i)) = 1;
            else
                features(idx(i)) = 0;
            end
        end
    end

    
    %% Draws the arrows with the corresponding gradients
    img = imread([original_path '/' image_name]);
    scaleX = size(img, 1) / HOG(1);
    scaleY = size(img, 2) / HOG(2);
    
%     figure
%     imshow(uint8(img));
    
    subplot(2,3,[2 3 5 6]), subimage(uint8(img))
    axis off;


    % For each feature
    for j = 1:lenHOG

        id = j;

        % Gets position in quadrant
        p = mod(id, HOG(3));
        if(p == 0)
            pos = HOG(3)-1;
            p = HOG(3);
        else
            pos = p-1;
        end
        % Gets Quadrant
        quad = (id - p) / HOG(3) + 1;
        quad_x = mod(quad, HOG(1));
        if(quad_x == 0)
            quad_x = HOG(1);
        end
        quad_y = ceil(quad / HOG(2));


        rot = mod(base_angle+(pos*increment_angle), 360);
        int = features(j);
        text(scaleY*quad_x - scaleY/2, scaleX*quad_y - scaleX/2,'\rightarrow','rotation', rot, 'color', [0 int 0], 'FontSize', 30);

    end

    
end