function []=HS3(handles)
% function HS3 divides seen clusters in 2 new clusters and calculates the
% probabilities of seeing samples from each cluster


global Z;
global C;
global labels;
global proposed_labels;
global seen_C;
global k;

global activeLearnerType;

C_new=[];
seen_C=unique(seen_C);
unseen_C=setdiff(1:1:length(C),seen_C);

% Picks the already seen_C
for j=1:length(seen_C)
    C_tmp=bound2(C(seen_C(j)), k, C(seen_C(j)).assigned_label); % Processes each of the already seen clusters
    if (length(C_tmp.adminsible_labels)>=1 && length(C_tmp.elements_id)>=2)
        
        if(activeLearnerType == 1) % Hierarchical Cluster Tree
            [C_div] = divide_partition_das2(C(seen_C(j)), labels , k, Z);
        elseif(activeLearnerType == 2 || activeLearnerType == 3) % LDA Tree or LMNN Tree
            [C_div] = divide_partition_das_LDA(C(seen_C(j)), labels, C_new);
        end
        
        C_div = bound2(C_div, k, C_tmp.assigned_label);
        C_new=[C_new C_div];
    else
        C_new=[C_new C(seen_C(j))];
    end
end
%update label propositions
[proposed_labels]=get_proposed_labels(C,proposed_labels, k, handles);

try 
    if(length(unseen_C)>0)
        C_new=[C_new C(unseen_C)];
    end
catch
    disp('error');
end

C= C_new;
clear C_div C_new;

end