% --------------------------------------------------------------------
function LoadVideo_Callback(hObject, eventdata, handles)
% hObject    handle to lButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    global HOBJECT;
    set(HOBJECT, 'HandleVisibility', 'on');
    global video_name;

    global pathName; % path used to load the structure with the input data (test.mat)
    global fileList ; % file name used to load the structure with the input data (test.mat)
    global video_path; % variable with video path
    global numOfImgs; % # of images that are in the directory
    global maxImgs2ShowInCluster ; % # of images that can be shown in cluster box
    global maxImgs2ShowInQuery ; % # of images that can be shown in quiery box
    % variables used in label box 
    global labIndX;
    global labIndY;
    global labels_mat; 
    global labLimit;

    global has_loaded ; % boolean used for checking if images are loaded
    % boolean used for checking if a cluster has already been loaded
    global has_loaded_clusters ; 

    global k;
    global Z; % pre-calculated hierarchical structure (putput of linkage)
    global proposed_labels; % vector with labels proposal (labels being proposed by the algorithm)
    global labels; % groundtruth
    global C; % filed used to keep the structure with all necessery information
    global B; % batch size
    global number_of_clics; % variable with the number of clicks
    global num_clicks_array; % variable with the number of click for each iteration
    num_clicks_array = [];
    global number_of_labeled_frames; % variable with the number of labeled frames

    global colsClusters;
    global rowsClusters;
    global colsQueries;
    global rowsQueries;

    global clicked_queries;
    global clicked_clusters;
    global cluster;
    global queries;

    global heightLabelAxes;
    global widthLabelAxes;

    global heightClicksAxes;
    global widthClicksAxes;
    global pxPerClick;
    global heightNumLabeledAxes;
    global widthNumLabeledAxes;
    global pxPerLabel;

    global fin;

    global imgsFormat;

    global heightImg;
    global widthImg;
    global widthLabel;

    % sets constants
    maxImgs2ShowInCluster = colsClusters*rowsClusters ; % number of images that can be shown in cluster box
    maxImgs2ShowInQuery = colsQueries*rowsQueries; % number of images that can be shown in query box

    global classifierType;
    global activeLearnerType;
    global prototypesType;
    global usingPrototypes;
    global usingVariance;
    global usingOnlineLearner;
    global weights;

    global prototypes;
    global numOfPrototypes;
    numOfPrototypes = 0;

    global simulate;
    global simulationMode;
    global waitTime;
    global simTimer;
    global GT_labels;
    global ready;
    ready = false;

    % asks for the dir
    global folder_path;
    global original_folder;

    has_loaded_clusters = false;
    has_loaded = false;
    
    global video_loaded;
    video_loaded = false;
    
    global start_time;
    

    % Disables the query and cluster buttons
    set(handles.accept_cluster_button,'Enable','off');
    set(handles.accept_queries_button,'Enable','off');
    set(handles.simulateButton,'Enable','off');

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if(strcmp(folder_path, ''))
        fp = uigetdir;
    else
        fp = folder_path;
    end
    
%     set(0, 'CurrentFigure', HOBJECT);
    %%%%%%%%%%%%%%%%%
    % fp = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY\Videos\650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part4_89x120';
    % fp = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY\Videos\650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part5_89x120';
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    video_path = fp;
    if(fp ~= 0)

        folder_path = fp;
        original_folder = getOriginalFolder(folder_path);

        fileList = dir([folder_path '\*' imgsFormat]);

        if(length(fileList) == 0)
            error('Empty folder or images format not set correctly.'); 
        end

        % We set the width of the image depending on its original proportions
        image = imread([folder_path '/' fileList(1).name]);
        rate = size(image,2) / size(image,1);
        widthImg = floor(heightImg * rate);

        % initialize counters
        number_of_clics=0;
        number_of_labeled_frames=0;

        % % Clear the axes images
        cla(handles.cAxes);
        cla(handles.qAxes);


        % initialization of the predefined classes
        loadClasses();
        global classes;
        len = length(classes);
        list = [];
        for i = 1:len
            list = [list;{[classes(i).name '  [ ' classes(i).shortcut ' ]']}];
        end
        set(handles.listClasses, 'String', list);


        % Loads the pre-computed euclid distances (euclidData.mat)
        matFile = dir([folder_path '\euclidData.mat']);
        splitted = regexp(folder_path,'\','split');
        video_name = char(splitted(length(splitted)));

        % number of images
        numOfImgs = length(fileList);


        if(usingPrototypes)

            % Loads the prototypes
            if(prototypesType == 1)
                path_prototypes = '../Prototypes/OnePerClass/prototypes.mat';
            elseif(prototypesType == 2)
                path_prototypes = '../Prototypes/OnePerLeaf/prototypes.mat';
            end
            prototypes = load(path_prototypes);
            prototypes = prototypes.prototypes;

            % Gets the prototypes' features and sample "sizes"
            features = load([folder_path '\features.mat']);
            features = features.F;
            numOfPrototypes = length(prototypes);
            total_samples = numOfImgs;
            for i = 1:numOfPrototypes
                total_samples = total_samples + prototypes(i).num_samples;
                features = [features; prototypes(i).features];
            end

            numOfImgs = numOfImgs + numOfPrototypes;

            % Initializes weights vector
            weights = zeros(numOfImgs,1);
            posProt = (numOfImgs-numOfPrototypes+1):numOfImgs;
            for i = 1:numOfImgs
                if(any(posProt==i))
                    weights(i) = prototypes(find(posProt==i)).num_samples / total_samples;
                else
                    weights(i) = 1 / total_samples;
                end
            end


            % Hierarchical Cluster Tree
            if(activeLearnerType == 1)
                disp('Loading hierarchical tree...');

                % Calculates the euclidian distance between the observations
                y = pdist(features, 'euclidean');

                % Calculates the hierarchical cluster tree
                Z = linkage(y, 'ward');
                clear y;
            end

        else

            % Hierarchical Cluster Tree
            if(activeLearnerType == 1)
                % Looks for the file Z in the current folder, if id doesn't find it then we
                % generate and store it
                try
                    features = load([folder_path '\features.mat']);
                    features = features.F;
                    
                    Z = load(['..\Z_files\' 'Z_' video_name '_' num2str(numOfImgs) '.mat']);
                    Z=Z.Z;
                catch
                    disp(['Z_' video_name '_' num2str(numOfImgs) '.mat' ' not found']);

                    disp('Loading hierarchical tree...');

                    % we get the euclidian distance between the observations
                    features = load([folder_path '\features.mat']);
                    features = features.F;
                    y = pdist(features, 'euclidean');
        %             y = y.data;

                    % Calculates the hierarchical cluster tree
                    Z = linkage(y, 'ward');
                    clear y;

                    save(['..\Z_files\' 'Z_' video_name '_' num2str(numOfImgs) '.mat'], 'Z');
                end
            % LDA or LMNN tree
            elseif(activeLearnerType == 2 || activeLearnerType == 3)
                features = load([folder_path '\features.mat']);
                features = features.F;
            end

        end

        %initialize tree structure one cluster with all elements (function initialize_arbol)
        C=initialize_arbol(1);
        %assign id to cluster
        C.id=size(Z,1)+size(Z,1)+1;
        %assign elements to cluster
        C.elements_id=1:1:numOfImgs;
        C.reliability = zeros(numOfImgs,1);
        C.reliableLabels = zeros(numOfImgs,1);
        C.classificationMethod = zeros(numOfImgs,1);
        C.likelihood = zeros(numOfImgs,1);

        C.features = features;

        %initialize and assign batch size
        %B=21;
        B = rowsQueries*colsQueries;
        % initialize proposed_labels var. All labels to 0;
        proposed_labels=zeros(numOfImgs,1);


        % variables used in label box
        r = widthLabelAxes/heightLabelAxes;
        widthLabel = floor(sqrt( (r*(heightLabelAxes.^2))/numOfImgs ));
        labIndX = floor(widthLabelAxes/widthLabel);
        labIndY = floor(heightLabelAxes/widthLabel);
        %%%
        widthLabelAxes = labIndX * widthLabel;
        heightLabelAxes = labIndY * widthLabel;
        %%%
        labLimit = labIndX * labIndY;
        labels=-1*ones(labLimit,1);

        % Initializes the first cluster info if using prototypes
        if(usingPrototypes)
            posProt = (numOfImgs-numOfPrototypes+1):numOfImgs;
            seen_lbls = [];
            for i = 1:length(posProt)
                proposed_labels(posProt(i)) = str2num(prototypes(i).name)-1;
                labels(posProt(i)) = str2num(prototypes(i).name)-1;
                seen_lbls = [seen_lbls; str2num(prototypes(i).name)];
            end
            C.seen_idx = posProt;
            C.seen_labels = seen_lbls;
        end

        % Does an initial screening to all the photos to try to guess some
        % labels
        initialScreening();

        if(usingVariance || usingOnlineLearner)
            % Shows all the initial cluster with the predictions made by
            % initialScreening()
            cluster_to_show(handles);
            fillClusterBox();
            % Shows Images Cluster in Axes
            showClusterAxes(handles);

            % We reset the initial values of clicked_clusters
            len = length(clicked_clusters);
            for i = 1:len
                clicked_clusters(i) = proposed_labels(cluster(i));
            end
            
            has_loaded_clusters = true;
        else
            % run HS1 -> select samples to be queried.
            HS1(handles);
            % fill the query box with the samples selected by HS1
            fillQueryBox();
            %show the result of fillQueryBox
            showQueryAxes(handles);

            % We reset the initial values of clicked_queries
            len = length(clicked_queries);
            for i = 1:len
                clicked_queries(i) = proposed_labels(queries(i));
            end

            has_loaded = true;
        end


        % Shows labels in labels box
        showLabelAxes(handles);


        % Initializes the clicksAxes
        im = uint8(zeros(heightClicksAxes, widthClicksAxes, 3));
        axes(handles.clicksAxes);
        imshow(im);

        % Initializes the labeledAxes
        im = uint8(zeros(heightNumLabeledAxes, widthNumLabeledAxes, 3));
        axes(handles.labeledAxes);
        imshow(im);

        % Enables the query and cluster buttons
        set(handles.accept_cluster_button,'Enable','on') 
        set(handles.accept_queries_button,'Enable','on') 

        % Clear the counters visualization

        % Clicks counter
        maxClicks = floor(numOfImgs/8);
        div = floor(maxClicks/10);
        str=['0   '];
        for i=1:9
            str = [str num2str(div*i) '   '];
        end 
        str = [str num2str(maxClicks)];
        set(handles.cProgress, 'String', str);
        pxPerClick = widthClicksAxes/maxClicks;

        str=['Clicks: 0'];
        set(handles.clicksText, 'String', str);

        % LabeledFrames counter
        div = floor(numOfImgs/10);
        str=['0   '];
        for i=1:9
            str = [str num2str(div*i) '   '];
        end 
        str = [str num2str(numOfImgs)];
        set(handles.lProgress, 'String', str);
        pxPerLabel = widthNumLabeledAxes/numOfImgs;

        % Sets the already labeled images on the corresponding progress bar
            number_of_labeled_frames = numOfPrototypes;
            finishPx = floor(number_of_labeled_frames*widthNumLabeledAxes/numOfImgs);
            imB = uint8(zeros(heightNumLabeledAxes, widthNumLabeledAxes, 3));
            imG = ones(heightNumLabeledAxes-2, finishPx-2)*255;
            imB(2:heightNumLabeledAxes-1, 2:finishPx-1, 2) = imG;
            cla(handles.labeledAxes);
            % shows in the axes
            set(gcf,'CurrentAxes',handles.labeledAxes);
            imshow(imB);
            axis off;

        changeColor(handles.listClasses);

        fin = false;
        ready = true;

        disp('Finished loading.');

        video_loaded = true;
        
        tic
        
        start_time = clock();

        %% Simulation timer
        try
            labels_result = load(['..\result_files\' video_name '\labels_result_' video_name '.mat'], 'labels_result');
            GT_labels = labels_result.labels_result;
            simTimer = timer('TimerFcn', {@doSimulation,gcf}, 'Period', 0.01, 'BusyMode', 'drop');
            if(simulate)
                start(simTimer);
                if(simulationMode == 2)
                    pause(waitTime);
                end

                while(~fin)
                    start(simTimer);
                    if(simulationMode == 2)
                        pause(waitTime);
                    end
                end
            else
                 set(handles.simulateButton,'Enable','on');
            end
        catch ME
            disp('Simulation aborted: Can not simulate a non previously labeled set.');
        end
        
        
    else % No video selected
        
        
        labelsIm = uint8(zeros(heightLabelAxes, widthLabelAxes, 3));
        axes(handles.lAxes);
        imshow(labelsIm);

        % Initializes the clicksAxes
        im = uint8(zeros(heightClicksAxes, widthClicksAxes, 3));
        axes(handles.clicksAxes);
        imshow(im);

        % Initializes the labeledAxes
        im = uint8(zeros(heightNumLabeledAxes, widthNumLabeledAxes, 3));
        axes(handles.labeledAxes);
        imshow(im);

        % Initializes the qAxes and cAxes
        axes(handles.qAxes);
        axis off;
        axes(handles.cAxes);
        axis off;
        axes(handles.showAxes);
        axis off;

        set(handles.simulateButton,'Enable','off');
        
    end
    

end


% Loads the classes previously created
function loadClasses()
    global classes;
    global classes_path;
    global k;
    
    file = [classes_path '/classesLabeling.mat'];
    if(exist(file, 'file'))
        data = load(file);
        classes = data.classes;
    else % If the file doesn't exist, creates standard classes
        classes(1).name = 'Green';
        classes(1).id = 1;
        % GREEN
        classes(1).rgb(1) = 51;
        classes(1).rgb(2) = 255;
        classes(1).rgb(3) = 51;
        classes(1).shortcut = 'G';

        classes(2).name = 'Red';
        classes(2).id = 2;
        % RED
        classes(2).rgb(1) = 204;
        classes(2).rgb(2) = 51;
        classes(2).rgb(3) = 0;
        classes(2).shortcut = 'R';
        
        saveClasses();
    end
    k = length(classes);
    loadRemoveClasses();
end


% Loads the classes that we won't consider in the algorythm
function loadRemoveClasses()
    global classes;
    global remove_classes;
    len = length(classes);
    lenR = 0;
    for i = 1:len
        if(strcmp(classes(i).name, 'Remove'))
            remove_classes(lenR+1).name = classes(i).name;
            remove_classes(lenR+1).id = classes(i).id;
            remove_classes(lenR+1).rgb = classes(i).rgb;
            remove_classes(lenR+1).shortcut = classes(i).shortcut;
            lenR = lenR+1;
        end
    end
end
    
% Returns the original images' folder depending on the "f" selected folder    
function original_folder = getOriginalFolder(f)
    folder = regexp(f, '\', 'split');
    original_folder = folder(length(folder));
    len_erase = length(original_folder{1});
    folder = regexp(original_folder{1}, '_', 'split');
    first_part = f(1:(length(f)-len_erase));
    len_last_part = length(folder{length(folder)});
    
    original_folder = [first_part original_folder{1}(1:(length(original_folder{1})-len_last_part-1))];
end
    
% Saves the classes stablished by now
function saveClasses()
    global classes;
    global classes_path;
    save([classes_path '/classesLabeling.mat'], 'classes');
end