function [area_blob_NEW, last_blob, distance]=qva_create_area_blob_NEW(image_gray, last_blob, distance)
%qva_create_area_blob_NEW Calculates the blob area
%
% INPUT:
%   image_gray   -> gray image
%   last_blob ->    blob image
%   distance -> distance in frames from last detected blob
%
% OUTPUT:
%   area_blob_NEW     -> blob area
%   last_blob         -> blob image
%   distance          -> distance in frames from last detected blob

%
%  Ex: 
%   [study, jpeg_info] = qva_create_all(study,gfhFile,gfdFile);
%   
% (c) MI group, Computer Vision Center, UAB, 2010
%

if isempty(last_blob)
    last_blob=logical(zeros(256));
    distance=1;
end

% calculate blob size
[area_blob_NEW, last_blob, distance, blob] = calculate_blob_from_im(image_gray, last_blob, distance);
% rescaling to comapare with old results:
area_blob_NEW      = floor(area_blob_NEW / 16);
end