function matrh=qva_create_coocurrence_textural_features_mat1(cell,w,dim)
%qva_create_coocurrence_textural_features_mat1 Calculates h-cooc.features.
%
% INPUT:
%   cell   -> The data.
%   w -> The 16 gray levels.
%   dime -> The length of the w vector.
%
% OUTPUT:
%   matrh -> The horizontal coocurrence matrix. 
%
%  Ex: 
%   matrh=qva_create_coocurrence_textural_features_mat1(cell,w,dim);
%   
% (c) MI group, Computer Vision Center, UAB, 2007
%

f=size(cell);
matrh=zeros(dim,dim);
for l=1:dim
    for k=1:dim
        w(l);
        w(k);
        x=0;
        for i=1:f(1,1)
            for j=1:f(1,2)-1
                if cell(i,j)==w(l)
                    if cell(i,j+1)==w(k)
                        x=x+1;
                    end;
                end;
                if cell(i,j)==w(k)
                    if cell(i,j+1)==w(l)
                        x=x+1;
                    end;
                end;
            end
        end
        matrh(l,k)=x;
    end
end
