function matrix_v=qva_create_coocurrence_textural_features_mat2(cell,w,dim)
%qva_create_coocurrence_textural_features_mat2 Calculates v-cooc.features.
%
% INPUT:
%   cell   -> The data.
%   w -> The 16 gray levels.
%   dime -> The length of the w vector.
%
% OUTPUT:
%   matrh -> The vertical coocurrence matrix. 
%
%  Ex: 
%   matrix_v=qva_create_coocurrence_textural_features_mat2(cell,w,dim)
%   
% (c) MI group, Computer Vision Center, UAB, 2007
%
f=size(cell);
matrix_v=zeros(dim,dim);
for l=1:dim
    for k=1:dim
        w(l);
        w(k);
        y=0;
        for i=1:f(1,1)-1
            for j=1:f(1,2)
                if cell(i+1,j)==w(l)
                    if cell(i,j)==w(k)
                        y=y+1;
                    end;
                end;
                if cell(i+1,j)==w(k)
                    if cell(i,j)==w(l)
                        y=y+1;
                    end;
                end;
            end
        end
        matrix_v(l,k)=y;
    end
end

