function matrix_ld=qva_create_coocurrence_textural_features_mat3(cell,w,dim)
%qva_create_coocurrence_textural_features_mat3 Calculates ld-cooc.features.
%
% INPUT:
%   cell   -> The data.
%   w -> The 16 gray levels.
%   dime -> The length of the w vector.
%
% OUTPUT:
%   matrh -> The left diagonal coocurrence matrix. 
%
%  Ex: 
%    matrix_ld=qva_create_coocurrence_textural_features_mat3(cell,w,dim);
%   
% (c) MI group, Computer Vision Center, UAB, 2007
%
f=size(cell);
matrix_ld=zeros(dim,dim);
for l=1:dim
    for k=1:dim		
        w(l);
        w(k);
        z=0;
        for i=1:f(1,1)-1
            for j=1:f(1,2)-1
                if cell(i,j)==w(l)
                    if cell(i+1,j+1)==w(k)
                        z=z+1;
                    end;
                end;
                if cell(i,j)==w(k)
                    if cell(i+1,j+1)==w(l)
                        z=z+1;
                    end;
                end;
            end
        end
        matrix_ld(l,k)=z;
    end
end
