function matrix_rd=qva_create_coocurrence_textural_features_mat4(cell,w,dim)
%qva_create_coocurrence_textural_features_mat4 Calculates rd-cooc. features.
%
% INPUT:
%   cell   -> The data.
%   w -> The 16 gray levels.
%   dime -> The length of the w vector.
%
% OUTPUT:
%   matrh -> The right diagonal coocurrence matrix. 
%
%  Ex: 
%    matrix_rd=qva_create_coocurrence_textural_features_mat4(cell,w,dim);
%   
% (c) MI group, Computer Vision Center, UAB, 2007
%
f=size(cell);
matrix_rd=zeros(dim,dim);
for l=1:dim  
    for k=1:dim
        w(l);
        w(k);
        v=0;
        for i=1:f(1,1)-1
            for j=1:f(1,2)-1
                if cell(i+1,j)==w(l)
                    if cell(i,j+1)==w(k)
                        v=v+1;
                    end;
                end;
                if cell(i+1,j)==w(k)
                    if cell(i,j+1)==w(l)
                        v=v+1;
                    end;
                end;
            end
        end
        matrix_rd(l,k)=v;
    end
end


