function [inertia, lochomo] = qva_create_textural_features_NEW(image_gray)
%qva_create_vol_blob_x_lap_NEW calculates vol in the laplacian
%
% INPUT:
%   image_gray   -> gray image 

%
% OUTPUT:
%   inertia     
%   lochomo         
%
%  Ex: 
%   [inertia, lochomo] = qva_create_textural_features_NEW(image_gray)
%   
% (c) MI group, Computer Vision Center, UAB, 2010
%

mask = qva_get_textural_mask(64, 64);
b=imresize(image_gray,[64 64]);

% calculates the coocurrence matrix-based features.
[inertia,lochomo] =  qva_create_coocurrence_textural_features_NEW(b,mask);


end