function qva_create_turbid_features(study, jpg_info)
%qva_create_turbid_features  Creates the color fetures for turbid analysis.
%
% INPUT:
%   study -> The study structure.
%   jpg_info -> The jpg_info structure.
%
% OUTPUT:
%
% This function calls the turbid_tool functions that handle 
% the color features for turbid detection. 
%
%  Ex: 
% qva_create_turbid_features(study, jpg_info);
%   
% (c) MI group, Computer Vision Center, UAB, 2007
%



% Load the centroids of the IntesColorSpace ( CX ) . 
load('IntesColorSpace');

turbid_tool_createHistogramsTurbid(study,jpg_info,CX);


