function [vol_blob_x_lap_NEW, minvol_NEW] = qva_create_vol_blob_x_lap_NEW(lap, lap_blob_unico)
%qva_create_vol_blob_x_lap_NEW calculates vol in the laplacian
%
% INPUT:
%   lap   -> laplacian 
%   lap_blob_unico ->    blob image

%
% OUTPUT:
%   vol_blob_x_lap_NEW     
%   minvol_NEW         
%
%  Ex: 
%   [vol_blob_x_lap_NEW, minvol_NEW] = qva_create_vol_blob_x_lap_NEW(lap,
%   lap_blob_unico)
%   
% (c) MI group, Computer Vision Center, UAB, 2010
%


vol= -lap .* lap_blob_unico;  
vol_blob_x_lap_NEW = sum(vol(:)); 
minvol_NEW  = min(min(vol)); 


end