function res_jpg_info_color = qva_get_jpg_info_color(study, jpg_info);

% qva_get_jpg_info_color checks for the existence of a color field in jpeg_info, 
%  and if not found, it reads the jpg_info_jaby_mean_opo matrix from disk.
%


if isfield(jpg_info, 'color')
  res_jpg_info_color = cell2mat([{jpg_info(:).color}']);
  return;
end

current_dir = pwd;
qva_path = study_jpg_info_path(study);
if ~exist(qva_path)
  res_jpg_info_color = [];
  return;
end

[p, n, e, v] = fileparts(qva_path);

load([p '/jpg_info_jaby_mean_opo']);

if ~exist('jpg_info_color') 
    res_jpg_info_color = [];
    return
end

res_jpg_info_color = jpg_info_color;