function mask = qva_get_mask(resx, resy, size)
% \param resx the horizontal resolution of the mask
% \param resy the vertical resolution of the mask
current_dir = pwd;
p = qva_module_path;
cd(p);
m = imread('qva_mask.png');
mask = imresize(m, [resx resy], 'bicubic');
cd(current_dir);
return

% alternative version without the need of a special mask file:
% \param size the extent of the mask, \elem 0..1
% \return a circular mask of given resolution
%
% x^2/a^2+y^2/b^2 = size
% a = w/2
% b = h/2
%if ~exist('size')
%    size = 1;
%end
%[mx, my] = meshgrid(1:resx, 1:resy);
%cx = resx/2-0.5;
%cy = resy/2-0.5;
%mx = mx-cx-1;
%my = my-cy-1;
%mx = mx./cx;
%my = my./cy;
%
%m = mx.*mx+my.*my;
%mask = m<size;
