function features = qva_get_static_features(study)
%qva_get_static_features returns the EMD features .
%
% INPUT:
%   study   -> The study struture.
%
% OUTPUT:
%   features   -> The static features.
%
% This function reads the file 
% EMD.mat where the turbid features are stored and returns 
% the features as an array.
%
%  Ex: 
% features = qva_get_static_features(study);
%   
% (c) MI group, Computer Vision Center, UAB, 2007
%


s=sprintf('%s/%s/EMD.mat',study.data_path,study.name);
data=load(s);
features=data.emd_distance;