function features = qva_get_turbid_features(study)
%qva_get_turbid_features Gets the turbid features frame.
%
% INPUT:
%   study   -> The study struture.
%
% OUTPUT:
%   features   -> The turbid features.
%
%  This function reads the file 
% histColorsRGBquantitzed.mat where the turbid features ares stored and returns 
% the features as an array.
%
%  Ex: 
%  features = qva_get_turbid_features(study);
%   
% (c) MI group, Computer Vision Center, UAB, 2007
%

s=sprintf('%s/%s/histColorsRGBquantitzed.mat',study.data_path,study.name);
data=load(s);
features=data.features;



