function result = qva_is_static_features(study)
%qva_is_static_features Checks whether the static features are already done.
%
% INPUT:
%   study  -> The study structure.
%
% OUTPUT:
%   result  -> 1 if the static features are already calculated.
%
% This function checkst the existence of the file
% EMD.mat
%
%  Ex: 
%   result = qva_is_static_features(study)
%   
% (c) MI group, Computer Vision Center, UAB, 2007
%

s=sprintf('%s/%s/EMD.mat',study.data_path,study.name);

if  exist(s,'file')~=0
  result = 1;
else 
  result = 0;
end
