function jpeg_info = qva_load(study)
%qva_load Loads the jpg_info structure.
%
% INPUT:
%   study   -> The study struture.
%
% OUTPUT:
%   jpeg_info -> The jpeg_info struture.
%
%  Ex: 
%   jpeg_info = qva_load(study);
%   
% (c) MI group, Computer Vision Center, UAB, 2007
%

current_dir = pwd;
qva_path = study_jpg_info_path(study);
if ~exist(qva_path)
  jpeg_info = [];
  return;
end

j = load(qva_path);
if ~isfield(j, 'jpg_info') 
    jpeg_info = [];
    return
end

jpeg_info = j.jpg_info;