function result = study_get_filepath(study)
% STUDY_GET_FILE_PATH creates a unique filepath for the study.
%
%   INPUT:
%       study -> The study structure. 
%
%   OUTPUT:
%       result -> The study filepath; '' if no argument is provided.
%
% This function creates a unique filepath for the study from the name and path of the
% study.
%
% Example:
%           data_path = study_get_data_path(study)
%  


if nargin<1
    result = '';
    return;
end

study_path = study_get_study_path(study);
result = [study_path '/' study_get_name(study) '.study'];