function [startidx,endidx] = study_get_limits(study)
% STUDY_GET_LIMITS returns the starting and ending frame indexes.
%
%   INPUT:
%       study -> The study structure. 
%
%   OUTPUT:
%       startidx -> The first frame index of the study.
%       endidx   -> The last frame index of the study.
%
%  Example:
%      [ub1, ub2] = study_get_limits(study); 
%
% (c) MI group, Computer Vision Center, UAB, 2007
%
startidx = study.thresholds(1);
endidx = study.thresholds(2);
