function limits = study_get_time_limits(study)
% STUDY_GET_LIMITS returns the time thresholds for study evaluation.
%
%   INPUT:
%       study -> The study structure. 
%
%   OUTPUT:
%       limits -> A 1x2 cell array of strings containing the time limits of
%                 the study.
%
%  Example:
%      limits = study_get_time_limits(study)
%      >> limits = 
%      >>           {'00.01.10', {'04.00.01'}}
%      >>
%

limits = study.time_thresholds;
