function [result, study,jpeg_info] = study_jpg_2_mat(study,jpeg_info)
% study_jpg_2_mat converts the given jpgs in the jpgs folder to mat images in blocks of 100 .
%

if study_assert(study) == 0 
  result = 0;
  return
end

jpg_dir = study_jpg_path(study);

rename_marker = sprintf('%s/converted_ok.txt', jpg_dir);

% check whether files have been renamed already
if exist(rename_marker) == 2 
  fprintf('\t\t MAT files already converted\n');
  result = 1;
  return
end

log_file = 'converted.log'; 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 4) Renaming files. Le ponemos un formato para que el ID_ tenga
%    6 cifras ID_000000->ID_999999
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
current_dir = pwd;
cd(jpg_dir);       % ya estamos en el directorio de los ficheros .jpg
files2     = dir('*.bmp');
num_frames = study.thresholds(2)-study.thresholds(1)+1;
if num_frames == 0 
  result = 0;
  cd(current_dir);
  return
end


% images are stored in mat format
for i = study.thresholds(1):study.thresholds(2)
    numFrame=str2num(jpeg_info(i).filename(1:7));
    str_read=sprintf('%.6d.bmp',numFrame);
    str_jpeg=sprintf('%.6d',numFrame);
    str_write=sprintf('%.6d.mat',numFrame);
    jpeg_info(i).filename=str_jpeg;
    image=imread(str_read);   

    save(str_write,'image');
end

% once all images are stored as mat file, bmp images are removed
dos('del *.bmp')

% we create a file wich indicates that renaming and conversion task
% finished properly
fid = fopen('converted_ok.txt', 'w');
fprintf(fid, 'all jpegs converted.');
fclose(fid);

cd(current_dir)

result = 1;
