function [study jpeg_info] = study_jpg_reverseALC_optical_correction(study,jpeg_info,gfh_file,gfd_file)
% STUDY_JPG_REVERSEALC rewrite jpeg images with reversing the ALC
%
%   INPUT:
%       study             -> The study structure.
%       jpeg_info         -> The jpeg_file strucure.
%       gfh_file          -> The location of the gfh_file.
%       gtd_file          -> The location of the gtd_file.
%   OUTPUT:
%       result -> '' if the paremeters are not correct; 1 if the video was succesfuly
%                 expanded.
%   Examples:
%     study_jpg_reverseALC(study)
%


if study_assert(study) == 0
    result = 0;
    return
end

jpg_path = study_jpg_path(study);

if exist([jpg_path '\reverseALC_ok.txt']) ~= 2


    % [pathstr, gtd_file_name, ext, versn] = fileparts(gtd_file);
    % if strcmp(study.name,gtd_file_name) ~= 1
    %     disp(['Study "' study.name '" must have the same name as the GTD file name "' gtd_file_name '".']);
    %     result = 0;
    %     return;
    % end
    %

    % %%GET CAPSULE INFO

    GFH=read_ALC(gfh_file);
    GFD1=read_motility_gfd(gfd_file);
    [ColMat1 ColMat2 CapsuleType CapsuleConfig] =read_gfhParameters(gfh_file);
    
    mask = imread('mask_lens.png');
    optical_correction_lookup_table = optical_correction_load_lookup_table();

    for index=1:size(jpeg_info,2)
        image=qva_get_frame_illumination_correction_SB2(study, jpeg_info, index,GFD1,GFH,ColMat1,CapsuleType,CapsuleConfig);
        %[image, SB2_mag_final] = optical_correction(image, optical_correction_lookup_table, mask);
        
        [image, SB2_mag_final] = optical_correction_2(image, optical_correction_lookup_table, mask);
        


        impath = sprintf('%s/%s', jpg_path, jpeg_info(index).filename );

        %     %%WITH MASK
        %
        %     mask = imread('mask_lens.png');
        %     maskF=[];
        %     maskF(:,:,1)=mask;
        %     maskF(:,:,2)=mask;
        %     maskF(:,:,3)=mask;
        %     maskF=uint8(maskF);
        %     image=image-maskF;
        %
        %     %% END PUT MASK



        imwrite(image,impath,'jpeg');

        % calculamos el volumen
        b = rgb2gray(image);
        volumen = sum(b(:));
        jpeg_info(index).vol = volumen;

    end

    fid = fopen([jpg_path '\reverseALC_ok.txt'], 'w');
    fprintf(fid, 'Reverse ALC Ok.');
    fclose(fid);

    result = 1;
    fprintf('\t\t VIDEO completely rewritted\n')
end