function result = study_save(study)
%study_save Saves the study structure to disk.
%
% INPUT:
%   study             -> The study structure.
%
% OUTPUT:
%   result             -> 1 if OK.
%
% The study structure is saved in the path stored in the field
% study.study_data_path.
%
%  Ex: 
% result = study_save(study);
%   
% (c) MI group, Computer Vision Center, UAB, 2007
%

if nargin<1
    result = 0;
    return;
end

study_path = study_get_filepath(study);

save(study_path, 'study');
result = 1;