function study_res = study_set_limits(study, istart, iend)
%study_set_limits Set the indexes bounding the usefull part of the study.
%
% INPUT:
%   study             -> The study structure.
%   istart -> The index of the first frame.
%   iend -> The index of the last frame.
%
% OUTPUT:
%   study_res  -> 1 if OK.
%
%  Ex: 
%   study_res = study_set_limits(study, istart, iend);
%   
% (c) MI group, Computer Vision Center, UAB, 2007
%
  
study_res = study;
study_res.thresholds(1) = istart;
study_res.thresholds(2) = iend;

if istart>=iend 
    study_res = [];
end