% --- Executes on button press on accept_cluster_button.
function accept_cluster_button_Callback(hObject, eventdata, handles)
% hObject    handle to accept_cluster_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global maxImgs2ShowInCluster ;
global labels ;
global proposed_labels ;
global queries;
global cluster ;
global seen_cluster;
global number_of_clics;
global num_clicks_array;
global clicked_queries;
global clicked_clusters;
global number_of_labeled_frames;
global C;
global heightClicksAxes;
global widthClicksAxes;
global pxPerClick;
global heightNumLabeledAxes;
global widthNumLabeledAxes;
global pxPerLabel;

global colsClusters;
global rowsClusters;
global colsQueries;
global rowsQueries;

global usingVariance;
global usingOnlineLearner;

global has_loaded;
global has_loaded_clusters;
global fin;
global ready;

ready = false;

if has_loaded_clusters
	showClusterAxes(handles);

    finishPx = ceil(pxPerClick*number_of_clics);
    imB = uint8(zeros(heightClicksAxes, widthClicksAxes, 3));
    imG = ones(heightClicksAxes-2, finishPx-2)*255;
    imB(2:heightClicksAxes-1, 2:finishPx-1, 2) = imG;
    cla(handles.clicksAxes);
    % shows in the axes
    set(gcf,'CurrentAxes',handles.clicksAxes);
    imshow(imB);
    axis off;

    % We count the number of labels changed
    len = length(clicked_clusters);
    num_clicks_array = [num_clicks_array 0];
    for i = 1:len
        if(i <= length(cluster) && clicked_clusters(i) ~= proposed_labels(cluster(i)))
            number_of_clics = number_of_clics+1;
            num_clicks_array(length(num_clicks_array)) = num_clicks_array(length(num_clicks_array))+1;
        end
    end
    str=['Clicks: ' num2str(number_of_clics)];
    set(handles.clicksText, 'String', str);
    
    if ~isempty(cluster)
        labels(cluster(1:min(maxImgs2ShowInCluster, length(cluster)))) = proposed_labels(cluster(1:min(maxImgs2ShowInCluster, length(cluster))))  ;
        showLabelAxes(handles);
        xxx=cluster(1:min(maxImgs2ShowInCluster, length(cluster)));
        try
            C(seen_cluster).cluster_seen=C(seen_cluster).cluster_seen+length(xxx); %update n
        catch ME
            save('error_Accept_Cluster_Button_Callback.mat');
            %disp('error3');
            fin = true;
            set(handles.accept_cluster_button,'Enable','off');
            set(handles.accept_queries_button,'Enable','off');
            has_loaded = false;
            has_loaded_clusters = false;
        end
        C(seen_cluster).seen_idx=[C(seen_cluster).seen_idx (xxx)];
        C(seen_cluster).seen_labels=[C(seen_cluster).seen_labels; labels((xxx))+1];
        cluster(1:min(maxImgs2ShowInCluster, length(cluster))) = [];
        fillClusterBox();
        showClusterAxes(handles);
        
        % Checks if there is any unvalidated preclassified sample in the
        % chosen cluster
        if((usingVariance || usingOnlineLearner) && ~has_loaded)
            has_loaded = checkAllValidated(C(seen_cluster));
        end
        
        
        % It only shows the queries if all the previously guessed labels
        % have been validated.
        if(has_loaded)
            HS1(handles);        
            fillQueryBox();
            showQueryAxes(handles);
            
%             % We reset the initial values of clicked_queries
%             len = length(clicked_queries);
%             for i = 1:len
%                 clicked_queries(i) = proposed_labels(queries(i));
%             end
        end
        
        if isempty(cluster)
            cluster_to_show(handles);
            fillClusterBox();
            showClusterAxes(handles);
        end
        
        % Shows the labeled frames
        number_of_labeled_frames=length(xxx)+number_of_labeled_frames;
        
        finishPx = ceil(pxPerLabel*number_of_labeled_frames);
        imB = uint8(zeros(heightNumLabeledAxes, widthNumLabeledAxes, 3));
        imG = ones(heightNumLabeledAxes-2, finishPx-2)*255;
        imB(2:heightNumLabeledAxes-1, 2:finishPx-1, 2) = imG;
        cla(handles.labeledAxes);
        % shows in the axes
        set(gcf,'CurrentAxes',handles.labeledAxes);
        imshow(imB);
        axis off;
        
        
        % We reset the initial values of clicked_queries and clicked_clusters
        if(has_loaded)
            len = length(clicked_queries);
            len2 = length(queries);
            i = 1;
            while(i <= len && i <= len2)
                clicked_queries(i) = proposed_labels(queries(i));
                i=i+1;
            end
        end
        len = length(clicked_clusters);
        len2 = length(cluster);
        i = 1;
        while(i <= len && i <= len2)
            clicked_clusters(i) = proposed_labels(cluster(i));
            i=i+1;
        end
        %%%
        
        
        if fin
%             storeResults();
            run finished
        end
        
    end
    
end

ready = true;

