% --- Executes on button press on accept_queries_button.
function accept_queries_button_Callback(hObject, eventdata, handles)
% hObject    handle to accept_queries_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global labels ;
global proposed_labels ;
global queries ;
global cluster;
global number_of_clics;
global num_clicks_array;
global clicked_queries;
global clicked_clusters;
global number_of_labeled_frames;
global heightClicksAxes;
global widthClicksAxes;
global pxPerClick;
global heightNumLabeledAxes;
global widthNumLabeledAxes;
global pxPerLabel;
global numOfImgs;

global colsClusters;
global rowsClusters;
global colsQueries;
global rowsQueries;

global has_loaded;
global has_loaded_clusters;
global fin;
global ready;

ready = false;

if has_loaded
    showQueryAxes(handles);
    
    %% Repaints progress bars
    finishPx = ceil(pxPerClick*number_of_clics);
    %show progress bar
    imB = uint8(zeros(heightClicksAxes, widthClicksAxes, 3));
    imG = ones(heightClicksAxes-2, finishPx-2)*255;
    imB(2:heightClicksAxes-1, 2:finishPx-1, 2) = imG;
    cla(handles.clicksAxes);
    % shows in the axes
    set(gcf,'CurrentAxes',handles.clicksAxes);
    imshow(imB);
    axis off;


    % We count the number of labels changed
    len = length(clicked_queries);
    num_clicks_array = [num_clicks_array 0];
    for i = 1:len
        if(i <= length(queries) && clicked_queries(i) ~= proposed_labels(queries(i)))
            number_of_clics = number_of_clics+1;
            num_clicks_array(length(num_clicks_array)) = num_clicks_array(length(num_clicks_array))+1;
        end
    end
    str=['Clicks: ' num2str(number_of_clics)];
    set(handles.clicksText, 'String', str);
    
    
    %% Calculates and shows cluster labels
    try
        if ~isempty(queries)
            labels(queries(1:end)) = proposed_labels(queries(1:end)) ;
            showLabelAxes(handles);
            HS2(handles);
            HS3(handles);
            cluster_to_show(handles);
            fillClusterBox();
            % Shows Images Cluster in Axes
            showClusterAxes(handles);
            has_loaded_clusters = true;
        end
    catch ME
        fin = true;
        set(handles.accept_cluster_button,'Enable','off');
        set(handles.accept_queries_button,'Enable','off');
        has_loaded = false;
        has_loaded_clusters = false;
    end
        
    number_of_labeled_frames=length(queries)+number_of_labeled_frames;
    
    %% Shows lables in labeledAxes
%     finishPx = ceil(pxPerLabel*number_of_labeled_frames);
    finishPx = floor(number_of_labeled_frames*widthNumLabeledAxes/numOfImgs);
    imB = uint8(zeros(heightNumLabeledAxes, widthNumLabeledAxes, 3));
    imG = ones(heightNumLabeledAxes-2, finishPx-2)*255;
    imB(2:heightNumLabeledAxes-1, 2:finishPx-1, 2) = imG;
    cla(handles.labeledAxes);
    % shows in the axes
    set(gcf,'CurrentAxes',handles.labeledAxes);
    imshow(imB);
    axis off;
    
    
    %% Chooses and refills the query box
    HS1(handles);
    fillQueryBox();
    showQueryAxes(handles);
    
    
    %% Resets the initial values of clicked_queries and clicked_clusters
    len = length(clicked_queries);
    len2 = length(queries);
    i = 1;
    while(i <= len && i <= len2)
        clicked_queries(i) = proposed_labels(queries(i));
        i=i+1;
    end
    if(has_loaded_clusters)
        len = length(clicked_clusters);
        len2 = length(cluster);
        i = 1;
        while(i <= len && i <= len2)
            clicked_clusters(i) = proposed_labels(cluster(i));
            i=i+1;
        end
    end
    %%%
    

    if fin
        run finished
    end
    
end

ready = true;

