%%
%   Checks if all the loaded photos are over or below a given
%   threshold_variance. If they are below it means that we are quite sure
%   that it won't be a plate.
function checkVariance()
       
    global folder_path;
    global fileList;
    global numOfImgs;
    global numOfPrototypes;
    global threshold_var;
    global proposed_labels;
    global classNoPlate;
    global C;
    global classes;
    global usingPrototypes;
    
    global idVariance;
    
    % Delete this line
%     varianceVec = zeros(numOfImgs, 3);

    % If we are using prototypes
    if(usingPrototypes)
        num = numOfImgs - numOfPrototypes;
    else
        num = numOfImgs;
    end
        
    for i = 1:num
        
        im = imread([folder_path '/' fileList(i).name]);
        
        for ch = 1:3
           M(ch) = mean(reshape(im(:,:,ch),[],1));
           V(ch) = var(double(reshape(im(:,:,ch),[],1)));
        end
        
        if( (sum(V) / length(V)) < threshold_var )
            proposed_labels(i) = classNoPlate.id-1;
            C.reliability(i) = 1;
            C.reliableLabels(i) = classNoPlate.id-1;
            C.classificationMethod(i) = idVariance;
        end

%         varianceVec(i,:) = V(:);
        
        if(mod(i,100) == 0)
           disp(['Variance check ' num2str(i) '/' num2str(num) ' done.']);
        end
        
    end

    disp('Variance check finished.');
    
end