
function AdaBoost_CombinedClassifier(F, labels_cell, classifier1, classifier2, testImgs, lenClasses)

    global C;
    global proposed_labels;
    
    global th_No_Plate;
	global th_Plate_Semiplate;
    global th_Plate;
    global th_Semiplate;
    global classNoPlate;
    global classPlate;
    global classSemiplate;
    
    global idOnlineLearner;
    
    global countPredicted;

    %% [ NP vs P+SP ] test
    [tests likelihood] = testBOOST(F, labels_cell, classifier1);

    % Calculates the resulting label for each image
    nextTest = [];
    for i = 1:size(likelihood,1)
        results = zeros(2,1);
        if(likelihood(i,1) > 0) % ClassNP vs ClassP+SP
            results(1) = results(1) + likelihood(i,1);
        else
            results(2) = results(2) + abs(likelihood(i,1));
        end

        % Gets the maximum value (c) and label (j)
        [c, j] = max(results);

        % Stores the result
        if(j == classNoPlate.id && c >= th_No_Plate) % No Plate
            proposed_labels(testImgs(i)) = classNoPlate.id-1;
            C.reliability(testImgs(i)) = 0.5;
            C.reliableLabels(testImgs(i)) = classNoPlate.id-1;
            C.classificationMethod(testImgs(i)) = idOnlineLearner;
            C.likelihood(testImgs(i)) = c;
            countPredicted{classNoPlate.id} = countPredicted{classNoPlate.id} + 1;
        elseif(j == 2 && c >= th_Plate_Semiplate) % Plate + Semiplate
            nextTest = [nextTest; testImgs(i)];
        end

    end
    
    %% [ P vs SP ] test
    features = F;
    
    % We get the features of the images that we have to classify
    F = zeros(length(nextTest), size(features, 2));
    for i = 1:length(nextTest)
        F(i,:) = features(nextTest(i),:);
    end
    
    % The classification starts
    [tests likelihood] = testBOOST(F, labels_cell, classifier2);
    
    for i = 1:size(likelihood,1)
        results = zeros(2,1);
        if(likelihood(i,1) > 0) % ClassP vs ClassSP
            results(1) = results(1) + likelihood(i,1);
        else
            results(2) = results(2) + abs(likelihood(i,1));
        end

        % Gets the maximum value (c) and label (j)
        [c, j] = max(results);

        % Stores the result
        if(j == classPlate.id-1 && c >= th_Plate) % Plate
            proposed_labels(nextTest(i)) = classPlate.id-1;
            C.reliability(nextTest(i)) = 0.5;
            C.reliableLabels(nextTest(i)) = classPlate.id-1;
            C.classificationMethod(nextTest(i)) = idOnlineLearner;
            C.likelihood(nextTest(i)) = c;
            countPredicted{classPlate.id} = countPredicted{classPlate.id} + 1;
        elseif(j == classSemiplate.id-1 && c >= th_Semiplate) % Semiplate
            proposed_labels(nextTest(i)) = classSemiplate.id-1;
            C.reliability(nextTest(i)) = 0.5;
            C.reliableLabels(nextTest(i)) = classSemiplate.id-1;
            C.classificationMethod(nextTest(i)) = idOnlineLearner;
            C.likelihood(nextTest(i)) = c;
            countPredicted{classSemiplate.id} = countPredicted{classSemiplate.id} + 1;
        end
        % if c < threshold we don't label that image

    end

end