
function KNN_CombinedClassifier(F, classifier1, classifier2, testImgs)

    global C;
    global proposed_labels;
    
    global th_No_Plate;
	global th_Plate_Semiplate;
    global th_Plate;
    global th_Semiplate;
    global classNoPlate;
    global classPlate;
    global classSemiplate;
    
    global idOnlineLearner;
    
    global countPredicted;

    %% [ NP vs P+SP ] test
    [labels likelihood] = predict(classifier1,F);

    % Calculates the resulting label for each image
    nextTest = []; % absolute positions in C from the elements in "F" list
    nextRelative = []; % relative positions in "F" list
    for i = 1:length(labels)

        j = labels(i);
        % Stores the result
        if(j == classNoPlate.id && max(likelihood(i, :)) >= th_No_Plate) % No Plate
            proposed_labels(testImgs(i)) = classNoPlate.id-1;
            C.reliability(testImgs(i)) = 0.5;
            C.reliableLabels(testImgs(i)) = classNoPlate.id-1;
            C.classificationMethod(testImgs(i)) = idOnlineLearner;
            C.likelihood(testImgs(i)) = max(likelihood(i, :));
            countPredicted{classNoPlate.id} = countPredicted{classNoPlate.id} + 1;
        elseif(j == 2 && max(likelihood(i, :)) >= th_Plate_Semiplate) % Plate + Semiplate
            nextTest = [nextTest; testImgs(i)];
            nextRelative = [nextRelative; i];
        end

    end
    
    
    %% [ P vs SP ] test
    features = F;
    
    % We get the features of the images that we have to classify
    F = zeros(length(nextTest), size(features, 2));
    for i = 1:length(nextTest)
        F(i,:) = features(nextRelative(i),:);
    end
    
    % The classification starts
    [labels likelihood] = predict(classifier2,F);
    
    for i = 1:length(labels)

        j = labels(i);
        % Stores the result
        if(j == classPlate.id-1 && max(likelihood(i, :)) >= th_Plate) % Plate
            proposed_labels(nextTest(i)) = classPlate.id-1;
            C.reliability(nextTest(i)) = 0.5;
            C.reliableLabels(nextTest(i)) = classPlate.id-1;
            C.classificationMethod(nextTest(i)) = idOnlineLearner;
            C.likelihood(nextTest(i)) = max(likelihood(i, :));
            countPredicted{classPlate.id} = countPredicted{classPlate.id} + 1;
        elseif(j == classSemiplate.id-1 && max(likelihood(i, :)) >= th_Semiplate) % Semiplate
            proposed_labels(nextTest(i)) = classSemiplate.id-1;
            C.reliability(nextTest(i)) = 0.5;
            C.reliableLabels(nextTest(i)) = classSemiplate.id-1;
            C.classificationMethod(nextTest(i)) = idOnlineLearner;
            C.likelihood(nextTest(i)) = max(likelihood(i, :));
            countPredicted{classSemiplate.id} = countPredicted{classSemiplate.id} + 1;
        end
        % if c < threshold we don't label that image

    end

end