%%
% Divides each of the seen_C (C in this function) in 2 parts using the 
% most probable division
function [C_div]=divide_partition_das2(C, labels , nr_class, Z)

global numOfImgs;

C_div=[];
seen_idx=C.seen_idx;
num_el=numOfImgs;
id=C.id;
ids=get_id_clusters(id, Z);
ccc=size(Z,1)+1;

for j=1:2
    [C_tmp]=initialize_arbol(ids(j));

    elements_id=[];
    C_tmp.elements_id=get_labels_id(ids(j), Z, elements_id, ccc);
    C_tmp.seen_idx=intersect(seen_idx,C_tmp.elements_id);
    C_tmp.seen_labels=labels(C_tmp.seen_idx)+1;
    
    C_tmp.weight=length(setdiff(C_tmp.elements_id, C_tmp.seen_idx))/num_el;
    
    for pos_elem = 1:length(C_tmp.elements_id)
        C_tmp.features = [C_tmp.features; C.features(find(C_tmp.elements_id(pos_elem)==C.elements_id),:)];
    end
    
    C_tmp.classificationMethod = zeros(length(C_tmp.elements_id),1);
    
    % Gets the reliability information if it exists for this cluster
    if(C.checkReliability)
        C_tmp.checkReliability = 1;
        
        C_tmp.reliability = zeros(length(C_tmp.elements_id),1);
        C_tmp.reliableLabels = zeros(length(C_tmp.elements_id),1);
        C_tmp.likelihood = zeros(length(C_tmp.elements_id),1);
        
        i = 1;
        while(i <= length(C_tmp.elements_id))
            k = find(C.elements_id==C_tmp.elements_id(i));
            
            C_tmp.reliableLabels(i) = C.reliableLabels(k);
            C_tmp.classificationMethod(i) = C.classificationMethod(k);
            C_tmp.reliability(i) = C.reliability(k);
            C_tmp.likelihood(i) = C.likelihood(k);

            i=i+1;
        end
    end 
    
    C_div=[C_div C_tmp];
end



end