%% Decides if the best label for all the elements in C is the majority_label
% or the one given by the initialScreening()
function [labels, elems] = getBestLabels(majority_label, C)

    global idVariance;
    global idOnlineLearner;
    global idActiveLearner;
    global reliabilityVariance;
    global reliabilityOnlineLearner;

    elems = setdiff(C.elements_id,C.seen_idx);
    len = length(elems);
    labels = zeros(len,1);

    for i = 1:len
        % the majority_label is the same as the previously selected or the
        % previously selected was chosen by the ActiveLearner too
        if(majority_label == C.reliableLabels(i) || C.classificationMethod(i) == idActiveLearner)
            labels(i) = majority_label;
        else
            if(C.classificationMethod(i) == idVariance && reliabilityVariance > C.p_score(majority_label+1))
                labels(i) = C.reliableLabels(i);
            elseif(C.classificationMethod(i) == idOnlineLearner && reliabilityOnlineLearner > C.p_score(majority_label+1))
                labels(i) = C.reliableLabels(i);
            else
                labels(i) = majority_label;
            end
        end
    end


end