function [proposed_labels]=get_proposed_labels(C,proposed_labels, nr_class, handles)

global has_loaded;
global fin;
global usingPrototypes;
global usingVariance;
global usingOnlineLearner;

for i=1:length(C)  
    % if some elements has been seen, else use the label of the parent node
    if (~isempty(C(i).seen_labels))
        C(i).p_score=[]; % rpobabilities for each of the labels 
        for z=1:nr_class
            %% Applies the weights on the score calculation if we are using prototypes
            if(usingPrototypes)
                C(i).p_score(z) = getScorePrototypes(C(i), z);
            else
                C(i).p_score(z)=length(find(C(i).seen_labels==z))/length(C(i).seen_labels);
            end
        end
        %calculate majority label
        majority_label=(find(C(i).p_score==max(C(i).p_score), 1, 'first')-1);
    else
        majority_label=C(i).assigned_label-1;
    end
    try

%  ONLY USED BEFORE THE PREVIOUSLY CLASSIFIED SAMPLES WHERE SHOWN AT THE BEGINNING
%         %% Sets the majority_label (proposed) to all the elements in the
%         % cluster "i" of the best one for each element
%         if(usingVariance || usingOnlineLearner)
%             [labels, elems] = getBestLabels(majority_label, C(i));
%             proposed_labels(elems) = labels;
%         else
            proposed_labels(C(i).elements_id)=majority_label*ones(length(C(i).elements_id),1);
%         end
    catch ME
        save('error_Get_Proposed_Labels.mat');
        fin = true;
        set(handles.accept_cluster_button,'Enable','off');
        set(handles.accept_queries_button,'Enable','off');
        has_loaded = false;
    end
end