
function doSimulation(src,event,handles)

    global simulate;
    global simulationMode;
    global silent;
    global waitTime;
    global GT_labels;
    global maxPerWrongCluster;
    global ready;
    
    global has_loaded;
    global has_loaded_clusters;
    
    global cluster;
    global queries;
    global maxImgs2ShowInCluster;
    global maxImgs2ShowInQuery;
    global clusterSize;
    global querySize;
    global clusterToShow;
    global queriesToShow;
    
    global proposed_labels;

    
    if(simulate && ready)
        
        handles = guidata(handles);
        
        if(has_loaded && has_loaded_clusters)
        %% Both Queries and Clusters are ACTIVE
            
            wrongLabelsC = [];
            i = 1;
            while(i <= maxImgs2ShowInCluster && i <= length(cluster))
                if(proposed_labels(cluster(i)) ~= GT_labels(cluster(i)).label - 1)
                    wrongLabelsC = [wrongLabelsC; cluster(i)];
                end
                i = i+1;
            end
            
            wrongLabelsQ = [];
            i2 = 1;
            while(i2 <= maxImgs2ShowInQuery && i2 <= length(queries))
                if(proposed_labels(queries(i2)) ~= GT_labels(queries(i2)).label - 1)
                    wrongLabelsQ = [wrongLabelsQ; queries(i2)];
                end
                i2 = i2+1;
            end
            
            lenC = length(wrongLabelsC);
            lenQ = length(wrongLabelsQ);
            per = lenC / (i-1);
            % Accept Cluster
%             if(per <= maxPerWrongCluster)
            if(lenC < lenQ)
                if(~silent)
                    disp('Click Cluster');
                    disp(num2str(per));
                end
                for i = 1:lenC
                    
                    if(proposed_labels(wrongLabelsC(i)) ~= GT_labels(wrongLabelsC(i)).label - 1)
                        proposed_labels(wrongLabelsC(i)) = GT_labels(wrongLabelsC(i)).label - 1;
                        
                        if(simulationMode == 2)
                            [rIdx,cIdx] = ind2sub(clusterSize,i);
                            clusterToShow{rIdx,cIdx} = innerBorder(clusterToShow{rIdx,cIdx}, GT_labels(wrongLabelsC(i)).label);
                            showClusterAxes(handles);

                            pause(waitTime/4);
                        end
                        
                    end
                    
                end
                accept_cluster_button_Callback('', '', handles);
            % Accept Queries
            else
                if(~silent)
                    disp('Click Query');
                    disp(num2str(per));
                end

                i = 1;
                while(i <= maxImgs2ShowInQuery && i <= length(queries))
                    if(proposed_labels(queries(i)) ~= GT_labels(queries(i)).label - 1)
                        proposed_labels(queries(i)) = GT_labels(queries(i)).label - 1;
                        
                        if(simulationMode == 2)
                            [rIdx,cIdx] = ind2sub(querySize,i);
                            queriesToShow{rIdx,cIdx} = innerBorder(queriesToShow{rIdx,cIdx}, GT_labels(queries(i)).label);
                            showQueryAxes(handles);

                            pause(waitTime/4);
                        end
                        
                    end
                    i = i+1;
                end
                accept_queries_button_Callback('', '', handles);
            end
            
        elseif(has_loaded)
        %% Only Queries are ACTIVE
            if(~silent)
                disp('Click Query');
            end
            i = 1;
            while(i <= maxImgs2ShowInQuery && i <= length(queries))
                if(proposed_labels(queries(i)) ~= GT_labels(queries(i)).label - 1)
                    proposed_labels(queries(i)) = GT_labels(queries(i)).label - 1;
                    
                    if(simulationMode == 2)
                        [rIdx,cIdx] = ind2sub(querySize,i);
                        queriesToShow{rIdx,cIdx} = innerBorder(queriesToShow{rIdx,cIdx}, GT_labels(queries(i)).label);
                        showQueryAxes(handles);
                        
                        pause(waitTime/4);
                    end
                    
                end
                i = i+1;
            end
            accept_queries_button_Callback('', '', handles);
            
        elseif(has_loaded_clusters)
        %% Only Clusters are ACTIVE
            if(~silent)
                disp('Click Cluster');
            end
            i = 1;
            while(i <= maxImgs2ShowInCluster && i <= length(cluster))
                if(proposed_labels(cluster(i)) ~= GT_labels(cluster(i)).label - 1)
                    proposed_labels(cluster(i)) = GT_labels(cluster(i)).label - 1;
                    
                    if(simulationMode == 2)
                        [rIdx,cIdx] = ind2sub(clusterSize,i);
                        clusterToShow{rIdx,cIdx} = innerBorder(clusterToShow{rIdx,cIdx}, GT_labels(cluster(i)).label);
                        showClusterAxes(handles);
                        
                        pause(waitTime/4);
                    end
                    
                end
                i = i+1;
            end
            accept_cluster_button_Callback('', '', handles);
            
        end
               
    end


end