function fillQueryBox()
%fillQueryBox fills the query box with images and labels
% about files
global fileList ;
% about dimensions
global maxImgs2ShowInQuery ;
% about images
global proposed_labels ;
global queries ;
global queriesToShow ;

global folder_path;

global heightImg;
global widthImg;
global outerBorder;

global classes;
% set dimension of showing cell-array
global colsQueries;
global rowsQueries;
rowQuery = rowsQueries;
colQuery = colsQueries;
%%%%% PATCH : shows images for columns not for rows
querySize = [rowQuery colQuery];
queriesToShow = cell(rowQuery,colQuery);

for idx=1:maxImgs2ShowInQuery
    [rIdx,cIdx] = ind2sub(querySize,idx);
    try
        if idx<=length(queries)
            %load image
%             image=qva_get_frame(study,jpg_info,fileList(queries(idx)));
%             str_tmp=jpg_info(fileList(queries(idx))).filename;
%             image=imread([study.data_path study.name  '\jpgs\' study.name '\' str_tmp '.png']);
            str = fileList(queries(idx)).name;
            image=imread([folder_path '\' str]);
            %resize image
            image = imresize(image,[heightImg widthImg]);
            %show label of the image
            labeledImage = setOuterBorder(image,classes(proposed_labels(queries(idx))+1).id);
            queriesToShow{rIdx,cIdx} = labeledImage;
        else
            queriesToShow{rIdx,cIdx} = uint8(zeros(heightImg+outerBorder*2,widthImg+outerBorder*2,3));
        end
        % catches out of bounds when less images ; fills with zeros
    catch  ME
        save('error_fillQueryBox.mat');
        if strcmp(ME1.identifier,'MATLAB:badsubscript')
            queriesToShow{rIdx,cIdx} = uint8(zeros(heightImg+outerBorder*2,widthImg+outerBorder*2,3));
        end
    end
end

