function varargout = finished(varargin)
% FINISHED M-file for finished.fig
%      FINISHED, by itself, creates a new FINISHED or raises the existing
%      singleton*.
%
%      H = FINISHED returns the handle to a new FINISHED or the handle to
%      the existing singleton*.
%
%      FINISHED('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FINISHED.M with the given input arguments.
%
%      FINISHED('Pr operty','Value',...) creates a new FINISHED or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before finished_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to finished_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help finished

% Last Modified by GUIDE v2.5 16-Oct-2012 16:49:16

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @finished_OpeningFcn, ...
                   'gui_OutputFcn',  @finished_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before finished is made visible.
function finished_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to finished (see VARARGIN)

% Choose default command line output for finished
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

global HANDLES_FIN;
HANDLES_FIN = handles;
global last_time;
global start_time;

% time = toc;

time = etime(clock(), start_time);

last_time = time;
time = time/60;

sec = mod(time,1);
min = time-sec;
sec=round(sec*60);

time = [num2str(min) ':' num2str(sec)];

set(hObject, 'Visible', 'on');
set(hObject, 'Resize', 'on');
%maximize(hObject);

global labels;
global fileList;
global numOfImgs;
global numOfPrototypes;
global num_clicks_array;
global video_name;
global video_path;
global usingPrototypes;
global classes;
global C;
global prototypes;

global folder_path;
folder_path = '';

global video_loaded;

labels_result = struct('name',{},'label',{});

if(usingPrototypes)
    numOfImgs = numOfImgs - numOfPrototypes;
end

for i = 1:numOfImgs
    labels_result(i).name = fileList(i).name;
    labels_result(i).label = labels(i)+1;
end

str = ['Congratulations! You finished the labeling. Total elapsed time: ' time ' min.'];
set(handles.textFinish, 'String', str);


% Keeping normal tree's elems
C_normal = struct('ids', {}, 'labels', {}, 'features', {});
for i = 1:length(C)
    C_normal(i).ids = C(i).elements_id;
    C_normal(i).labels = C(i).seen_labels';
    C_normal(i).features = C(i).features;
end
% Tree Leaves "purification"
C_pure = struct('ids', {}, 'labels', {}, 'features', {});
count = 1;

for i = 1:length(C)
    for j = 1:length(classes)
        elems = find(C(i).seen_labels == j);
        if(~isempty(elems))
            C_pure(count).ids = C(i).elements_id(elems);
            C_pure(count).labels = C(i).seen_labels(elems)';
            C_pure(count).features = C(i).features(elems,:);
            count = count+1;
        end
    end
end

    
% Saves .mat features in the results folder
features = load([video_path '\features.mat']);
F = features.F;
mkdir(['..\result_files\' video_name]);
save(['..\result_files\' video_name '\features.mat'], 'F');
% Saves the .mat labels_result
save(['..\result_files\' video_name '\labels_result_' video_name '.mat'], 'labels_result');
% Saves the array of the clicks done on each iteration
save(['..\result_files\' video_name '\num_clicks_array.mat'], 'num_clicks_array');
% Saves Tree Leaves
save(['..\result_files\' video_name '\C_normal.mat'], 'C_normal');
save(['..\result_files\' video_name '\C_pure.mat'], 'C_pure');

% Creates new prototypes
prototypes_new = struct('name', {}, 'features', {}, 'num_samples', {});
for i = 1:length(C_pure)
    prototypes_new(i).name = num2str(C_pure(i).labels(1));
    features_new = [];
    prototypes_new(i).num_samples = 0;
    lenIds = length(C_pure(i).ids);
    for j = 1:lenIds
        if(C_pure(i).ids(j) <= numOfImgs)
            prototypes_new(i).num_samples = prototypes_new(i).num_samples + 1;
            features_new = [features_new; C_pure(i).features(j,:)];
        elseif((C_pure(i).ids(j) > numOfImgs))
            id = C_pure(i).ids(j) - numOfImgs;
            prototypes_new(i).num_samples = prototypes_new(i).num_samples + prototypes(id).num_samples;
            features_new = [features_new; repmat(C_pure(i).features(j,:), prototypes(id).num_samples, 1)];
        end
    end
    prototypes_new(i).features = median(features_new,1);
end
prototypes = prototypes_new;

% Saves the prototypes
save('..\Prototypes\OnePerLeaf\prototypes.mat', 'prototypes');

video_loaded = false;


% UIWAIT makes finished wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = finished_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
%maximize(hObject);


% --- Executes on button press in aButton.
function aButton_Callback(hObject, eventdata, handles)
% hObject    handle to aButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close(findobj('type','figure','name','finished'));
