function varargout = gui_intestinal_labeling(varargin)
% GUI_INTESTINAL_LABELING M-file for gui_intestinal_labeling.fig
%      GUI_INTESTINAL_LABELING, by itself, creates a new GUI_INTESTINAL_LABELING or raises the existing
%      singleton*.
%
%      H = GUI_INTESTINAL_LABELING returns the handle to a new GUI_INTESTINAL_LABELING or the handle to
%      the existing singleton*.
%
%      GUI_INTESTINAL_LABELING('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_INTESTINAL_LABELING.M with the given input arguments.
%
%      GUI_INTESTINAL_LABELING('Property','Value',...) creates a new GUI_INTESTINAL_LABELING or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_intestinal_labeling_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_intestinal_labeling_OpeningFcn via varargin.
% 
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui_intestinal_labeling

% Last Modified by GUIDE v2.5 05-Jun-2013 13:41:35

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_intestinal_labeling_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_intestinal_labeling_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_intestinal_labeling is made visible.
function gui_intestinal_labeling_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_intestinal_labeling (see VARARGIN)


%-----------------------------
%-----------------------------
%---- GLOBAL VARIABLES -------
%-----------------------------
%-----------------------------

global folder_path; % path to the images' folder
folder_path = '';
global original_folder; % path to the original images' folder

global video_name; % name of the video we are displaying

% defines all global vars althought not used
global pathName; % path used to load the structure with the input data (test.mat)
global fileList ; % file name used to load the structure with the input data (test.mat)

global numOfImgs; % # of images that are in the directory
global maxImgs2ShowInCluster ; % # of images that can be shown in cluster box
global maxImgs2ShowInQuery ; % # of images that can be shown in quiery box

global cluster ; % idx of the images inside a cluster
global clusterToShow ; % idx of images from cluster to be shown in cluster box
global queries ;    % idx of images 
global queriesToShow ; % idx of images to be shown in in query box

global labels ;     % groundtruth
global proposed_labels ; % vector with labels proposal (labels being proposed by the algorithm)

% vectors that indicate which where the labels of the queries and the
% clusters in this iteration before modifying any label.
global clicked_queries; % vector that indicates which of the queries' labels have been changed in a particular moment
global clicked_clusters; % vector that indicates which of the cluster's labels have been changed in a particular moment

% variables used in label box 
global labIndX;
global labIndY;
global labels_mat ;
global labLimit ;

% Indicates if we finished labeling all the images
global fin;

% variables - number of classes
global k;

global has_loaded; % boolean used for checking if images are loaded
has_loaded = false;
% boolean used for checking if a cluster has already been loaded
global has_loaded_clusters; 
has_loaded_clusters = false;

%%% load paths to intes code
tmp_path=pwd;
addpath([tmp_path '\Utils\qva\qva']);
addpath([tmp_path '\Utils\study\study']);
addpath([tmp_path '\mLMNN2.3']);
install();
cd ..
clc;
% AdaBoost path
% addpath('..\..\..\AdaBoost');

%%% add paths to algorithm
addpath([tmp_path '\code']);
addpath(pwd);

%%% video frames path
global video_path;
% video_path='E:\MARC\Intestinos_application_Marc\';

% Pixels width of the outer border of the labels
global outerBorder;
outerBorder = 10;

% Height and Width of the coloured axes to show movie frames
global heightLabelAxes;
global widthLabelAxes;
heightLabelAxes = 64;
widthLabelAxes = 768; % ratio 12

% Width and Height of a frame label in label axes
global widthLabel;

% Height and Width of click's progress bar
global heightClicksAxes;
global widthClicksAxes;
heightClicksAxes = 20;
widthClicksAxes = 230;
global pxPerClick;

% Height and Width of number of images labeled progress bar
global heightNumLabeledAxes;
global widthNumLabeledAxes;
heightNumLabeledAxes = 20;
widthNumLabeledAxes = 320;
global pxPerLabel;

global imgsFormat;
imgsFormat = '.jpg';

% Height of the images in pixels
global heightImg;
heightImg = 150;
% Width of the images in pixels
global widthImg;
widthImg = 150;
% Number of rows in the queries panel
global rowsQueries;
rowsQueries = 5;
% Number of columns in the queries panel
global colsQueries;
colsQueries= 4;
% Queries total size
global querySize;
querySize = [rowsQueries colsQueries];
% Number of rows in the clusters panel
global rowsClusters;
rowsClusters = 5;
% Number of rows in the clusters panel
global colsClusters;
colsClusters = 8;
% Clusters total size
global clusterSize;
clusterSize = [rowsClusters colsClusters];

clicked_queries = zeros(rowsQueries*colsQueries,1);
clicked_clusters = zeros(rowsClusters*colsClusters,1);

% Variables about the diferent classes that we can label
global classes_path;
classes_path = '..';

global classes;
classes = struct('name', {}, 'id', {}, 'rgb', zeros(3,1), 'shortcut', {});

% Struct that stores the classes that won't be processed in the labeling
% algorythm (about photos that we don't consider relevant).
global remove_classes;
remove_classes = struct('name', {}, 'id', {}, 'rgb', zeros(3,1), 'shortcut', {});


% ActiveLearner type
% { 1 = Hierarchical Cluster Tree, 2 = Linear Discriminant Analysis Tree,
%   3 = Large Margin Nearest Neighbours }
global activeLearnerType;
activeLearnerType = 2;

% Type of classifier used {0 = AdaBoost, 1 = KNN}
global classifierType;
classifierType = 1;

% OnlineLearner type 
% {1 = Single Classifier, 2 = Combined Classifier}
global onlineLearnerType;
onlineLearnerType = 2;

% Type of prototypes {1 = One Per Class, 2 = One Per Leaf (form previously classified tree)}
global prototypesType;
prototypesType = 1;

% PCA threshold to decide if a feature is useless
global PCAthreshold;
PCAthreshold = 0.001;
global LDAthreshold;
LDAthreshold = 0.001;
global join_labels;
join_labels = [2 3];
global numNearestNeighboursKNN;
numNearestNeighboursKNN = 15;
global numNearestNeighboursLMNN;
numNearestNeighboursLMNN = 3;
global nClusters;
nClusters = 2;

% Prototypes variables
global usingPrototypes;
usingPrototypes = true;

global usingVariance;
usingVariance = false;
global usingOnlineLearner;
usingOnlineLearner = true;

% Weights used with prototypes
global weights;

% Threshold used for the variance check (if variance < threshold --> no plate)
global threshold_var;
threshold_var = 1500;

% Threshold to consider that the onlineLearner can be trusted
global th_No_Plate;
global th_Plate_Semiplate;
global th_Plate;
global th_Semiplate;
% Thresholds KNN
th_No_Plate = 0.7;
th_Plate_Semiplate = 0.7;
th_Plate = 0.9;
th_Semiplate = 0.8;

% th_No_Plate = 0.9;
% th_Plate_Semiplate = 0.9;
% th_Plate = 0.9;
% th_Semiplate = 0.9;

% th_No_Plate = 1;
% th_Plate_Semiplate = 1;
% th_Plate = 1;
% th_Semiplate = 1;

% Reliability given to each classification method
global reliabilityVariance;
global reliabilityOnlineLearner;
% reliabilityVariance = 0.25;
% reliabilityOnlineLearner = 0.769;
reliabilityVariance = 0.0;
reliabilityOnlineLearner = 0.0;


% Ids given to each classification method
global idVariance;
global idOnlineLearner;
global idActiveLearner;
idVariance = 1;
idOnlineLearner = 2;
idActiveLearner = 0;

% Says if the labeling will be authomatically simpulated
global simulate;
simulate = false;
global simulationMode;
% {1 = quick , 2 = slow (showing label changes) }
simulationMode = 1;
global waitTime; % seconds
waitTime = 1;
global simTimer;
global GT_labels;
global maxPerWrongCluster;
maxPerWrongCluster = 0.2;
% Determines if the info about the simulation process is silenced or not
global silent;
silent = false;

global video_loaded;
video_loaded = false;
%-----------------------------
%-----------------------------
%------ INITIALIZATION -------
%-----------------------------
%-----------------------------

% Choose default command line output for gui_intestinal_labeling
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

global HANDLES;
HANDLES = handles;
global HOBJECT;
HOBJECT = hObject;

% UIWAIT makes gui_intestinal_labeling wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% gets the screen resolution
% a=get(0,'MonitorPositions');
% global screenWidth;
% screenWidth = a(3);
% global screenHeight;
% screenHeight = a(4);
% 
% fig = [screenWidth/50, screenHeight/8, screenWidth/6, screenHeight/15];
% 
% set(handles.figure1, 'Position', fig);
% set(handles.uipanel8, 'Position', [fig(3)/50, fig(4)/50,
% fig(3)-fig(3)/50*2, fig(4)/10]);

set(hObject, 'Visible', 'on');
set(hObject, 'Resize', 'on');
%maximize(hObject);

% Initializes the lAxes (Labels Axes)
labelsIm = uint8(zeros(heightLabelAxes, widthLabelAxes, 3));
axes(handles.lAxes);
imshow(labelsIm);

% Initializes the clicksAxes
im = uint8(zeros(heightClicksAxes, widthClicksAxes, 3));
axes(handles.clicksAxes);
imshow(im);

% Initializes the labeledAxes
im = uint8(zeros(heightNumLabeledAxes, widthNumLabeledAxes, 3));
axes(handles.labeledAxes);
imshow(im);

% Initializes the qAxes and cAxes
axes(handles.qAxes);
axis off;
axes(handles.cAxes);
axis off;
axes(handles.showAxes);
axis off;

set(handles.simulateButton,'Enable','off');



% --- Outputs from this function are returned to the command line.
function varargout = gui_intestinal_labeling_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
%maximize(hObject);

% --------------------------------------------------------------------
function File_Callback(hObject, eventdata, handles)
% hObject    handle to File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global folder_path;
folder_path = '';


% --------------------------------------------------------------------
function Help_Callback(hObject, eventdata, handles, idTab)
% hObject    handle to File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global helpID; % id of the help page that we are going to show

helpID = idTab;
% run helpWindow;
folder = 'Help';
fileList = dir([folder '/*.pdf']);
file = fileList(helpID).name;

text = [pwd '\' folder '\' file];

winopen(text);

 

% --- Executes on mouse press over figure background, over a disabled or
% --- inactive control, or over an axes background.



function newClassValue_Callback(hObject, eventdata, handles)
% hObject    handle to newClassValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of newClassValue as text
%        str2double(get(hObject,'String')) returns contents of newClassValue as a double


% --- Executes during object creation, after setting all properties.
function newClassValue_CreateFcn(hObject, eventdata, handles)
% hObject    handle to newClassValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Rvalue_Callback(hObject, eventdata, handles)
% hObject    handle to Rvalue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Rvalue as text
%        str2double(get(hObject,'String')) returns contents of Rvalue as a double


% --- Executes during object creation, after setting all properties.
function Rvalue_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Rvalue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Gvalue_Callback(hObject, eventdata, handles)
% hObject    handle to Gvalue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Gvalue as text
%        str2double(get(hObject,'String')) returns contents of Gvalue as a double


% --- Executes during object creation, after setting all properties.
function Gvalue_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Gvalue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Bvalue_Callback(hObject, eventdata, handles)
% hObject    handle to Bvalue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Bvalue as text
%        str2double(get(hObject,'String')) returns contents of Bvalue as a double


% --- Executes during object creation, after setting all properties.
function Bvalue_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Bvalue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function shortcutValue_Callback(hObject, eventdata, handles)
% hObject    handle to shortcutValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of shortcutValue as text
%        str2double(get(hObject,'String')) returns contents of shortcutValue as a double


% --- Executes during object creation, after setting all properties.
function shortcutValue_CreateFcn(hObject, eventdata, handles)
% hObject    handle to shortcutValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in addClassButton.
function addClassButton_Callback(hObject, eventdata, handles)
% hObject    handle to addClassButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global classes;
global has_loaded;
global has_loaded_clusters;

if(has_loaded || has_loaded_clusters)
    errorMessage = 'Les dades introdudes no sn correctes.';
    len = length(classes);

    % Get data from GUI
    n = get(handles.newClassValue, 'String');
    r = str2num(get(handles.Rvalue, 'String'));
    g = str2num(get(handles.Gvalue, 'String'));
    b = str2num(get(handles.Bvalue, 'String'));
    sc = get(handles.shortcutValue, 'String');

    % Check class name not repeated
    i = 1;
    okN = true;
    while(i <= len && okN)
        if(strcmp(n, classes(i).name))
            okN = false;
        end
        i=i+1;
    end

    % Check RGB values not repeated
    if(isempty(r) || isempty(g) || isempty(b))
        okRGB = false;
    else
        rgb = [r g b];
        okRGB = true;
        i = 1;
        while(i <= 3 && okRGB)
            if(rgb(i) < 0 || rgb(i) > 255)
                okRGB = false;
            end
            i = i+1;
        end
        i = 1;
        while(i <= len && okRGB)
            if(rgb(1) == classes(i).rgb(1) && rgb(2) == classes(i).rgb(2) && rgb(3) == classes(i).rgb(3))
                okRGB = false;
            end
            i = i+1;
        end
    end

    % Check shortcut not repeated
    if(length(sc) ~= 1)
        okSC = false;
    else
        okSC = true;
        i = 1;
        while(i <= len && okSC)
            if(strcmp(sc, classes(i).shortcut))
                okSC = false;
            end
            i=i+1;
        end
    end

    % Add to list
    if(okN && okRGB && okSC)
        global k;
        k = k+1;
        set(handles.textInfo, 'String', '');
        classes(len+1).name = n;
        classes(len+1).rgb = rgb;
        classes(len+1).id = len+1;
        classes(len+1).shortcut = sc;
        set(handles.listClasses, 'String', [get(handles.listClasses, 'String');{[n ' [' sc ']']}]);
        changeColor(handles.listClasses);
        saveClasses();
    else
        set(handles.textInfo, 'String', errorMessage);
    end
end

% --- Executes on selection change in listClasses.
function listClasses_Callback(hObject, eventdata, handles)
% hObject    handle to listClasses (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listClasses contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listClasses

changeColor(hObject);


% --- Executes during object creation, after setting all properties.
function listClasses_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listClasses (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over listClasses.
function listClasses_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to listClasses (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on key press with focus on figure1 and none of its controls.
function figure1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  structure with the following fields (see FIGURE)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in changeAllCButton.
function changeAllCButton_Callback(hObject, eventdata, handles)
% hObject    handle to changeAllCButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global proposed_labels;
global cluster;
global clusterToShow;
global k;
global classes;
global clusterSize;
global has_loaded_clusters;


if has_loaded_clusters

    % We check if 'Shift' is pressed and if it's true we get the shortcut key
    if(~isempty(get(handles.figure1, 'CurrentModifier')))
        key = get(handles.figure1, 'CurrentKey');
    else
        key = false;
    end

    % We change the label depending on the clicked shortcut (if clicked)
    if(key)
        len = length(classes);
        i = 1; found = false;
        while(i <= len && ~found)
            if(strcmp(lower(classes(i).shortcut), key))
                found = true;
            end
            i = i+1;
        end
    else
        found = false;
    end

    len = min( (clusterSize(1) * clusterSize(2)), length(cluster) );
    if(found)
        for j = 1:len
            [rIdx, cIdx] = ind2sub(clusterSize, j);
            proposed_labels(cluster(j)) = classes(i-1).id-1;
            clusterToShow{rIdx,cIdx} = innerBorder(clusterToShow{rIdx,cIdx}, classes(i-1).id);
        end
    else
        for j = 1:len
            [rIdx, cIdx] = ind2sub(clusterSize, j);
            proposed_labels(cluster(j)) = mod(proposed_labels(cluster(j))+1,k);
            clusterToShow{rIdx,cIdx} = innerBorder(clusterToShow{rIdx,cIdx},classes(proposed_labels(cluster(j))+1).id);
        end
    end

    % Changes the selected class (and for this reason its colour too) in the list of classes 
    set(handles.listClasses, 'value', proposed_labels(cluster(1))+1);
    changeColor(handles.listClasses);
    
    showClusterAxes(handles);
end


% --- Executes on button press in changeAllQButton.
function changeAllQButton_Callback(hObject, eventdata, handles)
% hObject    handle to changeAllQButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global proposed_labels;
global queries;
global queriesToShow;
global k;
global classes;
global querySize;
global has_loaded;


if has_loaded

    % We check if 'Shift' is pressed and if it's true we get the shortcut key
    if(~isempty(get(handles.figure1, 'CurrentModifier')))
        key = get(handles.figure1, 'CurrentKey');
    else
        key = false;
    end

    % We change the label depending on the clicked shortcut (if clicked)
    if(key)
        len = length(classes);
        i = 1; found = false;
        while(i <= len && ~found)
            if(strcmp(lower(classes(i).shortcut), key))
                found = true;
            end
            i = i+1;
        end
    else
        found = false;
    end

    len = querySize(1) * querySize(2);
    if(found)
        for j = 1:len
            [rIdx, cIdx] = ind2sub(querySize, j);
            proposed_labels(queries(j)) = classes(i-1).id-1;
            queriesToShow{rIdx,cIdx} = innerBorder(queriesToShow{rIdx,cIdx}, classes(i-1).id);
        end
    else
        for j = 1:len
            [rIdx, cIdx] = ind2sub(querySize, j);
            proposed_labels(queries(j)) = mod(proposed_labels(queries(j))+1,k);
            queriesToShow{rIdx,cIdx} = innerBorder(queriesToShow{rIdx,cIdx},classes(proposed_labels(queries(j))+1).id);
        end
    end

    % Changes the selected class (and for this reason its colour too) in the list of classes 
    set(handles.listClasses, 'value', proposed_labels(queries(1))+1);
    changeColor(handles.listClasses);
    
    showQueryAxes(handles);
    
end


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
global fin;
delete(hObject);

fin = true;


% --- Executes on button press in simulateButton.
function simulateButton_Callback(hObject, eventdata, handles)
% hObject    handle to simulateButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global fin;
global simTimer;
global simulationMode;
global waitTime;
global simulate;

simulate = true;

if(~fin)
    start(simTimer);
    if(simulationMode == 2)
        pause(waitTime);
    end
end


% --------------------------------------------------------------------
function Settings_Callback(hObject, eventdata, handles)
% hObject    handle to Settings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% --------------------------------------------------------------------
function Edit_Callback(hObject, eventdata, handles)
% hObject    handle to Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% SETTINGS EDIT function
global video_loaded;

if(~video_loaded)
    run settings;
end



