%%
%   Does an initial screening over all the loaded images checking if some
%   of their labels can be initially guessed.
function initialScreening()

    global classes;
    global classNoPlate;
    global classPlate;
    global classSemiplate;
    global C;
    
    global usingVariance;
    global usingOnlineLearner;
    
    global time_classifier;
    time_classifier = 0;
    global countPredicted;
    countPredicted = {};
    global k;
    for i = 1:k
        countPredicted{i} = 0;
    end
    
    % Gets the classes 'No plate', 'Plate' and 'Semiplate'
    len = length(classes);
    for i = 1:len
        if(strcmp(classes(i).name, 'No plate'))
            classNoPlate = classes(i);
        elseif(strcmp(classes(i).name, 'Plate'))
            classPlate = classes(i);
        elseif(strcmp(classes(i).name, 'Semiplate'))
            classSemiplate = classes(i);
        end
    end

    if(usingVariance)
        checkVariance(); % Does an initial variance screening with all the images
    end
    
    if(usingOnlineLearner)
        t1 = clock();
        checkOnlineLearner(); % Classifies and discards the images whos labels are clear.
        time_classifier = etime(clock(), t1);
    end
    
    if(usingVariance || usingOnlineLearner)
        C.checkReliability = 1;
    end
    
end