function mouseOverAxes(src, varargin)
    global querySize;
    global clusterSize;
    global widthImg;
    global heightImg;
    global outerBorder;
    global proposed_labels;
    global labels;
    global queries;
    global cluster;
    
    global original_folder;
    global fileList;
    
    global labIndX;
    global labIndY;
    global numOfImgs;

    handles = guidata(src);
    
    % We check the qAxes
    h = handles.qAxes;
 
    pt = get(h,'CurrentPoint');
    x = pt(1,1);
    y = pt(1,2);
    x = ceil(x/ (widthImg + outerBorder*2) );
    y = ceil(y/ (heightImg + outerBorder*2) );
    
    try
        index = sub2ind(querySize,y,x);
        class = proposed_labels(queries(index))+1;
        set(handles.listClasses, 'value', class);
        changeColor(handles.listClasses);
    catch
        % This means we aren't in the queries axes, we are going to try in 
        % the cluster's axes
        % We check the cAxes
        h = handles.cAxes;
    
        pt = get(h,'CurrentPoint');
        x = pt(1,1);
        y = pt(1,2);
        x = ceil(x/ (widthImg + outerBorder*2) );
        y = ceil(y/ (heightImg + outerBorder*2) );
        try
            index = sub2ind(clusterSize,y,x);
            class = proposed_labels(cluster(index))+1;
            set(handles.listClasses, 'value', class);
            changeColor(handles.listClasses);
        catch
            % We do nothing
        end
    end
    

    % We check the lAxes
    h = handles.lAxes;

%     newPoint = get(handles.figure1, 'CurrentPoint');
%     pos = get(h, 'Position');
%     inAxes=(newPoint(1,1)>=pos(1)) && (newPoint(1,1)<pos(1)+pos(3)) && (newPoint(1,2)>pos(2)) && (newPoint(1,2)<pos(2)+pos(4));
%     if(inAxes)

    % tinc posicio respecte el uipanel4
    % necesito posici respecte el lAxes
    pt = get(h,'CurrentPoint');
    
    x = pt(1,1);
    y = pt(1,2);
    x = round(x);
    y = round(y);
    try
        labelsSize = [labIndX labIndY];
        index = sub2ind(labelsSize,x,y);
        if(numOfImgs >= index)
            str = fileList(index).name;
            img = imread([original_folder '\' str]);
            % changes the class showed in the list
            class = labels(index)+1;
            if(class > 0)
                set(handles.listClasses, 'value', class);
                changeColor(handles.listClasses);
            end
            % shows the modified lAxes with the different color label
            showLabelAxesSelected(handles, index);
            % clears show axes
            cla(handles.showAxes);
            % shows in the axes
            set(gcf,'CurrentAxes',handles.showAxes);
            imshow(img);
            axis off;
        end

    catch
        % clears show axes
        cla(handles.showAxes);
        showLabelAxes(handles); % we show the normal lAxes
    end
    
    
end