% --- Adds a border to img1 and Paints the borders of color c
function img2 = setOuterBorder(img1, c)
global outerBorder;
global classes;
t = outerBorder;
[nr1 nc1 d] = size(img1);

% Add the border thicknesses to the total image size
nr2 = nr1 + 2*t;
nc2 = nc1 + 2*t;
% Create an empty matrix, filled with the border color.
img2 = repmat(0, [nr2 nc2 d]);

for i = 1:3
    img2(:,:,i)=repmat(classes(c).rgb(i), [nr2 nc2]);
end

img2 = uint8(img2);
% Copy IMG1 to the inner portion of the image.
img2((t+1):(nr2-t),(t+1):(nc2-t),:) = img1;