function varargout = settings(varargin)
% SETTINGS MATLAB code for settings.fig
%      SETTINGS, by itself, creates a new SETTINGS or raises the existing
%      singleton*.
%
%      H = SETTINGS returns the handle to a new SETTINGS or the handle to
%      the existing singleton*.
%
%      SETTINGS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SETTINGS.M with the given input arguments.
%
%      SETTINGS('Property','Value',...) creates a new SETTINGS or raises
%      the existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before settings_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to settings_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help settings

% Last Modified by GUIDE v2.5 05-Jun-2013 15:19:37

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @settings_OpeningFcn, ...
                   'gui_OutputFcn',  @settings_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before settings is made visible.
function settings_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to settings (see VARARGIN)

% Choose default command line output for settings
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

initialize_gui(hObject, handles, false);

% UIWAIT makes settings wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = settings_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in accept.
function accept_Callback(hObject, eventdata, handles)
% hObject    handle to accept (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function initialize_gui(fig_handle, handles, isreset)
% If the metricdata field is present and the reset flag is false, it means
% we are we are just re-initializing a GUI by calling it from the cmd line
% while it is up. So, bail out as we dont want to reset the data.


% Update handles structure
guidata(handles.figure1, handles);


%%% Active Learners
global activeLearnerType;

switch(activeLearnerType)
    case 1
        set(handles.linkage, 'Value', 1)
    case 2
        set(handles.LDA, 'Value', 1)
    case 3
        set(handles.LMNN, 'Value', 1)
end


%%% Online Learners
global classifierType;
global onlineLearnerType;
global usingOnlineLearner;

if(~usingOnlineLearner)
    set(handles.NoneO, 'Value', 1)
else
    if(classifierType == 0)
        set(handles.AdaBoost, 'Value', 1)
    elseif(classifierType == 1)
        set(handles.KNN, 'Value', 1)
    end
end

if(onlineLearnerType == 1)
    set(handles.single, 'Value', 1)
elseif(onlineLearnerType == 2)
    set(handles.combined, 'Value', 1)
end


%%% Prototypes
global prototypesType;
global usingPrototypes;

if(~usingPrototypes)
    set(handles.NoneP, 'Value', 1)
else
    if(prototypesType == 1)
        set(handles.OnePerClass, 'Value', 1)
    elseif(prototypesType == 2)
        set(handles.OnePerLeaf, 'Value', 1)
    end
end


%%% Simulator
global simulate;
global simulationMode;
% {1 = quick , 2 = slow (showing label changes) }

if(simulate)
    set(handles.activate_simulation, 'Value', 1);
end

if(simulationMode == 1)
    set(handles.quick, 'Value', 1);
elseif(simulationMode == 2)
    set(handles.slow, 'Value', 1);
end




% --- Executes during object creation, after setting all properties.
function wait_time_CreateFcn(hObject, eventdata, handles)
% hObject    handle to wait_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes when selected object is changed in active_learners.
function active_learners_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in active_learners 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

global activeLearnerType;

switch get(eventdata.NewValue,'Tag') 
    case 'linkage'
        activeLearnerType = 1;
    case 'LDA'
        activeLearnerType = 2;
    case 'LMNN'
        activeLearnerType = 3;
end


% --- Executes when selected object is changed in online_learners.
function online_learners_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in online_learners 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
global classifierType;
global usingOnlineLearner;
global th_No_Plate;
global th_Plate_Semiplate;
global th_Plate;
global th_Semiplate;

if(strcmp(get(eventdata.NewValue,'Tag'), 'NoneO'))
    usingOnlineLearner = false;
else
    usingOnlineLearner = true;
    if(strcmp(get(eventdata.NewValue,'Tag'), 'AdaBoost'))
        classifierType = 0;
        th_No_Plate = 0.075;
        th_Plate_Semiplate = 0.075;
        th_Plate = 0.075;
        th_Semiplate = 0.075;
    elseif(strcmp(get(eventdata.NewValue,'Tag'), 'KNN'))
        classifierType = 1;
        th_No_Plate = 0.7;
        th_Plate_Semiplate = 0.7;
        th_Plate = 0.9;
        th_Semiplate = 0.8;
    end
end


% --- Executes when selected object is changed in online_learner_method.
function online_learner_method_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in online_learner_method 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

global onlineLearnerType;

if(strcmp(get(eventdata.NewValue,'Tag'), 'single'))
    onlineLearnerType = 1;
elseif(strcmp(get(eventdata.NewValue,'Tag'), 'combined'))
    onlineLearnerType = 2;
end


% --- Executes when selected object is changed in prototypes.
function prototypes_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in prototypes 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

global prototypesType;
global usingPrototypes;


if(strcmp(get(eventdata.NewValue,'Tag'), 'NoneP'))
    usingPrototypes = false;
else
    usingPrototypes = true;
    if(strcmp(get(eventdata.NewValue,'Tag'), 'OnePerClass'))
        prototypesType = 1;
    elseif(strcmp(get(eventdata.NewValue,'Tag'), 'OnePerLeaf'))
        prototypesType = 2;
    end
end


% --- Executes when selected object is changed in simulation.
function simulation_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in simulation 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

global simulationMode;
% {1 = quick , 2 = slow (showing label changes) }

switch get(eventdata.NewValue,'Tag') 
    case 'quick'
        simulationMode = 1;
    case 'slow'
        simulationMode = 2;
end


% --- Executes on key press with focus on activate_simulation and none of its controls.
function activate_simulation_Callback(hObject, eventdata, handles)
% hObject    handle to activate_simulation (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

global simulate;

if(get(hObject, 'Value') == 1)
    simulate = true;
else
    simulate = false;
end
