% --- Shows cluster images in axes
function showClusterAxes(handles)
global clusterToShow ;
global number_of_labeled_frames;
global numOfImgs;
global has_loaded;

global heightImg;
global widthImg;

global maxImgs2ShowInCluster;
global clusterSize;
global seen_cluster;
global cluster;
global C;

global idOnlineLearner;

% if(number_of_labeled_frames < numOfImgs && has_loaded)
if(number_of_labeled_frames < numOfImgs)
    % clears cluster axes
    cla(handles.cAxes);
    % shows in the axes
    set(gcf,'CurrentAxes',handles.cAxes);
    imshow(cell2mat(clusterToShow));
    
    dim = [];
    x = get(handles.cAxes, 'xLim');
    dim(2) = x(2);
    y = get(handles.cAxes, 'yLim');
    dim(1) = y(2);
    
    dim(1) = dim(1) / clusterSize(1);
    dim(2) = dim(2) / clusterSize(2);
    
    idx = 1;
    while( idx <= maxImgs2ShowInCluster && idx <= length(cluster) && ~isempty(seen_cluster))
        [cIdx,rIdx] = ind2sub(clusterSize,idx);
        
        % If this sample's label has been guessed by the online learner
        % then we show its likelihood
        this_idx = find(C(seen_cluster).elements_id == cluster(idx));
        if(C(seen_cluster).classificationMethod(this_idx) == idOnlineLearner)
            lh_str = sprintf('%.3f',C(seen_cluster).likelihood(this_idx));
            text('position',[((dim(2)*(rIdx-1))+10 +dim(2) -dim(2)/2) ((dim(1)*cIdx)-10-(dim(1)-dim(1)/4))],'fontsize',10,'string',lh_str, 'color', 'yellow');
        end
        
        idx = idx+1;
    end
        
    axis off;

    % Sets the "listeners" for when you click on the cAxes
    c = get(handles.cAxes, 'children');
    set(c,'ButtonDownFcn',@labelClickedCluster);
    set(handles.figure1,'windowbuttonmotionfcn',@mouseOverAxes);
else
    cla(handles.qAxes);
    cla(handles.cAxes);
end