% --- Shows colored labels in axes with the selected image (index) with a
% different colour
function showLabelAxesSelected(handles, index)
global labels
global labIndX;
global labIndY;
global labels_mat ;
global labLimit ;
global classes;
global k;

color_increment = 80;

class_sel = labels(index)+1;
new_labels = labels;
new_labels(index) = k; % we pretend it's a new class

% we generate the new color for the selected image label
if(class_sel == 0) % without class
    new_color = [color_increment color_increment color_increment];
else
    new_color = classes(class_sel).rgb;
    for i = 1:3
        new_color(i) = new_color(i)+color_increment;
        if(new_color(i) > 255)
            new_color(i) = 255;
        end
    end
end

labels_mat = (reshape(new_labels(1:labLimit), labIndX, labIndY));
set(gcf,'CurrentAxes',handles.lAxes);
%imagesc(labels_mat',[0,1]);
labels_mat = (labels_mat + 1) ./ (k+1);
imshow(labels_mat');

test_map = [0 0 0];
for i = 1:k
    test_map = [test_map; classes(i).rgb];
end
test_map = [test_map; new_color]; % we put the new color in the test_map
test_map = test_map ./ 255;
%test_map=[classes(1).rgb;0 0 0; classes(2).rgb;] ./255;
colormap(test_map)
axis off;