%%  Creates all the possible subimages from all the images in a source folder
%   using a sliding window with the given parameters.
function slidingWindow()

    % Variables for storing the result of the sliding windows
    global countSlides;
    countSlides = 1;
    global result;
    result = struct('id_photo', {}, 'id_subphoto', {}, 'w', {}, 'h', {}, 'maxW', {}, 'maxH', {}, 'x', {}, 'y', {});

    source_path = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY\Videos\Dishes images_renamed';
    imgsFormat = '.jpg';

    initPer = 70;   % Initial percentatge rate of the source fotos
    finPer = 30;    % Final percentatge rate of the source fotos
    jumpPer = 10;   % Difference between the proportions of a set of sliding window photos and the next
    diffSlide = 10;  % Difference (in relative percentatge) between every slide of the same slidingWindow
    % 75, 25, 10, 10 by default
    
    imgs = dir([source_path '\*' imgsFormat]);
    len = length(imgs);
    
    ini = 150;    % initial and final IDs of the photos that will be processed (1 and len by default)
    fin = 350;
    
    % Sets the result path
    result_path = [source_path '_' num2str(ini) 'to' num2str(fin) '_slides'];
    mkdir(result_path);
    
    %% Images/Percentatges iteration
    % For each image
    for imIdx = ini:fin
        %% Sizes Calculation
        im = imread([source_path '\' imgs(imIdx).name]);
        s = size(im);
        maxY = s(1); maxX = s(2); % Gets the max X, Y for the slidingWindow
        % For each percentatge
        for per = initPer:-jumpPer:finPer
            h = floor(maxY *(per/100)); % Gets the width and height of the resulting images
            w = floor(maxX *(per/100));

            xDisp = floor(maxX*(diffSlide/100)); % absolute displacement between slides
            yDisp = floor(maxY*(diffSlide/100));
        
            %% YSlides/XSlides iteration
            for y = 1:yDisp:(maxY-h)
                for x = 1:xDisp:(maxX-w)
                    slideIm = im(y:(h+y), x:(w+x),:);
                    name_subimage = setResult(x, y, w, h, size(im, 2), size(im,1), imgs(imIdx).name);
                    imwrite(slideIm, [result_path '\' name_subimage]);
                end
            end
        end
        % We save the complete image
        name_subimage = setResult(1, 1, size(im, 2), size(im,1), size(im, 2), size(im,1), imgs(imIdx).name);
        imwrite(im, [result_path '\' name_subimage]);
        disp(['Image ' imgs(imIdx).name ' slides finished (' num2str(imIdx-ini+1) '/' num2str(fin-ini+1) ').']);
    end
    
    %% Stores the results_slide file with all the data related and the subimages proportions
    save([result_path '\' 'result_slide' '.mat'], 'result');
    disp(['File ' 'result_slide' ' successfuly saved in ' result_path]);
end

%% Stores the data in the 'result' variable and returns the name of the sub_image
function name_subimage = setResult(x, y, w, h, maxW, maxH, name)

    global countSlides;
    global result;
    
    result(countSlides).id_photo = name;
    name_subimage = strcat(sprintf('%06d', countSlides), '.jpg');
    result(countSlides).id_subphoto = name_subimage;
    result(countSlides).x = x;
    result(countSlides).y = y;
    result(countSlides).w = w;
    result(countSlides).h = h;
    result(countSlides).maxW = maxW;
    result(countSlides).maxH = maxH;
    countSlides = countSlides+1;
    
end


