%% Test function to see if sameFace.m works properly
function testSameImages()

    global simmilarityRate;
    simmilarityRate = 0.5;

    source_path = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY\Videos\EE6B5EA5-9ABF-32DA-9709-AAFEB23BB51E_slides';

    file_slides = load([source_path '\' 'result_slide' '.mat']);
    file_slides = file_slides.result;
    
    id_photo_plate = 178; % The photo that supposedly has a plate
    
    subphotos_ids = getSubphotos(id_photo_plate, file_slides);
    subphotos_data = getSubphotosData(id_photo_plate, subphotos_ids, file_slides);
    
    len = length(subphotos_ids);
    % Gets the ids of all the photos that match the one with the plate
    idsToRemove= [];
    for i = 1:len
        if(sameFace(subphotos_data, i, len+1))
            idsToRemove = [idsToRemove subphotos_ids(i)];
        end
    end
    
end


function ids = getSubphotos(id, data)

    len = length(data);
    ids = []; 
    for i = 1:len
        % If has the same photo but not the same subphoto
        if(strcmp(data(i).id_photo, data(id).id_photo) && ~strcmp(data(i).id_subphoto, data(id).id_subphoto))
            ids = [ids i];
        end
    end

end


function result = getSubphotosData(plate, ids, data)

    len = length(ids);
    result = zeros(4, len+1);
    
    result(:,len+1) = [data(plate).x  data(plate).y  data(plate).w  data(plate).h];
    for i = 1:len
        result(:,i) =  [data(ids(i)).x  data(ids(i)).y  data(ids(i)).w  data(ids(i)).h];
    end

end




