
function analyseForestResults()
    
    load('test_data.mat');
    test_name = {'[1] KNN + LDA - Single Sets - No Prototypes'; '[2] KNN + LDA - Single Sets - OnePerClass'; ...
        '[3] KNN + LDA - Single Sets - OnePerLeaf'; '[4] AdaBoost + LDA - Single Sets - OnePerClass'; ...
        '[5] KNN + LMNN (k=3) - Single Sets - OnePerClass'; '[6] AdaBoost + LMNN (k=3) - Single Sets - OnePerClass'; ...
        '[7] KNN + LDA - Join Days Sets - OnePerClass'; '[8] No Classifier + LDA - Join All Sets - No Prototypes'; ...
        '[9] KNN + Single Linkage - Single Sets - OnePerClass'; '[10] No Classifier + LDA - Single Sets - OnePerClass'; ...
        '[11] KNN + LMNN (k=7) - Single Sets - OnePerClass'; '[12] AdaBoost + LMNN (k=7) - Single Sets - OnePerClass'; ...
        '[13] (Dasgupta) No Classifier + Single Linkage - Single Sets - No Prototypes'};
    
    colors = {  [0 0 1;0 1 0;1 0 0]; ...
                [0 0 1;0 1 0;1 0 0]; ...
                [0 0 1;0 1 0;1 0 0; 1 1 0]; ...
                [0 0 1;0 1 0;1 0 0]; ...
                [0 0 1;0 1 0;1 0 0; 0 1 1; 1 0 0; 0 1 1; 1 1 0] };
    
    test_groups = {[1 2 3];[2 7 8];[2 5 11 9];[2 4 10];[2 4 5 6 11 12 13]};
    name_groups = {'Protoypes';'Sets division';'Active Learner';'Online Learner'; 'Online & Active Learners'};
    
    
    %% Separates the types of tests by the number of sets
    lengths = [];
    idx = {};
    dif_tests = {};
    count = 1;
%     for i = 1:length(test_data)
%         if(~any(lengths==length(test_data(i).set_data)))
%             lengths = [lengths length(test_data(i).set_data)];
%             dif_tests{count} = test_data(i);
%             idx{count} = i;
%             count = count+1;
%         else
%             dif_tests{find(lengths==length(test_data(i).set_data))} = [dif_tests{find(lengths==length(test_data(i).set_data))}; test_data(i)];
%             idx{find(lengths==length(test_data(i).set_data))} = [idx{find(lengths==length(test_data(i).set_data))}; i];
%         end
%     end
%     
%     
%     %% Absolute average clicks vs Sets graphic
%     for k = 1:length(dif_tests)
%         sub_test_data = dif_tests{k};
%         
%         figure
%         for i = 1:length(sub_test_data) % For each different test
%             clicks = [];
%             set_names = {};
%             for j = 1:length(sub_test_data(i).set_data)
%                 clicks = [clicks; sub_test_data(i).set_data(j).avg_num_clicks];
%                 set_names{j} = sub_test_data(i).set_data(j).set_name;
%             end
% 
%             plot(clicks);
%             hold all;
% 
% 
%             % Reduce the size of the axis so that all the labels fit in the figure.
%             pos = get(gca,'Position');
%             set(gca,'Position',[pos(1), 0.35, pos(3) .60])
% 
%             Xt = 1:length(clicks);
%             Xl = [0 length(clicks)];
% 
%             ax = axis; % Current axis limits
%             axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
%             Yl = ax(3:4); % Y-axis limits
% 
%             t = text(Xt,Yl(1)*ones(1,length(Xt)), set_names);
%             set(t,'HorizontalAlignment','right','VerticalAlignment','top','Rotation',45, 'fontsize', 8);
% 
%             % Remove the default labels
%             set(gca,'XTickLabel','');
% 
%         end
%         title('Num clicks for each set.');
%         ylabel('Num Average Clicks');
%         legend(test_name{idx{k}(:)});
% 
% 
% 
%         %% Percentatge vs Sets graphic
%         figure
%         for i = 1:length(sub_test_data) % For each different test
%             clicks = [];
%             set_names = {};
%             for j = 1:length(sub_test_data(i).set_data)
%                 clicks = [clicks; sub_test_data(i).set_data(j).avg_num_clicks / sub_test_data(i).set_data(j).num_elements];
%                 set_names{j} = sub_test_data(i).set_data(j).set_name;
%             end
% 
%             plot(clicks);
%             hold all;
% 
% 
%             % Reduce the size of the axis so that all the labels fit in the figure.
%             pos = get(gca,'Position');
%             set(gca,'Position',[pos(1), 0.35, pos(3) .60])
% 
%             Xt = 1:length(clicks);
%             Xl = [0 length(clicks)];
% 
%             ax = axis; % Current axis limits
%             axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
%             Yl = ax(3:4); % Y-axis limits
% 
%             t = text(Xt,Yl(1)*ones(1,length(Xt)), set_names);
%             set(t,'HorizontalAlignment','right','VerticalAlignment','top','Rotation',45, 'fontsize', 8);
% 
%             % Remove the default labels
%             set(gca,'XTickLabel','');
% 
%         end
%         title('Percentatge clicks for each set.');
%         ylabel('Percentatge Clicks');
%         legend(test_name{idx{k}(:)});
% 
% 
%         %% Time vs Sets graphic
%         figure
%         maxim = 0;
%         minim = 100;
%         for i = 1:length(sub_test_data) % For each different test
%             times = [];
%             set_names = {};
%             for j = 1:length(sub_test_data(i).set_data)
%                 times = [times; sub_test_data(i).set_data(j).avg_time / sub_test_data(i).set_data(j).num_elements];
%                 set_names{j} = sub_test_data(i).set_data(j).set_name;
%             end
% 
%             if(maxim < max(times))
%                 maxim = max(times);
%             end
%             if(minim > min(times))
%                 minim = min(times);
%             end
% 
%             plot(times);
%             hold all;
% 
%         end
%         % Reduce the size of the axis so that all the labels fit in the figure.
%         pos = get(gca,'Position');
%         set(gca,'Position',[pos(1), 0.35, pos(3) .60])
% 
%         Xt = 1:length(times);
%         Xl = [0 length(times)];
% 
%         ax = axis; % Current axis limits
%         axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
%         Yl = ax(3:4); % Y-axis limits
% 
%         t = text(Xt,minim*ones(1,length(Xt)), set_names);
%         set(t,'HorizontalAlignment','right','VerticalAlignment','top','Rotation',45, 'fontsize', 8);
% 
%         % Remove the default labels
%         set(gca,'XTickLabel','');
% 
%         if(minim == maxim)
%             maxim = maxim + maxim*0.1;
%         end
%         ylim([minim maxim]);
%         title('Time spent for each set.');
%         ylabel('Time Spent / Num Samples');
%         legend(test_name{idx{k}(:)});
%         
%     end
    
    
    
    %% Average clicks and average time per test type
    clicks = zeros(1,length(test_data));
    time = zeros(1,length(test_data));
    for i = 1:length(test_data) % For each different test
        total_time = 0;
        total_elements = 0;
        total_clicks = 0;
        for j = 1:length(test_data(i).set_data)
            total_time = total_time + test_data(i).set_data(j).avg_time;
            total_elements = total_elements + test_data(i).set_data(j).num_elements;
            total_clicks = total_clicks + test_data(i).set_data(j).avg_num_clicks;
        end
        clicks(i) = total_clicks / total_elements;
        time(i) = total_time / total_elements;
    end
    
    for test_i = 1:length(test_groups)
        this_group = test_groups{test_i};
        this_group_name = name_groups{test_i};
        this_clicks = clicks(this_group);
        this_time = time(this_group);
        this_names = {};
        for i = 1:length(this_group)
            this_names{i} = test_name{this_group(i)};
        end
        
        %% Clicks
        figure
        f = bar(this_clicks);
        bar_child=get(f,'Children');
        set(bar_child,'CData',1:length(this_clicks));
        colormap(colors{test_i})

        % Reduce the size of the axis so that all the labels fit in the figure.
        pos = get(gca,'Position');
        set(gca,'Position',[pos(1), 0.5, pos(3) .4])

        Xt = 1:length(this_clicks);
        Xl = [0 length(this_clicks)];

        ax = axis; % Current axis limits
        axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
        Yl = ax(3:4); % Y-axis limits

        t = text(Xt,Yl(1)*ones(1,length(Xt)), this_names);
        set(t,'HorizontalAlignment','right','VerticalAlignment','top','Rotation',45, 'fontsize', 8);

        % Remove the default labels
        set(gca,'XTickLabel','');

        title({['Comparison name: ' this_group_name]; 'Average clicks for each test type'});
        ylabel('Average clicks per image');
        
        saveas(f, ['Plot Results/' num2str(test_i) '- ' this_group_name '_Clicks'], 'jpg');

        %% Time
        figure
        f = bar(this_time);
        bar_child=get(f,'Children');
        set(bar_child,'CData',1:length(this_time));
        colormap(colors{test_i})

        % Reduce the size of the axis so that all the labels fit in the figure.
        pos = get(gca,'Position');
        set(gca,'Position',[pos(1), 0.5, pos(3) .4])

        Xt = 1:length(this_time);
        Xl = [0 length(this_time)];

        ax = axis; % Current axis limits
        axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
        Yl = ax(3:4); % Y-axis limits

        t = text(Xt,Yl(1)*ones(1,length(Xt)), this_names);
        set(t,'HorizontalAlignment','right','VerticalAlignment','top','Rotation',45, 'fontsize', 8);

        % Remove the default labels
        set(gca,'XTickLabel','');

        title({['Comparison name: ' this_group_name]; 'Average time for each test type (seconds)'});
        ylabel('Average time per image');
        
        saveas(f, ['Plot Results/' num2str(test_i) '- ' this_group_name '_Time'], 'jpg');
        
    end
    
    
    %% Mean and Std deviation (time and clicks)
    clc
    
    % Test Names
    disp('Test Names');
    disp(' ');
    for i = 1:length(test_data)
        disp(test_name{i});
    end
    
    % Clicks
    disp(' ');
    disp('CLICKS');
    disp(' ');
    disp('Test Name                     Mean         Std Deviation       Num. Tests');
    disp(' ');
    for i = 1:length(test_data)
        disp(['[' num2str(i) ']  ' num2str(test_data(i).mean_clicks) '  ' num2str(test_data(i).deviation_clicks) '  ' num2str(test_data(i).num_tests)]);
    end
    
    % Time
    disp(' ');
    disp('TIME');
    disp(' ');
    disp('Test Name                     Mean         Std Deviation       Num. Tests');
    disp(' ');
    for i = 1:length(test_data)
        disp(['[' num2str(i) ']  ' num2str(test_data(i).mean_time) '  ' num2str(test_data(i).deviation_time) '  ' num2str(test_data(i).num_tests)]);
    end

    % C_normal
    disp(' ');
    disp('NORMAL CLUSTERS');
    disp(' ');
    disp('Test Name                     Mean         Std Deviation       Num. Tests');
    disp(' ');
    for i = 1:length(test_data)
        disp(['[' num2str(i) ']  ' num2str(test_data(i).mean_C_normal) '  ' num2str(test_data(i).deviation_C_normal) '  ' num2str(test_data(i).num_tests)]);
    end
    
    % C_pure
    disp(' ');
    disp('PURE CLUSTERS');
    disp(' ');
    disp('Test Name                     Mean         Std Deviation       Num. Tests');
    disp(' ');
    for i = 1:length(test_data)
        disp(['[' num2str(i) ']  ' num2str(test_data(i).mean_C_pure) '  ' num2str(test_data(i).deviation_C_pure) '  ' num2str(test_data(i).num_tests)]);
    end
    
end




    
    