
function getForestResults()
    
    %% Initilization
    test_name = {'[1] KNN + LDA - Single Sets - No Prototypes'; '[2] KNN + LDA - Single Sets - OnePerClass'; ...
        '[3] KNN + LDA - Single Sets - OnePerLeaf'; '[4] AdaBoost + LDA - Single Sets - OnePerClass'; ...
        '[5] KNN + LMNN (k=3) - Single Sets - OnePerClass'; '[6] AdaBoost + LMNN (k=3) - Single Sets - OnePerClass'; ...
        '[7] KNN + LDA - Join Days Sets - OnePerClass'; '[8] No Classifier + LDA - Join All Sets - No Prototypes'; ...
        '[9] KNN + Single Linkage - Single Sets - OnePerClass'; '[10] No Classifier + LDA - Single Sets - OnePerClass'; ...
        '[11] KNN + LMNN (k=7) - Single Sets - OnePerClass'; '[12] AdaBoost + LMNN (k=7) - Single Sets - OnePerClass'; ...
        '[13] (Dasgupta) No Classifier + Single Linkage - Single Sets - No Prototypes'};
    
    
    numDifferentTests = length(test_name);
    data_path = '../Results/';
    data_dirs = dir(data_path);
    data_dirs = data_dirs(3:end);
    
    
    files = {};
    for i = 1:numDifferentTests
        files{i} = [];
    end
    
    %% Gets the files of each kind of test
    for i = 1:length(data_dirs)
       
        load([data_path data_dirs(i).name '/forest_simulation_data.mat']);
        
        for j = 1:length(forest_simulation_data.labeling_data)
            forest_simulation_data.labeling_data(j).features = [];
            forest_simulation_data.labeling_data(j).labels_result = [];
            forest_simulation_data.labeling_data(j).num_clicks_array = sum(forest_simulation_data.labeling_data(j).num_clicks_array);
            forest_simulation_data.labeling_data(j).C_normal = length(forest_simulation_data.labeling_data(j).C_normal);
            forest_simulation_data.labeling_data(j).C_pure = length(forest_simulation_data.labeling_data(j).C_pure);
        end
        
        % No prototypes
        if(~forest_simulation_data.usingPrototypes)
            if(forest_simulation_data.test_type == 1 && forest_simulation_data.activeLearnerType == 2)
                files{1} = [files{1}; forest_simulation_data];
            elseif(forest_simulation_data.test_type == 1 && forest_simulation_data.activeLearnerType == 1)
                files{13} = [files{13}; forest_simulation_data];
            elseif(forest_simulation_data.test_type == 3)
                files{8} = [files{8}; forest_simulation_data];
            end
        % Prototypes type OnePerClass
        elseif(forest_simulation_data.prototypesType == 1)
            if(forest_simulation_data.activeLearnerType == 2 && forest_simulation_data.usingOnlineLearner == false)
                files{10} = [files{10}; forest_simulation_data];
            elseif(forest_simulation_data.activeLearnerType == 2 && forest_simulation_data.classifierType == 1 && forest_simulation_data.test_type == 1)
                files{2} = [files{2}; forest_simulation_data];
            elseif(forest_simulation_data.activeLearnerType == 2 && forest_simulation_data.classifierType == 0)
                files{4} = [files{4}; forest_simulation_data];
            elseif(forest_simulation_data.activeLearnerType == 3 && forest_simulation_data.classifierType == 1 && forest_simulation_data.k_LMNN == 3)
                files{5} = [files{5}; forest_simulation_data];
            elseif(forest_simulation_data.activeLearnerType == 3 && forest_simulation_data.classifierType == 1 && forest_simulation_data.k_LMNN == 7)
                files{11} = [files{11}; forest_simulation_data];
            elseif(forest_simulation_data.activeLearnerType == 3 && forest_simulation_data.classifierType == 0 && forest_simulation_data.k_LMNN == 3)
                files{6} = [files{6}; forest_simulation_data];
            elseif(forest_simulation_data.activeLearnerType == 3 && forest_simulation_data.classifierType == 0 && forest_simulation_data.k_LMNN == 7)
                files{12} = [files{12}; forest_simulation_data];
            elseif(forest_simulation_data.activeLearnerType == 2 && forest_simulation_data.classifierType == 1 && forest_simulation_data.test_type == 2)
                files{7} = [files{7}; forest_simulation_data];
            elseif(forest_simulation_data.activeLearnerType == 1 && forest_simulation_data.classifierType == 1)
                files{9} = [files{9}; forest_simulation_data];
            end
        % Prototypes type OnePerLeaf
        elseif(forest_simulation_data.prototypesType == 2)
            files{3} = [files{3}; forest_simulation_data];
        end
        
        disp([num2str(i) '/' num2str(length(data_dirs)) ' files loaded.']);
        
    end
    
    %% Calculates the average data per each set in each test type
    test_data = struct('set_data', {}, 'repetition_data', {}, 'avg_num_clicks', {}, 'avg_time', {}, 'num_tests', {}, 'deviation_clicks', {}, 'deviation_time', {}, 'mean_clicks', {}, 'mean_time', {}, 'mean_C_pure', {}, 'mean_C_normal', {}, 'deviation_C_pure', {}, 'deviation_C_normal', {});
    for i = 1:numDifferentTests % For each type of test
        set_data = struct('avg_num_clicks', {}, 'avg_time', {}, 'num_elements', {}, 'set_name', {}, 'avg_C_normal_length', {}, 'avg_C_pure_length', {});
        repetition_data = struct('total_num_clicks', {}, 'total_time', {}, 'C_normal_length', {}, 'C_pure_length', {});
        
        files_this = files{i};
        test_data(i).num_tests = length(files_this);
        file = files_this(1);
        numSets = length(file.labeling_data);
        
        %% Means for each set 
        for j = 1:numSets % For each set
            set_data(j).set_name = file.labeling_data(j).set_name;
            set_data(j).num_elements = file.labeling_data(j).num_elements;
            acum_clicks = 0; acum_time = 0;
            acum_C_normal_length = 0; acum_C_pure_length = 0;
            
            for k = 1:length(files_this) % For each repeated test
                acum_clicks = acum_clicks + files_this(k).labeling_data(j).num_clicks_array;
                acum_time = acum_time + files_this(k).labeling_data(j).time;
                acum_C_normal_length = acum_C_normal_length + files_this(k).labeling_data(j).C_normal;
                acum_C_pure_length = acum_C_pure_length + files_this(k).labeling_data(j).C_pure;
            end
            
            set_data(j).avg_num_clicks = acum_clicks / test_data(i).num_tests;
            set_data(j).avg_time = acum_time / test_data(i).num_tests;
            set_data(j).avg_C_normal_length = acum_C_normal_length / test_data(i).num_tests;
            set_data(j).avg_C_pure_length = acum_C_pure_length / test_data(i).num_tests;
        end
        
        test_data(i).set_data = set_data;
        acum_clicks = 0; acum_time = 0;
        for j = 1:numSets % For each set
            acum_clicks = acum_clicks + set_data(j).avg_num_clicks;
            acum_time = acum_time + set_data(j).avg_time;
        end
        test_data(i).avg_num_clicks = acum_clicks / numSets;
        test_data(i).avg_time = acum_time / numSets;
        
        %% Means and deviation for each test repetition
        for k = 1:length(files_this) % For each test repetition
            acum_clicks = 0; acum_time = 0;
            acum_C_normal_length = 0; acum_C_pure_length = 0;
            
            for j = 1:numSets % For each set
                acum_clicks = acum_clicks + files_this(k).labeling_data(j).num_clicks_array;
                acum_time = acum_time + files_this(k).labeling_data(j).time;
                acum_C_normal_length = acum_C_normal_length + files_this(k).labeling_data(j).C_normal;
                acum_C_pure_length = acum_C_pure_length + files_this(k).labeling_data(j).C_pure;
            end

            repetition_data(k).total_num_clicks = acum_clicks;
            repetition_data(k).total_time = acum_time;
            repetition_data(k).C_normal_length = acum_C_normal_length;
            repetition_data(k).C_pure_length = acum_C_pure_length;
        end
        
        test_data(i).repetition_data = repetition_data;
        acum_clicks = [];
        acum_time = [];
        acum_C_pure = [];
        acum_C_normal = [];
        for k = 1:length(files_this) % For each test repetition
            acum_clicks = [acum_clicks repetition_data(k).total_num_clicks];
            acum_time = [acum_time repetition_data(k).total_time];
            acum_C_pure = [acum_C_pure repetition_data(k).C_pure_length];
            acum_C_normal = [acum_C_normal repetition_data(k).C_normal_length];
        end
        test_data(i).mean_clicks = mean(acum_clicks);
        test_data(i).mean_time = mean(acum_time);
        test_data(i).deviation_clicks = std(acum_clicks);
        test_data(i).deviation_time = std(acum_time);
        test_data(i).mean_C_pure = mean(acum_C_pure);
        test_data(i).mean_C_normal = mean(acum_C_normal);
        test_data(i).deviation_C_pure = std(acum_C_pure);
        test_data(i).deviation_C_normal = std(acum_C_normal);
            
    end
    
    %% Saves data
    save('test_data.mat', 'test_data');
    
    disp('Test Data Saved.');
    
end