
function getOLPerformance()
    
    test_name = {'KNN'; 'AdaBoost'};

    numDifferentTests = length(test_name);
    data_path = '../Results OL Performance/';
    data_dirs = dir(data_path);
    data_dirs = data_dirs(3:end);
    
    files = {};
    for i = 1:numDifferentTests
        files{i} = [];
    end
    
    %% Gets the files of each kind of test
    for i = 1:length(data_dirs)
        
        load([data_path data_dirs(i).name '/forest_simulation_data.mat']);
        
        for j = 1:length(forest_simulation_data.labeling_data)
            forest_simulation_data.labeling_data(j).features = [];
            forest_simulation_data.labeling_data(j).labels_result = [];
            forest_simulation_data.labeling_data(j).num_clicks_array = sum(forest_simulation_data.labeling_data(j).num_clicks_array);
            forest_simulation_data.labeling_data(j).C_normal = length(forest_simulation_data.labeling_data(j).C_normal);
            forest_simulation_data.labeling_data(j).C_pure = length(forest_simulation_data.labeling_data(j).C_pure);
        end
        
        if(forest_simulation_data.classifierType == 0)
            files{2} = [files{2}; forest_simulation_data];
        elseif(forest_simulation_data.classifierType == 1)
            files{1} = [files{1}; forest_simulation_data];
        end
        
        disp([num2str(i) '/' num2str(length(data_dirs)) ' files loaded.']);
        
    end
        
    test_OL_data = struct('num_tests', {}, 'avg_time', {}, 'avg_predicted', {}, 'set_data', {});
    for i = 1:numDifferentTests
        set_data = struct('time', {}, 'predicted', {});

        files_this = files{i};
        test_OL_data(i).num_tests = length(files_this);
        file = files_this(1);
        numSets = length(file.labeling_data);
        len_predicted = length(file.labeling_data(1).count_predicted);

        %% Means for each set 
        acum_time_total = 0;
        acum_predicted_total = zeros(1, len_predicted);
        for j = 2:numSets % For each set
            acum_time = 0;
            acum_predicted = zeros(1, len_predicted);
            for k = 1:length(files_this)
                acum_time = acum_time + files_this(k).labeling_data(j).time_classifier;
                acum_time_total = acum_time_total + files_this(k).labeling_data(j).time_classifier;
                for l = 1:len_predicted
                    acum_predicted(l) = acum_predicted(l) + files_this(k).labeling_data(j).count_predicted{l};
                    acum_predicted_total(l) = acum_predicted_total(l) + files_this(k).labeling_data(j).count_predicted{l};
                end
            end
           set_data(j-1).time = acum_time/length(files_this);
           set_data(j-1).predicted = acum_predicted/length(files_this);
        end
        test_OL_data(i).avg_time = acum_time_total / length(files_this) / (numSets-1);
        test_OL_data(i).avg_predicted = acum_predicted_total / length(files_this) / (numSets-1);
        test_OL_data(i).set_data = set_data;

    end
        
    
    save('test_OL_data.mat', 'test_OL_data');
    
end