
% Joins all the sets in one folder or all the sets of one day in a single
% folder
function joinSets()
    
    %% Init variables

    % {1 = JoinAll; 2 = JoinDays}
    joinMode = 2;
    
    file_format = '.jpg';
    
    % Gets path to data and to results
    pathh = mfilename('fullpath');
    pathh = regexp(pathh, '\', 'split');
    auxpath = pathh{1};
    for i = 2:(length(pathh) - 3)
        auxpath = [auxpath '\' pathh{i}];
    end
    data_path = [auxpath '\Labeling\Demo Labeling - WORKING COPY\Videos'];
    results_path = [auxpath '\Labeling\Demo Labeling - WORKING COPY\result_files'];
    
    resolution = [89 120];
    
    dest_folders = {'0BC25B01-7420-DD20-A1C8-3B2BD6C87CB0_3to62_slides'; ...
        '6FD1B048-A2F2-4CAB-1EFE-266503F59CD3_81to120_slides'; ...
        '650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides'; ...
        'D165DFFA-B41D-26BC-4C16-BFB23F981BE8_3783to3868_slides'; ...
        'Dishes images_renamed_1to100_slides'; ...
        'EE6B5EA5-9ABF-32DA-9709-AAFEB23BB51E_150to350_slides'; ...
        'FD214597-9360-9CA1-9393-914D9B7BB726_3844to3903_slides'};

    
    source_folders = {
        {'0BC25B01-7420-DD20-A1C8-3B2BD6C87CB0_3to62_slides-part1'; '0BC25B01-7420-DD20-A1C8-3B2BD6C87CB0_3to62_slides-part2'; '0BC25B01-7420-DD20-A1C8-3B2BD6C87CB0_3to62_slides-part3'};
        {'6FD1B048-A2F2-4CAB-1EFE-266503F59CD3_81to120_slides-part1'; '6FD1B048-A2F2-4CAB-1EFE-266503F59CD3_81to120_slides-part2'};
        {'650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part1'; '650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part2'; '650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part3'; '650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part4'; '650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part5'};
        {'D165DFFA-B41D-26BC-4C16-BFB23F981BE8_3783to3868_slides-part1'; 'D165DFFA-B41D-26BC-4C16-BFB23F981BE8_3783to3868_slides-part2'; 'D165DFFA-B41D-26BC-4C16-BFB23F981BE8_3783to3868_slides-part3'};
        {'Dishes images_renamed_1to100_slides-part1-part1'; 'Dishes images_renamed_1to100_slides-part1-part2'; 'Dishes images_renamed_1to100_slides-part2-part1'; 'Dishes images_renamed_1to100_slides-part2-part2'};
        {'EE6B5EA5-9ABF-32DA-9709-AAFEB23BB51E_150to350_slides-part1'; 'EE6B5EA5-9ABF-32DA-9709-AAFEB23BB51E_150to350_slides-part2'; 'EE6B5EA5-9ABF-32DA-9709-AAFEB23BB51E_150to350_slides-part3'; 'EE6B5EA5-9ABF-32DA-9709-AAFEB23BB51E_150to350_slides-part4'};
        {'FD214597-9360-9CA1-9393-914D9B7BB726_3844to3903_slides-part1'; 'FD214597-9360-9CA1-9393-914D9B7BB726_3844to3903_slides-part2'; 'FD214597-9360-9CA1-9393-914D9B7BB726_3844to3903_slides-part3'}
        };

    
    
    %% Creates and fills big images folder/s
    
    if(joinMode == 1) % JoinAll
        disp('Starting big images JOIN ALL.'); disp(' ');
        
        if(exist([data_path '\All Folders']))
            rmdir([data_path '\All Folders'], 's');
        end
        mkdir([data_path '\All Folders']);
        
        count = 1;
        % For each day
        for day = 1:length(source_folders)
            % For each set
            for set = 1:length(source_folders{day})

                sub_count = 1;
                disp(source_folders{day}{set});
                files = dir([data_path '\' source_folders{day}{set} '\*' file_format]);
                numFiles = length(files);
                for k = 1:numFiles
                    name = strcat(sprintf('%06d', count), file_format);
                    copyfile([data_path '\' source_folders{day}{set} '\' files(k).name], [data_path '\All Folders\' name])
                    count = count+1;
                    sub_count = sub_count+1;
                    if(mod(sub_count,500) == 0)
                        disp([num2str(sub_count) '/' num2str(numFiles) ' copied']);
                    end
                end
                disp([num2str(numFiles) '/' num2str(numFiles) ' copied']);
                
            end
        end
        
        
    elseif(joinMode == 2) % JoinDays
        disp('Starting big images JOIN DAYS.'); disp(' ');
        
        % For each day
        for day = 1:length(source_folders)
            count = 1;
            
            if(exist([data_path '\' dest_folders{day}]))
                rmdir([data_path '\' dest_folders{day}], 's');
            end
            mkdir([data_path '\' dest_folders{day}]);
            
            % For each set
            for set = 1:length(source_folders{day})

                sub_count = 1;
                disp(source_folders{day}{set});
                files = dir([data_path '\' source_folders{day}{set} '\*' file_format]);
                numFiles = length(files);
                for k = 1:numFiles
                    name = strcat(sprintf('%06d', count), file_format);
                    copyfile([data_path '\' source_folders{day}{set} '\' files(k).name], [data_path '\' dest_folders{day} '\' name])
                    count = count+1;
                    sub_count = sub_count+1;
                    if(mod(sub_count,500) == 0)
                        disp([num2str(sub_count) '/' num2str(numFiles) ' copied']);
                    end
                end
                disp([num2str(numFiles) '/' num2str(numFiles) ' copied']);
                
            end
        end
        
    end
    
    
    %% Creates and fills small images folder/s
    res = ['_' num2str(resolution(1)) 'x' num2str(resolution(2))];
    
    if(joinMode == 1) % JoinAll
        disp(' '); disp('Starting small images JOIN ALL.'); disp(' ');
        F = [];
        labels_result = struct('name', {}, 'label', {}); 
        
        % Creates Videos file
        if(exist([data_path '\All Folders' res]))
            rmdir([data_path '\All Folders' res], 's');
        end
        mkdir([data_path '\All Folders' res]);
        
        % Creates result_files file
        if(exist([results_path '\All Folders' res]))
            rmdir([results_path '\All Folders' res], 's');
        end
        mkdir([results_path '\All Folders' res]);

        count = 1;
        % For each day
        for day = 1:length(source_folders)
            % For each set
            for set = 1:length(source_folders{day})

                sub_count = 1;
                disp([source_folders{day}{set} res]);
                files = dir([data_path '\' source_folders{day}{set} res '\*' file_format]);
                % Gets with all the labels
                this_labels = load([results_path '\' source_folders{day}{set} res '\labels_result_' source_folders{day}{set} res '.mat']);
                this_labels = this_labels.labels_result;
                % Appends with all the features
                features = load([data_path '\' source_folders{day}{set} res '\features.mat']);
                F = [F; features.F];
                numFiles = length(files);
                for k = 1:numFiles
                    name = strcat(sprintf('%06d', count), file_format);
                    % Saves file
                    copyfile([data_path '\' source_folders{day}{set} res '\' files(k).name], [data_path '\All Folders' res '\' name])
                    % Gets label
                    labels_result(count).name = name;
                    labels_result(count).label = this_labels(sub_count).label;
                    count = count+1;
                    sub_count = sub_count+1;
                    if(mod(sub_count,500) == 0)
                        disp([num2str(sub_count) '/' num2str(numFiles) ' copied']);
                    end
                end
                disp([num2str(numFiles) '/' num2str(numFiles) ' copied']);
                
            end
        end
        % Saves all the features
        save([data_path '\All Folders' res '\features.mat'], 'F');
        disp('features.mat file saved.');
        % Saves all the labels
        save([results_path '\All Folders' res '\labels_result_All Folders' res '.mat'], 'labels_result');
        disp('labels_result.mat file saved.');
        
    elseif(joinMode == 2) % JoinDays
        disp(' '); disp('Starting small images JOIN DAYS.'); disp(' ');
        
        % For each day
        for day = 1:length(source_folders)
            count = 1;
            
            F = [];
            labels_result = struct('name', {}, 'label', {}); 

            % Creates Videos file
            if(exist([data_path '\' dest_folders{day} res]))
                rmdir([data_path '\' dest_folders{day} res], 's');
            end
            mkdir([data_path '\' dest_folders{day} res]);

            % Creates result_files file
            if(exist([results_path '\' dest_folders{day} res]))
                rmdir([results_path '\' dest_folders{day} res], 's');
            end
            mkdir([results_path '\' dest_folders{day} res]);
            
            % For each set
            for set = 1:length(source_folders{day})

                sub_count = 1;
                disp([source_folders{day}{set} res]);
                files = dir([data_path '\' source_folders{day}{set} res '\*' file_format]);
                % Gets with all the labels
                this_labels = load([results_path '\' source_folders{day}{set} res '\labels_result_' source_folders{day}{set} res '.mat']);
                this_labels = this_labels.labels_result;
                % Appends with all the features
                features = load([data_path '\' source_folders{day}{set} res '\features.mat']);
                F = [F; features.F];
                numFiles = length(files);
                for k = 1:numFiles
                    name = strcat(sprintf('%06d', count), file_format);
                    % Saves file
                    copyfile([data_path '\' source_folders{day}{set} res '\' files(k).name], [data_path '\' dest_folders{day} res '\' name])
                    % Gets label
                    labels_result(count).name = name;
                    labels_result(count).label = this_labels(sub_count).label;
                    count = count+1;
                    sub_count = sub_count+1;
                    if(mod(sub_count,500) == 0)
                        disp([num2str(sub_count) '/' num2str(numFiles) ' copied']);
                    end
                end
                disp([num2str(numFiles) '/' num2str(numFiles) ' copied']);
                
            end
            
            % Saves all the features
            save([data_path '\' dest_folders{day} res '\features.mat'], 'F');
            disp('features.mat file saved.');
            % Saves all the labels
            save([results_path '\' dest_folders{day} res '\labels_result_' dest_folders{day} res '.mat'], 'labels_result');
            disp('labels_result.mat file saved.');
            
        end
        
    end
    
    
    %% Finishing
    disp(' ');
    if(joinMode == 1)
        disp('Creating JOIN ALL done.');
    elseif(joinMode == 2)
        disp('Creating JOIN DAYS done.');
    end
    disp(' ');
    
end