
% Saves the generated data from the labeling of the 'set_struct'
% in the 'labeling_data' struct.
function labeling_data = saveData(labeling_data, set_struct)
    
    global last_time;
    global time_classifier;
    global countPredicted;

    id = length(labeling_data) + 1;
    
    % Gets the data
    load(['..\result_files\' set_struct '\features.mat']);
    features = F;
    load(['..\result_files\' set_struct '\num_clicks_array.mat']);
    load(['..\result_files\' set_struct '\C_normal.mat']);
    load(['..\result_files\' set_struct '\C_pure.mat']);
    load(['..\result_files\' set_struct '\labels_result_' set_struct '.mat']);
    
    num_elements = size(features,1);

    % Stores the data
    labeling_data(id).num_clicks_array = num_clicks_array;
    labeling_data(id).time = last_time;
    labeling_data(id).num_elements = num_elements;
    labeling_data(id).set_name = set_struct;
    labeling_data(id).C_normal = C_normal;
    labeling_data(id).C_pure = C_pure;
    labeling_data(id).labels_result = labels_result;
    labeling_data(id).features = features;
    labeling_data(id).time_classifier = time_classifier;
    labeling_data(id).count_predicted = countPredicted;
    
end