
% Trains all the classifiers using the sets described by 'sets' and
% the corresponding options
function trainClassifiers(sets, options)
    
    if(options.classifierType == 0)
        method = 'AdaBoost';
    elseif(options.classifierType == 1)
        method = 'KNN';
    end

    if(options.usingPrototypes || options.usingOnlineLearner)
        trainAndPrototypesSingleClassifier(method, options.k_KNN, true, sets);
        disp('Training classifiers 1/3');
    end
        
    if(options.usingOnlineLearner)
        trainCombinedClassifier1(method, options.k_KNN, true, sets);
        disp('Training classifiers 2/3');
        trainCombinedClassifier2(method, options.k_KNN, true, sets);
        disp('Training classifiers 3/3');
    end
    
end

