function cross_folders_2_labels_analysis()
    %% Variables initializations

    global classes;
    global app_path;
%     method = 'AdaBoost';
    method = 'KNN';
    
    app_path = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY';
%     dirTest = 'Dishes images_renamed_1to100_slides-part1-part2_89x120';
    dirTest = '650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part1_89x120';
    ids = {'Plate', 'Semi-plate'};
    used_labels = [2 3];
    addpath('C:\Users\Marc\Desktop\Treball Final de Grau\AdaBoost');
    loadClasses();
    videos_path = [app_path '\result_files'];
    
    numOldClasses = length(classes);
    numClasses = 2;
    numDivisions = 10;
    numTests = 1;
    numOfAdaBoostRounds = 1000;
    numNearestNeighboursKNN = 4;
    
    % Vectors to store all the results for all the tests
    vecTP = zeros(numTests,numClasses);
    vecTN = zeros(numTests,numClasses);
    vecFP = zeros(numTests,numClasses);
    vecFN = zeros(numTests,numClasses);
    vecSensitivity = zeros(numTests,numClasses);
    vecSpecificity = zeros(numTests,numClasses);
    
    % Vectors to store the average results
    avgTP = zeros(numClasses,1);
    avgFP = zeros(numClasses,1);
    avgTN = zeros(numClasses,1);
    avgFN = zeros(numClasses,1);
    avgSensitivity = zeros(numClasses,1);
    avgSpecificity = zeros(numClasses,1);
    
    % Likelihood matrix
    marginsLH = 0:0.05:1;
    likelihoodTP = {};
    likelihoodFP = {};
    for i = 1:numClasses;
        likelihoodTP{i} = {};
        likelihoodFP{i} = {};
        for j = 1:numTests
            likelihoodTP{i}{j} = {};
            likelihoodFP{i}{j} = {};
        end
    end
    
    labels_cell = {}; % Stores the different labels of our images
    
    %% Loads all the Ground Truth data
    
    % Gets the dir list
    fileList = dir([videos_path]);
    dirList = {};
    len = length(fileList);
    for i = 3:len
        if(isdir([videos_path '\' fileList(i).name]) && ~strcmp(fileList(i).name, dirTest))
            dirList = [dirList fileList(i).name];
        end
    end
    
    % Gets a cell with all the classes names
    for i = 1:numClasses
        labels_cell(i) = {['label_' num2str(classes(i).id)]};
    end
    
    
    % Counts the number of images for each label
    lenFiles = length(dirList);
    vecNumImgsTrain = zeros(numClasses,1);
    for i = 1:lenFiles
        labels_result = load([videos_path '\' dirList{i} '\labels_result_' dirList{i} '.mat']);
        labels_result = labels_result.labels_result;
        partialLen = size(labels_result, 2);
        
        for j = 1:partialLen
            label = labels_result(j).label;
            if(any(used_labels==label))
                vecNumImgsTrain(label-1) = vecNumImgsTrain(label-1) + 1;
            end
        end
    end
    
    % Counts the number of images for each label in the dirTest
    lenFiles = 1;
    vecNumImgsTest = zeros(numClasses,1);
    for i = 1:lenFiles
        labels_result = load([videos_path '\' dirTest '\labels_result_' dirTest '.mat']);
        labels_result = labels_result.labels_result;
        partialLen = size(labels_result, 2);
        
        for j = 1:partialLen
            label = labels_result(j).label;
            if(any(used_labels==label))
                vecNumImgsTest(label-1) = vecNumImgsTest(label-1) + 1;
            end
            %vecNumImgsTest(labels_result(j).label) = vecNumImgsTest(labels_result(j).label) + 1;
        end
    end
    
    
    %% Starts the numTests
    for t = 1:numTests
    
        %% Prepares the train and test data
        
        F_train = {}; % Stores a cell matrix with the list of features of for each label
        F_test = {};
        vecRandomPicks = {}; % stores the random ids that will be picked for the test
        
        % Loads one features file to know the needed length of the vector
        % We eliminate the features related to the Time (6 components)
        sizeTime = 6;
        features = load([videos_path '\' dirList{1} '\features.mat']);
        lenFeatures = size(features.F, 2);
        for i = 1:numClasses
            F_train{i} = zeros(vecNumImgsTrain(i),lenFeatures - sizeTime);
            F_test{i} = zeros(vecNumImgsTest(i),lenFeatures - sizeTime);
        end
    
        % Creates the cell to prepare the data
        vecCountTotal = ones(numClasses,1);
        vecCountNumTrain = ones(numClasses,1);
        vecCountNumTest = ones(numClasses,1);
        % Prepares Train Data
        lenFiles = length(dirList);
        for i = 1:lenFiles
            labels_result = load([videos_path '\' dirList{i} '\labels_result_' dirList{i} '.mat']);
            labels_result = labels_result.labels_result;
            partialLen = size(labels_result, 2);

            features = load([videos_path '\' dirList{i} '\features.mat']);
            features = features.F;

            for j = 1:partialLen
                label_id = labels_result(j).label;
                if(any(used_labels==label_id))
                    label_id = label_id - 1;
                
                    F_train{label_id}(vecCountNumTrain(label_id),:) = [features(j,(sizeTime+1):lenFeatures)];
                    vecCountNumTrain(label_id) = vecCountNumTrain(label_id) + 1;

                    vecCountTotal(label_id) = vecCountTotal(label_id) + 1;
                    
                end
            end
        end
        % Prepares Test Data
        lenFiles = 1;
        for i = 1:lenFiles
            labels_result = load([videos_path '\' dirTest '\labels_result_' dirTest '.mat']);
            labels_result = labels_result.labels_result;
            partialLen = size(labels_result, 2);

            features = load([videos_path '\' dirTest '\features.mat']);
            features = features.F;

            for j = 1:partialLen
                label_id = labels_result(j).label;
                if(any(used_labels==label_id))
                    label_id = label_id - 1;
                
                    F_test{label_id}(vecCountNumTest(label_id),:) = [features(j,(sizeTime+1):lenFeatures)];
                    vecCountNumTest(label_id) = vecCountNumTest(label_id) + 1;

                    vecCountTotal(label_id) = vecCountTotal(label_id) + 1;
                    
                end
            end
        end
        

        %% Trains and classifies
        disp(' ');
        disp(['--- ' 'Starting test ' num2str(t) '/' num2str(numTests) ' ---']);
        disp(' ');
        
        if(strcmp(method, 'AdaBoost'))
            
            % Creates the structure for the training and for the testing
            trainNorm = cell2struct(F_train', labels_cell, 1);
            testNorm = cell2struct(F_test', labels_cell, 1);

            % Trains the AdaBoost classifier
            trainedClassifiers = trainBOOST(false, trainNorm, numOfAdaBoostRounds, labels_cell, 'OneVsOne');
            % Tests the AdaBoost classifier
            [tests margins] = testBOOST(testNorm, labels_cell, trainedClassifiers);
            
        elseif(strcmp(method, 'KNN'))
            
            F = []; F_t = []; % features train and test
            L = []; L_t = []; % labels train and test(groundtruth)
            for i = 1:numClasses
                F = [F; F_train{i}];
                L = [L; ones(length(F_train{i}),1)*i];
                F_t = [F_t; F_test{i}];
                L_t = [L_t; ones(length(F_test{i}),1)*i];
            end
            
            %classifies
            trainedClassifier = ClassificationKNN.fit(F,L,'NumNeighbors',numNearestNeighboursKNN);
            % tests
            labels = predict(trainedClassifier,F_t);
        end
    
        
        %% Stores the results
        
        if(strcmp(method, 'AdaBoost'))
            % Calculates the resulting label for each image
            results = zeros(size(margins));
            labels = zeros(size(margins,1));
            for i = 1:size(margins,1)
                if(margins(i,1) > 0) % Class1 vs Class2
                    results(i,1) = results(i,1) + margins(i,1);
                else
                    results(i,2) = results(i,2) + abs(margins(i,1));
                end
                if(margins(i,2) > 0) % Class1 vs Class3
                    results(i,1) = results(i,1) + margins(i,2);
                else
                    results(i,3) = results(i,3) + abs(margins(i,2));
                end
                if(margins(i,3) > 0) % Class2 vs Class3
                    results(i,2) = results(i,2) + margins(i,3);
                else
                    results(i,3) = results(i,3) + abs(margins(i,3));
                end
                [c, j] = max(results(i,:));
                labels(i) = j;
            end
            
        elseif(strcmp(method, 'KNN'))
            
            results = zeros(length(labels), numClasses);
            
        end


        % Calculates TP, FP and FN
        countFP = zeros(numClasses,1);
        countTP = zeros(numClasses,1);
        countFN = zeros(numClasses,1);
        countTN = zeros(numClasses,1);
        specificity = zeros(numClasses,1);
        sensitivity = zeros(numClasses,1);
        
        
        % Calculates FPs, TPs, TNs and FNs
        for i = 1:sum(vecNumImgsTest)
            if(i <= vecNumImgsTest(1)) % No Plate
                if(labels(i) == 1)
                    countTP(1) = countTP(1) + 1;
                    likelihoodTP{1}{t} = [likelihoodTP{1}{t}; results(i, labels(i))/2];
                else
                    countFP(labels(i)) = countFP(labels(i)) + 1;
                    likelihoodFP{labels(i)}{t} = [likelihoodFP{labels(i)}{t};  results(i, labels(i))/2];
                end
            elseif(i <= (vecNumImgsTest(1)+vecNumImgsTest(2))) % Plate
                if(labels(i) == 2)
                    countTP(2) = countTP(2) + 1;
                    likelihoodTP{2}{t} = [likelihoodTP{2}{t}; results(i, labels(i))/2];
                else
                    countFP(labels(i)) = countFP(labels(i)) + 1;
                    likelihoodFP{labels(i)}{t} = [likelihoodFP{labels(i)}{t};  results(i, labels(i))/2];
                end
            elseif(i <= (vecNumImgsTest(1)+vecNumImgsTest(2)+vecNumImgsTest(3))) % Semi Plate
                if(labels(i) == 3)
                    countTP(3) = countTP(3) + 1;
                    likelihoodTP{3}{t} = [likelihoodTP{3}{t}; results(i, labels(i))/2];
                else
                    countFP(labels(i)) = countFP(labels(i)) + 1;
                    likelihoodFP{labels(i)}{t} = [likelihoodFP{labels(i)}{t};  results(i, labels(i))/2];
                end
            end

        end

        % Specificity and sensitivity
        for i = 1:numClasses
            countFN(i) = vecNumImgsTest(i) - countTP(i);
            countTN(i) = sum(vecNumImgsTest) - (countTP(i) + countFN(i) + countFP(i));
            sensitivity(i) = countTP(i)/(countTP(i)+countFN(i));
            specificity(i) = countTN(i)/(countTN(i)+countFP(i));
        end
        
        for i = 1:numClasses
            vecTP(t,i) = countTP(i);
            vecFP(t,i) = countFP(i);
            vecTN(t,i) = countTN(i); 
            vecFN(t,i) = countFN(i);
            vecSpecificity(t,i) = specificity(i);
            vecSensitivity(t,i) = sensitivity(i);
        end
        
    end
    
    %% Calculates average results
    for i = 1:numClasses
        avgTP(i) = sum(vecTP(:,i))/numTests;
        avgFP(i) = sum(vecFP(:,i))/numTests;
        avgTN(i) = sum(vecTN(:,i))/numTests;
        avgFN(i) = sum(vecFN(:,i))/numTests;
        avgSpecificity(i) = sum(vecSpecificity(:,i))/numTests;
        avgSensitivity(i) = sum(vecSensitivity(:,i))/numTests;
    end
    
    %% Shows result #TP vs #FP with likelihood
    if(strcmp(method, 'AdaBoost'))
        showFigureSpecVsSens(ids, likelihoodTP, likelihoodFP, marginsLH, numClasses, numOfAdaBoostRounds, numTests);
    end
        
    %% Shows results graphic bars
    
    % Displays the result in text format
    for i = 1:numClasses
        disp(['[Class ' num2str(i) ']:']);
        disp(['Total Imgs: ' num2str(vecCountTotal(i)) ', Test Imgs: ' num2str(vecNumImgsTest(i)) ', TP: ' num2str(avgTP(i)) ', FN: ' num2str(avgFN(i)) ', FP: ' num2str(avgFP(i)) ', TN: ' num2str(avgTN(i))]);
        disp(['          ' 'Specificity: ' num2str(avgSpecificity(i)) ', Sensitivity: ' num2str(avgSensitivity(i))]);
        disp(' ');
    end
    

    % Displays the result in a figure
    showFigureBars(method, ids, vecNumImgsTest', avgTP', avgFN', avgFP', numOfAdaBoostRounds, numTests);
    
    
end

% Displays a figure to see the comparison #TP vs #FP for different margins
% of likelihoods
% function showFigureSpecVsSens(ids, lhTP, lhFP, lhTN, lhFN, marginsLH, numClasses, numRounds, numTests)
function showFigureSpecVsSens(ids, lhTP, lhFP, marginsLH, numClasses, numRounds, numTests)

    lenMargins = length(marginsLH);
    countMarginsTP = zeros(numClasses, lenMargins-1, 1);
    countMarginsFP = zeros(numClasses, lenMargins-1, 1);
%     countMarginsTN = zeros(numClasses, lenMargins-1, 1);
%     countMarginsFN = zeros(numClasses, lenMargins-1, 1);
    sensitivityMargins = zeros(lenMargins-1,1);
    specificityMargins = zeros(lenMargins-1,1);

    for i = 1:numClasses
        for j = 1:numTests
            % Counts TP
            len = length(lhTP{i}{j});
            for k = 1:len
                l = 1;
                while(l <= lenMargins && marginsLH(l) < lhTP{i}{j}{k})
                    l = l+1;
                end
                countMarginsTP(i, l-1) = countMarginsTP(i, l-1) + 1;
            end
            
            % Counts FP
            len = length(lhFP{i}{j});
            for k = 1:len
                l = 1;
                while(l <= lenMargins && marginsLH(l) < lhFP{i}{j}{k})
                    l = l+1;
                end
                
                countMarginsFP(i, l-1) = countMarginsFP(i, l-1) + 1;
                
%                 if(l == 1) % if lhFP{i}{j}{k} == 0
%                     countMarginsFP(i, 1) = countMarginsFP(i, 1) + 1;
%                 else
%                     countMarginsFP(i, l-1) = countMarginsFP(i, l-1) + 1;
%                 end
            end
            
%             % Counts TN
%             len = length(lhTN{i}{j});
%             for k = 1:len
%                 l = 1;
%                 while(l <= lenMargins && marginsLH(l) < lhTN{i}{j}{k})
%                     l = l+1;
%                 end
%                 countMarginsTN(i, l-1) = countMarginsTN(i, l-1) + 1;
%             end
%             
%             % Counts FN
%             len = length(lhFN{i}{j});
%             for k = 1:len
%                 l = 1;
%                 while(l <= lenMargins && marginsLH(l) < lhFN{i}{j}{k})
%                     l = l+1;
%                 end
%                 countMarginsFN(i, l-1) = countMarginsFN(i, l-1) + 1;
%             end
            
        end
    end
    
    
    acumTP = fliplr(cumsum(fliplr(countMarginsTP),2));
    acumFP = fliplr(cumsum(fliplr(countMarginsFP),2));
    
%     for i = (lenMargins-1):-1:1
%         sumTP = sum(countMarginsTP);
%         sumTP = sum(sumTP(i:lenMargins-1));
%         sumFP = sum(countMarginsFP);
%         sumFP = sum(sumFP(i:lenMargins-1));
%         sumTN = sum(countMarginsTN);
%         sumTN = sum(sumTN(i:lenMargins-1));
%         sumFN = sum(countMarginsFN);
%         sumFN = sum(sumFN(i:lenMargins-1));
%         sensitivityMargins(i) = sumTP/(sumTP+sumFN);
%         specificityMargins(i) = (1 - sumTN/(sumTN+sumFP));
%     end
    
    precission = acumTP./(acumTP+acumFP);
    marginsLabels = [];
    margins = [];
    for i = 1:length(marginsLH)-1
        marginsLabels = [marginsLabels; {[num2str(marginsLH(i)) ' - ' num2str(marginsLH(i+1))]}];
        margins = [margins; (marginsLH(i)+marginsLH(i+1))/2];
    end
    
    for i = 1:numClasses
        figure
        
        bar(margins, precission(i,:));

        x = margins;
        % Set the X-Tick locations
        Xt = margins;
        Xl = [0 marginsLH(end)];
        set(gca,'XTick',Xt,'XLim',Xl);
        
        % Reduce the size of the axis so that all the labels fit in the figure.
        pos = get(gca,'Position');
        set(gca,'Position',[pos(1), 0.2, pos(3) .7])
        
        ax = axis; % Current axis limits
        axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
        Yl = ax(1:2); % Y-axis limits

        % Place the text labels
        t = text(Xt,Yl(1)*ones(1,length(precission(i,:))), marginsLabels);
        set(t,'HorizontalAlignment','right','VerticalAlignment','middle','Rotation',90);

        % Remove the default labels
        set(gca,'XTickLabel','');
        
        
        title({'Precision vs Margin'; ids{i}});
        ylabel('Precision');
        
    end

end


% Displays a figure to see the results of the test
function showFigureBars(method, names, num, tp, fn, fp, rounds, numTests)

    colors = [  0.2706  0.6157  0.8078;
                0.2000  1.0000  0.2000;
                0.8000  0.2000  0;
                0.9686  0.6824  0.1294  ];

    x = names;
    y = [num; tp; fn; fp]';

    % Creates the figure
    fig_h = figure;
    bar_h = bar(1:length(x), y);
   
    
    % Set the X-Tick locations
    Xt = 1:length(x);
    Xl = [0 length(x)+1.5];
    set(gca,'XTick',Xt,'XLim',Xl);

    ax = axis; % Current axis limits
    axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
    Yl = ax(3:4); % Y-axis limits
    
    % Place the text labels
    t = text(Xt,Yl(1)*ones(1,length(Xt)), x);
    set(t,'HorizontalAlignment','center','VerticalAlignment','top','Rotation',0);
    
    % Remove the default labels
    set(gca,'XTickLabel','');
    
    % Sets the color to each bar
	for i = 1:length(bar_h)
        set(bar_h(i),'facecolor',colors(i,:))
    end
    
    legend('Total','Average TP','Average FN','Average FP');
    if(strcmp(method, 'AdaBoost'))
        title(['AdaBoost rounds: ' num2str(rounds) '  |  Number of random tests: ' num2str(numTests)]);
    elseif(strcmp(method, 'KNN'))
        title(['KNN test  |  Number of random tests: ' num2str(numTests)]);
    end

end


% Loads the classes file
function loadClasses()
    global classes;
    global app_path;

    classes_path = app_path;
    
    file = [classes_path '/classesLabeling.mat'];
    if(exist(file, 'file'))
        data = load(file);
        classes = data.classes;
    end
end