
    addpath('C:\Users\Marc\Desktop\Treball Final de Grau\mLMNN2.3');
    addpath('../../Labeling/Demo Labeling - WORKING COPY/stable');
    addpath('../../MeanShift');
    cd '../../mLMNN2.3'
    install();
    clc
    cd '../Training-Test Analysis/Synthetic Data Analysis'

    global join_labels;
    global numNearestNeighboursKNN;
    
    global classNoPlate;
    global classPlate;
    global classSemiplate;
    
    join_labels = [2 3];
    numNearestNeighboursKNN = 15;
    classNoPlate.id = 1;
    classPlate.id = 2;
    classSemiplate.id = 3;
    
    % Synthetic Samples Generation
    sigma = 0.01;
    groups = 10;
    samplesPerGroup = 400;
    nFeatures = 94;
    
    nClasses = 3;
    nClusters = 2; 
    k_LMNN = 3;

    meanShiftB = 0.2;
    
    %% Random data
    [data, labels] = syntheticTestGenerator(groups, samplesPerGroup, nFeatures, sigma, nClasses);

    fig = figure;
    gscatter(data(:,1), data(:,2), labels, 'rgymb','o');
    legend('X', 'Y', 'Z');
    title('2 first components of the basic data');

    
    %% Balances the training data
    uniqueLabels = unique(labels);
    count = zeros(length(uniqueLabels), 1);
    posElems = {};
    for i = 1:length(uniqueLabels)
        posElems{i} = [];
    end
    for i = 1:length(labels)
        pos = find(uniqueLabels==labels(i));
        count(pos) = count(pos) +1;
        posElems{pos} = [posElems{pos} i];
    end
    numPicks = min(count);
    train_features = [];
    train_labels = [];
    for i = 1:length(uniqueLabels)
        % Picks the random indx to train
        M = posElems{i};
        p = randperm(length(M)); % Reshuffle their order randomly
        train_features = [train_features; data(M(p(1:numPicks)), :)]; % Choose the first "numPicks" of these
        train_labels = [train_labels; labels(M(p(1:numPicks)))];
    end
    

    %% PCA
    tic
    V_PCA = PCA(train_features);
    PCA_data = (data - repmat(mean(data), size(data,1), 1) ) * V_PCA;
    
    %% Balances the training data
    uniqueLabels = unique(labels);
    count = zeros(length(uniqueLabels), 1);
    posElems = {};
    for i = 1:length(uniqueLabels)
        posElems{i} = [];
    end
    for i = 1:length(labels)
        pos = find(uniqueLabels==labels(i));
        count(pos) = count(pos) +1;
        posElems{pos} = [posElems{pos} i];
    end
    numPicks = min(count);
    train_features_LDA = [];
    train_labels = [];
    for i = 1:length(uniqueLabels)
        % Picks the random indx to train
        M = posElems{i};
        p = randperm(length(M)); % Reshuffle their order randomly
        train_features_LDA = [train_features_LDA; PCA_data(M(p(1:numPicks)), :)]; % Choose the first "numPicks" of these
        train_labels = [train_labels; labels(M(p(1:numPicks)))];
    end
    
    
    %% LDA
    V_LDA = LDA(train_features_LDA, train_labels);
    LDA_data = PCA_data * V_LDA;
    
    % Figure LDA space
    fig = figure;
    gscatter(LDA_data(:,1), LDA_data(:,2), labels, 'rgymb','o');
    legend('X', 'Y', 'Z');
    title('LDA transformed data');
    timeLDA = toc;
    
    % Kmeans
    [cluster, centroid] = kmeans(LDA_data, nClusters, 'emptyaction', 'singleton');
    
    % Mean Shift
    [clustCent,point2cluster,clustMembsCell] = MeanShiftCluster(LDA_data',meanShiftB);
    
    %% LDA - KMeans
    
    % Figure kmeans
    fig2 = figure;
    c = {};
    lbls = [];
    comp1 = [];
    comp2 = [];
    lgnd = {};
    for i = 1:nClusters
        c{i} = find(cluster == i);
        lbls = [lbls; ones(length(c{i}),1)*i];
        comp1 = [comp1; LDA_data(c{i},1)];
        comp2 = [comp2; LDA_data(c{i},2)];
        lgnd{i} = ['Cluster ' num2str(i)];
    end
    gscatter(comp1, comp2, lbls, 'mbrgy','o');
    legend(lgnd);
    title('Clustering with KMeans of samples in LDA space');
    
    % Check error rate LDA - KMeans
    errorLDA = zeros(nClasses,1);
    classClusterLDA = zeros(nClusters,1);
    okCountLDA = zeros(nClusters,1);
    totalCountLDA = zeros(nClasses,1);
    for i = 1:nClusters
        maxClass = 0;
        class = 0;
        for j = 1:nClasses
            num = length(find(labels(c{i})==j));
            if(num > maxClass)
                maxClass = num;
                class = j;
            end
        end
        elemsOrig = find(labels==class);
        lenElems = length(elemsOrig);
        countOK = 0;
        for j = 1:lenElems
            countOK = countOK + any(c{i} == elemsOrig(j));
        end
        classClusterLDA(i) = class;
        okCountLDA(i) = countOK;
        totalCountLDA(class) = lenElems;
    end
    for i = 1:nClasses
        clustersThisClass = find(classClusterLDA==i);
        errorLDA(i) = 1 - (sum(okCountLDA(clustersThisClass)) / totalCountLDA(i));
    end
    
    %% LDA - Mean Shift
    
    % Figure meanshift
    fig2 = figure;
    c = {};
    lbls = [];
    comp1 = [];
    comp2 = [];
    lgnd = {};
    for i = 1:length(clustMembsCell)
        c{i} = find(point2cluster == i);
        lbls = [lbls; ones(length(c{i}),1)*i];
        comp1 = [comp1; LDA_data(c{i},1)];
        comp2 = [comp2; LDA_data(c{i},2)];
        lgnd{i} = ['Cluster ' num2str(i)];
    end
    gscatter(comp1, comp2, lbls, 'mbrgy','oooooxxxxx+++++');
    legend(lgnd);
    title('Clustering with MeanShift of samples in LDA space');
    
    
    % Check error rate LDA - MeanShift
    errorLDA_MS = zeros(nClasses,1);
    classClusterLDA_MS = zeros(length(clustMembsCell),1);
    okCountLDA_MS = zeros(length(clustMembsCell),1);
    totalCountLDA_MS = zeros(nClasses,1);
    for i = 1:length(clustMembsCell)
        maxClass = 0;
        class = 0;
        for j = 1:nClasses
            num = length(find(labels(c{i})==j));
            if(num > maxClass)
                maxClass = num;
                class = j;
            end
        end
        elemsOrig = find(labels==class);
        lenElems = length(elemsOrig);
        countOK = 0;
        for j = 1:lenElems
            countOK = countOK + any(c{i} == elemsOrig(j));
        end
        classClusterLDA_MS(i) = class;
        okCountLDA_MS(i) = countOK;
        totalCountLDA_MS(class) = lenElems;
    end
    for i = 1:nClasses
        clustersThisClass = find(classClusterLDA_MS==i);
        errorLDA_MS(i) = 1 - (sum(okCountLDA_MS(clustersThisClass)) / totalCountLDA_MS(i));
    end

    
    %% LMNN
    tic
    [L, Det] = lmnn2(train_features', train_labels', k_LMNN, 'outdim', 2, 'quiet', 1, 'maxiter', 50);
    LMNN_data = data * L';
    
    % Figure LMNN space
    fig = figure;
    gscatter(LMNN_data(:,1), LMNN_data(:,2), labels, 'rgymb','o');
    legend('X', 'Y', 'Z');
    title('LMNN transformed data');
    timeLMNN = toc;
    
    % Kmeans
    [cluster, centroid] = kmeans(LMNN_data, nClusters, 'emptyaction', 'singleton');
    
    % Mean Shift
    [clustCent,point2cluster,clustMembsCell] = MeanShiftCluster(LMNN_data',meanShiftB);
    
    %% LMNN - Kmeans
    
    % Figure kmeans
    fig2 = figure;
    c = {};
    lbls = [];
    comp1 = [];
    comp2 = [];
    lgnd = {};
    for i = 1:nClusters
        c{i} = find(cluster == i);
        lbls = [lbls; ones(length(c{i}),1)*i];
        comp1 = [comp1; LMNN_data(c{i},1)];
        comp2 = [comp2; LMNN_data(c{i},2)];
        lgnd{i} = ['Cluster ' num2str(i)];
    end
    gscatter(comp1, comp2, lbls, 'mbrgy','o');
    legend(lgnd);
    title('Clustering with KMeans of samples in LMNN space');
    timeLMNN = toc;
    
    % Check error rate
    errorLMNN = zeros(nClasses,1);
    classClusterLMNN = zeros(nClusters,1);
    okCountLMNN = zeros(nClusters,1);
    totalCountLMNN = zeros(nClasses,1);
    for i = 1:nClusters
        maxClass = 0;
        class = 0;
        for j = 1:nClasses
            num = length(find(labels(c{i})==j));
            if(num > maxClass)
                maxClass = num;
                class = j;
            end
        end
        elemsOrig = find(labels==class);
        lenElems = length(elemsOrig);
        countOK = 0;
        for j = 1:lenElems
            countOK = countOK + any(c{i} == elemsOrig(j));
        end
        classClusterLMNN(i) = class;
        okCountLMNN(i) = countOK;
        totalCountLMNN(class) = lenElems;
    end
    for i = 1:nClasses
        clustersThisClass = find(classClusterLMNN==i);
        errorLMNN(i) = 1 - (sum(okCountLMNN(clustersThisClass)) / totalCountLMNN(i));
    end
    
    
    
    %% LMNN - Mean Shift
    
    % Figure kmeans
    fig2 = figure;
    c = {};
    lbls = [];
    comp1 = [];
    comp2 = [];
    lgnd = {};
    for i = 1:length(clustMembsCell)
        c{i} = find(point2cluster == i);
        lbls = [lbls; ones(length(c{i}),1)*i];
        comp1 = [comp1; LMNN_data(c{i},1)];
        comp2 = [comp2; LMNN_data(c{i},2)];
        lgnd{i} = ['Cluster ' num2str(i)];
    end
    gscatter(comp1, comp2, lbls, 'mbrgy','oooooxxxxx+++++');
    legend(lgnd);
    title('Clustering with MeanShift of samples in LMNN space');

    
    % Check error rate
    errorLMNN_MS = zeros(nClasses,1);
    classClusterLMNN_MS = zeros(length(clustMembsCell),1);
    okCountLMNN_MS = zeros(length(clustMembsCell),1);
    totalCountLMNN_MS = zeros(nClasses,1);
    for i = 1:length(clustMembsCell)
        maxClass = 0;
        class = 0;
        for j = 1:nClasses
            num = length(find(labels(c{i})==j));
            if(num > maxClass)
                maxClass = num;
                class = j;
            end
        end
        elemsOrig = find(labels==class);
        lenElems = length(elemsOrig);
        countOK = 0;
        for j = 1:lenElems
            countOK = countOK + any(c{i} == elemsOrig(j));
        end
        classClusterLMNN_MS(i) = class;
        okCountLMNN_MS(i) = countOK;
        totalCountLMNN_MS(class) = lenElems;
    end
    for i = 1:nClasses
        clustersThisClass = find(classClusterLMNN_MS==i);
        errorLMNN_MS(i) = 1 - (sum(okCountLMNN_MS(clustersThisClass)) / totalCountLMNN_MS(i));
    end
    
    
    %% Results display
    clc
    
    disp(['Elapsed time LDA: ' num2str(timeLDA)]);
    disp('----- LDA & KMeans -----');
    for i = 1:nClasses
        disp(['Error class ' num2str(i) ': ' num2str(errorLDA(i))]);
    end
    
    disp(' ');
    
    disp('----- LDA & MeanShift -----');
    for i = 1:nClasses
        disp(['Error class ' num2str(i) ': ' num2str(errorLDA_MS(i))]);
    end
    
    disp(' ');
    
    disp(['Elapsed time LMNN: ' num2str(timeLMNN)]);
    disp('----- LMNN & KMeans -----');
    for i = 1:nClasses
        disp(['Error class ' num2str(i) ': ' num2str(errorLMNN(i))]);
    end
    
    disp(' ');
    
    disp('----- LMNN & MeanShift -----');
    for i = 1:nClasses
        disp(['Error class ' num2str(i) ': ' num2str(errorLMNN_MS(i))]);
    end
    
    disp(' ');
    disp(' ');
    disp('Tests Done.');
    
    