function X_fold_2_labels_analysis()
    %% Variables initializations

    addpath('auxCode');
    global classes;
    global app_path;
    method = 'AdaBoost';
%     method = 'KNN';
    
    % Says if the sets must be balanced
    balanced = true;
    
    app_path = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY';
    
    % Says if the FN must be saved on a folder to be relabeled
    saveFN = false;
    save_path = [app_path '/Videos'];
    format = '.jpg';
    
    % Determines if we want to get a sample of the nearest neighbours (KNN
    % of a high likelihood and a low likelihood sample.
    showNeighbours = false;
    
    ids = {'Plate', 'Semi-plate'};
    used_labels = [2 3];
    addpath('C:\Users\Marc\Desktop\Treball Final de Grau\AdaBoost and KNN');
    loadClasses();
    videos_path = [app_path '\result_files'];
    
    numOldClasses = length(classes);
    numClasses = 2;
    
    numDivisions = 10;
    
    numTests = 1;
    numOfAdaBoostRounds = 1500;
    numNearestNeighboursKNN = 15;
    
    % Creates a temporal folder for the results obtained in this test
    if(balanced)
        bal = 'Balanced';
    else
        bal = 'NonBalanced';
    end
    working_resolution = '89x120';
    
    if(strcmp(method, 'AdaBoost'))
        testFolder = ['TESTS/' num2str(numDivisions) '-fold ' num2str(numClasses) ' labels/' working_resolution ' ' method ' NR=' num2str(numOfAdaBoostRounds) ' NT=' num2str(numTests) ' ' bal];
    elseif(strcmp(method, 'KNN'))
        testFolder = ['TESTS/' num2str(numDivisions) '-fold ' num2str(numClasses) ' labels/' working_resolution ' ' method ' NN=' num2str(numNearestNeighboursKNN) ' NT=' num2str(numTests) ' ' bal];
    end
    
    if(isdir(testFolder))
        rmdir(testFolder, 's');
    end
    mkdir(testFolder);
    
    % Vectors to store all the results for all the tests
    vecTP = zeros(numTests,numClasses);
    vecTN = zeros(numTests,numClasses);
    vecFP = zeros(numTests,numClasses);
    vecFN = zeros(numTests,numClasses);
    vecSensitivity = zeros(numTests,numClasses);
    vecSpecificity = zeros(numTests,numClasses);
    
    % Vectors to store the average results
    avgTP = zeros(numClasses,1);
    avgFP = zeros(numClasses,1);
    avgTN = zeros(numClasses,1);
    avgFN = zeros(numClasses,1);
    avgSensitivity = zeros(numClasses,1);
    avgSpecificity = zeros(numClasses,1);
    
    % Likelihood matrix
    marginsLH = 0:0.05:1;
    likelihoodTP = {};
    likelihoodFP = {};
    for i = 1:numClasses;
        likelihoodTP{i} = {};
        likelihoodFP{i} = {};
        for j = 1:numTests
            likelihoodTP{i}{j} = {};
            likelihoodFP{i}{j} = {};
        end
    end
    
    labels_cell = {}; % Stores the different labels of our images
    
    %% Loads all the Ground Truth data
    
    % Gets the dir list
    fileList = dir([videos_path]);
    dirList = {};
    len = length(fileList);
    for i = 3:len
        if(isdir([videos_path '\' fileList(i).name]))
            dirList = [dirList fileList(i).name];
        end
    end
    
    % Gets a cell with all the classes names
    for i = 1:numClasses
        labels_cell(i) = {['label_' num2str(used_labels(i))]};
    end
    
    
    % Counts the number of images for each label
    lenFiles = length(dirList);
    vecNumImgsTrain = zeros(numClasses,1);
    vecNumImgsTest = zeros(numClasses,1);
    %%% Add fix code
    idxClasses = {};
    for i = 1:numClasses
        idxClasses{i} = [];
    end
    totalLength = 1;
    %%%
    for i = 1:lenFiles
        labels_result = load([videos_path '\' dirList{i} '\labels_result_' dirList{i} '.mat']);
        labels_result = labels_result.labels_result;
        partialLen = size(labels_result, 2);
        
        for j = 1:partialLen
            label = labels_result(j).label;
            if(any(used_labels==label))
                %%% Change fix code
                idxClasses{label-1} = [idxClasses{label-1} totalLength];
                vecNumImgsTrain(label-1) = vecNumImgsTrain(label-1) + 1;
            end
            totalLength = totalLength+1;
            %%%
            %vecNumImgsTrain(labels_result(j).label) = vecNumImgsTrain(labels_result(j).label) + 1;
        end
    end
    
    % Calculates the number of images in the training and in the test sets
    % Calculates the number of images in the training and in the test sets
    if(balanced)
        vecNumImgsTotal = vecNumImgsTrain;
        balancedNum = min(vecNumImgsTrain);
        for i = 1:numClasses
            vecNumImgsTest(i) = round(balancedNum*100/numDivisions/100);
            vecNumImgsTrain(i) = balancedNum - vecNumImgsTest(i);
        end
    else
        for i = 1:numClasses
            vecNumImgsTest(i) = round(vecNumImgsTrain(i)*100/numDivisions/100);
            vecNumImgsTrain(i) = vecNumImgsTrain(i) - vecNumImgsTest(i);
        end
    end
    
    %% Starts the numTests
    for t = 1:numTests
    
        %% Prepares the train and test data
        
        F_train = {}; % Stores a cell matrix with the list of features of for each label
        F_test = {};
        vecRandomPicks = {}; % stores the random ids that will be picked for the test
        
        % Loads one features file to know the needed length of the vector
        % We eliminate the features related to the Time (6 components)
        sizeTime = 6;
        features = load([videos_path '\' dirList{1} '\features.mat']);
        lenFeatures = size(features.F, 2);
        for i = 1:numClasses
            F_train{i} = zeros(vecNumImgsTrain(i),lenFeatures - sizeTime);
            F_test{i} = zeros(vecNumImgsTest(i),lenFeatures - sizeTime);

            %%% Change fix code
            % Picks the random indx to test
%             M = 1:(vecNumImgsTest(i)+vecNumImgsTrain(i));
            M = idxClasses{i};
            %%%
            p = randperm(length(M)); % Reshuffle their order randomly
            vecRandomPicks{i} = M(p(1:vecNumImgsTest(i))); % Choose the first N of these
            vecRandomPicks{i} = sort(vecRandomPicks{i}); % Sort them
            
            if(balanced)
                %%% Change fix code
                % Picks the random indx to train
%                 M = 1:(vecNumImgsTotal(i));
                M = idxClasses{i};
                for j = 1:length(vecRandomPicks{i})
                    M(find(M==vecRandomPicks{i}(j))) = [];% Eliminates the items already chosen as test
                end
%                 M(vecRandomPicks{i}) = []; % Eliminates the items already chosen as test
                %%%
                p = randperm(length(M)); % Reshuffle their order randomly
                vecRandomPicksTrain{i} = M(p(1:vecNumImgsTrain(i))); % Choose the first N of these
                vecRandomPicksTrain{i} = sort(vecRandomPicksTrain{i}); % Sort them
            end
            
        end
    
        % Creates the cell to prepare the data
        countTotal = 1;
%         vecCountTotal = ones(numClasses,1);
        vecCountNumTrain = ones(numClasses,1);
        vecCountNumTest = ones(numClasses,1);
        for i = 1:lenFiles
            labels_result = load([videos_path '\' dirList{i} '\labels_result_' dirList{i} '.mat']);
            labels_result = labels_result.labels_result;
            partialLen = size(labels_result, 2);

            features = load([videos_path '\' dirList{i} '\features.mat']);
            features = features.F;

            for j = 1:partialLen
                label_id = labels_result(j).label;
                if(any(used_labels==label_id))
                    label_id = label_id - 1;
                
                    if(balanced)
                    
                        picksThisLabelTrain = vecRandomPicksTrain{label_id};
                        picksThisLabel = vecRandomPicks{label_id};
                        % We add it to the test set
%                         if(vecCountNumTest(label_id) <= length(picksThisLabel) && vecCountTotal(label_id) == picksThisLabel(vecCountNumTest(label_id)))
                        if(vecCountNumTest(label_id) <= length(picksThisLabel) && countTotal == picksThisLabel(vecCountNumTest(label_id)))
                            F_test{label_id}(vecCountNumTest(label_id),:) = [features(j,(sizeTime+1):lenFeatures)];
                            vecCountNumTest(label_id) = vecCountNumTest(label_id) + 1;
                        end
                        % We add it to the train set
%                         if(vecCountNumTrain(label_id) <= length(picksThisLabelTrain) && vecCountTotal(label_id) == picksThisLabelTrain(vecCountNumTrain(label_id)))
                        if(vecCountNumTrain(label_id) <= length(picksThisLabelTrain) && countTotal == picksThisLabelTrain(vecCountNumTrain(label_id)))
                            F_train{label_id}(vecCountNumTrain(label_id),:) = [features(j,(sizeTime+1):lenFeatures)];
                            vecCountNumTrain(label_id) = vecCountNumTrain(label_id) + 1;
                        end
                    
                    else
                    
                        % We add it to the test set
                        picksThisLabel = vecRandomPicks{label_id};
%                         if(vecCountNumTest(label_id) <= length(picksThisLabel) && vecCountTotal(label_id) == picksThisLabel(vecCountNumTest(label_id)))
                        if(vecCountNumTest(label_id) <= length(picksThisLabel) && countTotal == picksThisLabel(vecCountNumTest(label_id)))
                            F_test{label_id}(vecCountNumTest(label_id),:) = [features(j,(sizeTime+1):lenFeatures)];
                            vecCountNumTest(label_id) = vecCountNumTest(label_id) + 1;
                        % We add it to the train set
                        else
                            F_train{label_id}(vecCountNumTrain(label_id),:) = [features(j,(sizeTime+1):lenFeatures)];
                            vecCountNumTrain(label_id) = vecCountNumTrain(label_id) + 1;
                        end
                        
                    end

%                     vecCountTotal(label_id) = vecCountTotal(label_id) + 1;
                    
                end
                
                countTotal = countTotal + 1;
            end
        end

        %% Trains and classifies
        disp(' ');
        disp(['--- ' 'Starting test ' num2str(t) '/' num2str(numTests) ' ---']);
        disp(' ');
        
        if(strcmp(method, 'AdaBoost'))
            
            % Creates the structure for the training and for the testing
            trainNorm = cell2struct(F_train', labels_cell, 1);
            testNorm = cell2struct(F_test', labels_cell, 1);

            % Trains the AdaBoost classifier
            trainedClassifiers = trainBOOST(false, trainNorm, numOfAdaBoostRounds, labels_cell, 'OneVsOne');
            % Tests the AdaBoost classifier
            [tests margins] = testBOOST(testNorm, labels_cell, trainedClassifiers);
            
        elseif(strcmp(method, 'KNN'))
            
            F = []; F_t = []; % features train and test
            L = []; L_t = []; % labels train and test(groundtruth)
            for i = 1:numClasses
                F = [F; F_train{i}];
                L = [L; ones(length(F_train{i}),1)*i];
                F_t = [F_t; F_test{i}];
                L_t = [L_t; ones(length(F_test{i}),1)*i];
            end
            
            %classifies
            trainedClassifier = ClassificationKNN.fit(F,L,'NumNeighbors',numNearestNeighboursKNN);
            % tests
            [labels results] = predict(trainedClassifier,F_t);
            
            if(balanced && showNeighbours)
                getNeighbours(numClasses, F_train, F, F_t, numNearestNeighboursKNN, results, vecRandomPicks, vecRandomPicksTrain, t, save_path, dirList, format);
            end
            
        end
    
        
        %% Stores the results
        
        if(strcmp(method, 'AdaBoost'))
            % Calculates the resulting label for each image
            results = zeros(length(margins), 2);
            labels = zeros(size(margins,1),1);
            for i = 1:size(margins,1)
                if(margins(i,1) > 0)
                    results(i,1) = results(i,1) + margins(i,1);
                else
                    results(i,2) = results(i,2) + abs(margins(i,1));
                end
%                 if(margins(i,2) > 0) % Class1 vs Class3
%                     results(i,1) = results(i,1) + margins(i,2);
%                 else
%                     results(i,3) = results(i,3) + abs(margins(i,2));
%                 end
%                 if(margins(i,3) > 0) % Class2 vs Class3
%                     results(i,2) = results(i,2) + margins(i,3);
%                 else
%                     results(i,3) = results(i,3) + abs(margins(i,3));
%                 end
                [c, j] = max(results(i,:));
                labels(i) = j;
            end
            results = results/2;
            
%         elseif(strcmp(method, 'KNN'))
%             
%             results = zeros(length(labels), numClasses);
            
        end


        % Calculates TP, FP and FN
        countFP = zeros(numClasses,1);
        countTP = zeros(numClasses,1);
        countFN = zeros(numClasses,1);
        countTN = zeros(numClasses,1);
        specificity = zeros(numClasses,1);
        sensitivity = zeros(numClasses,1);
        
        FNidx =  {};
        for i = 1:numClasses
            FNidx{i} = [];
        end
        
        
        % Calculates FPs, TPs, TNs and FNs
        for i = 1:sum(vecNumImgsTest)
            if(i <= vecNumImgsTest(1)) % Plate
                if(labels(i) == 1)
                    countTP(1) = countTP(1) + 1;
                    likelihoodTP{1}{t} = [likelihoodTP{1}{t}; results(i, labels(i))];
                else
                    countFP(labels(i)) = countFP(labels(i)) + 1;
                    likelihoodFP{labels(i)}{t} = [likelihoodFP{labels(i)}{t};  results(i, labels(i))];
                    FNidx{1} = [FNidx{1} i];
                end
            elseif(i <= (vecNumImgsTest(1)+vecNumImgsTest(2))) % Semi Plate
                if(labels(i) == 2)
                    countTP(2) = countTP(2) + 1;
                    likelihoodTP{2}{t} = [likelihoodTP{2}{t}; results(i, labels(i))];
                else
                    countFP(labels(i)) = countFP(labels(i)) + 1;
                    likelihoodFP{labels(i)}{t} = [likelihoodFP{labels(i)}{t};  results(i, labels(i))];
                    FNidx{2} = [FNidx{2} i];
                end
%             elseif(i <= (vecNumImgsTest(1)+vecNumImgsTest(2)+vecNumImgsTest(3))) % Semi Plate
%                 if(labels(i) == 3)
%                     countTP(3) = countTP(3) + 1;
%                     likelihoodTP{3}{t} = [likelihoodTP{3}{t}; results(i, labels(i))];
%                 else
%                     countFP(labels(i)) = countFP(labels(i)) + 1;
%                     likelihoodFP{labels(i)}{t} = [likelihoodFP{labels(i)}{t};  results(i, labels(i))];
%                     FNidx{3} = [FNidx{3} i];
%                 end
            end

        end

        % Specificity and sensitivity
        for i = 1:numClasses
            countFN(i) = vecNumImgsTest(i) - countTP(i);
            countTN(i) = sum(vecNumImgsTest) - (countTP(i) + countFN(i) + countFP(i));
            sensitivity(i) = countTP(i)/(countTP(i)+countFN(i));
            specificity(i) = countTN(i)/(countTN(i)+countFP(i));
        end
        
        for i = 1:numClasses
            vecTP(t,i) = countTP(i);
            vecFP(t,i) = countFP(i);
            vecTN(t,i) = countTN(i); 
            vecFN(t,i) = countFN(i);
            vecSpecificity(t,i) = specificity(i);
            vecSensitivity(t,i) = sensitivity(i);
        end
        
        %% Saves the FNs images to be relabeled
        if(saveFN)
            
            acumFN = 0;
            for i = 1:numClasses
                % Gets the indexes of all the images that have gotten a FN
                FNidx{i} = vecRandomPicks{i}(FNidx{i}-acumFN);
                
                lenFN = length(FNidx{i});
                newSetFeatures = zeros(lenFN, lenFeatures);
                location = struct('folder', {}, 'original_name', {}, 'pos', {});
                count = 1;
                j = 1;
                idxPassed = 0;
                % Goes through all the directories finding these indexes
                while(count <= lenFN && j <= lenFiles)
                    names = dir([save_path '\' dirList{j}]);
                    names = names(3:end);
                    features = load([videos_path '\' dirList{j} '\features.mat']);
                    features = features.F;
                    partialLen = size(features, 1);
                    
                    while(count <= lenFN && FNidx{i}(count) <= (partialLen+idxPassed))
                        % For each image found
                        idx = ( (FNidx{i}(count)) - idxPassed);
                        newSetFeatures(count, :) = features(idx,:);
                        location(count).folder = dirList{j};
                        location(count).original_name = names(idx).name;
                        location(count).pos = idx;
                        
                        count = count+1;
                    end

                    idxPassed = idxPassed + partialLen;
                    j = j+1;
                    
                end
                % For all the images found
                folder = [save_path '/FNs Class' num2str(i) ' numTest=' num2str(t)];
                mkdir(folder);
                % Copies them in the new folder
                for j = 1:lenFN
                    new_name = strcat(sprintf('%06d', j), format);
                    copyfile([save_path '/' location(j).folder '/' location(j).original_name], [folder '/' new_name]);
                end
                features = newSetFeatures;
                save([folder '/features.mat'], 'features');
                save([folder '/location.mat'], 'location');

                acumFN = acumFN + vecNumImgsTest(i);
            end

        end
        
    end
    
    %% Calculates average results
    for i = 1:numClasses
        avgTP(i) = sum(vecTP(:,i))/numTests;
        avgFP(i) = sum(vecFP(:,i))/numTests;
        avgTN(i) = sum(vecTN(:,i))/numTests;
        avgFN(i) = sum(vecFN(:,i))/numTests;
        avgSpecificity(i) = sum(vecSpecificity(:,i))/numTests;
        avgSensitivity(i) = sum(vecSensitivity(:,i))/numTests;
    end
    
    %% Shows result #TP vs #FP with likelihood
    showFigurePrecVsMarg(ids, likelihoodTP, likelihoodFP, marginsLH, numClasses, numTests, testFolder);
        
    %% Shows results graphic bars
    
    % Fills the test_results file
    fillTestResultsFile(numClasses, ids, vecNumImgsTest, vecNumImgsTrain, avgTP, avgFN, avgFP, avgTN, avgSpecificity, avgSensitivity, testFolder);
    
    % Displays the result in text format
    for i = 1:numClasses
        disp(['[Class ' num2str(i) ']:']);
        disp(['Total Imgs: ' num2str(vecNumImgsTest(i)+vecNumImgsTrain(i)) ', Test Imgs: ' num2str(vecNumImgsTest(i)) ', TP: ' num2str(avgTP(i)) ', FN: ' num2str(avgFN(i)) ', FP: ' num2str(avgFP(i)) ', TN: ' num2str(avgTN(i))]);
        disp(['          ' 'Specificity: ' num2str(avgSpecificity(i)) ', Sensitivity: ' num2str(avgSensitivity(i))]);
        disp(' ');
    end
    

    % Displays the result in a figure
    showFigureBars(method, ids, vecNumImgsTest', avgTP', avgFN', avgFP', numOfAdaBoostRounds, numTests, testFolder);
    
    
end
