
% Plots the clicks vs the time on an ActiveLabeling session
function clicksVsTimePlot()

    folders_path = '\\vmware-host\Shared Folders\Mark Mac\Documents\Dropbox\Universitat Assignatures\Treball Fi de Grau\Resultats\TFG Resultats\Labeling Results Active Learning';
    folders_name = {};
    count = 1;
    
    fileList = dir(folders_path);
    fileList = fileList(3:end);
    
    %% Plots the clicks per iteration
    figure
    for i = 1:length(fileList)

        matFile = dir([folders_path '\' fileList(i).name '\*.mat']);
        if(length(matFile) > 0)
            
            folders_name{count} = fileList(i).name;
            count = count+1;
            file_name = matFile(1).name;
    
            num_clicks_array = load([folders_path '\' fileList(i).name '\' file_name]);
            num_clicks_array = num_clicks_array.num_clicks_array;

            % Plots the clicks on each iteration
            plot(num_clicks_array);
            hold all;
            
            
        end
    end
    
    xlabel('Iterations');
    ylabel('Clicks');
    title({'Clicks vs Iterations'});
    legend(folders_name{:});
    
    
    %% Plots the accumulated clicks
    figure
    for i = 1:length(fileList)

        matFile = dir([folders_path '\' fileList(i).name '\*.mat']);
        if(length(matFile) > 0)
            
            file_name = matFile(1).name;
            
            num_clicks_array = load([folders_path '\' fileList(i).name '\' file_name]);
            num_clicks_array = num_clicks_array.num_clicks_array;

            % Plots the accumulated clicks on each iteration
            plot(cumsum(num_clicks_array));
            hold all;
            
            
        end

    end
    
    xlabel('Iterations');
    ylabel('Accumulated Clicks');
    title({'Accumulated Clicks vs Iterations'});
    legend(folders_name{:});
    
end