% Auxiliary function
function fillTestResultsFile(numClasses, ids, vecNumImgsTest, vecNumImgsTrain, avgTP, avgFN, avgFP, avgTN, avgSpecificity, avgSensitivity, testFolder)

    test_results = struct('class_name', {}, 'class_id', {}, 'total_images', {}, 'test_images', {}, 'TP', {}, 'FN', {}, 'FP', {}, 'TN', {}, 'specificity', {}, 'sensitivity', {});
    
    for i = 1:numClasses
        test_results(i).class_name = ids{i};
        test_results(i).class_id = i;
        test_results(i).total_images = vecNumImgsTest(i)+vecNumImgsTrain(i);
        test_results(i).test_images = vecNumImgsTest(i);
        test_results(i).TP = avgTP(i);
        test_results(i).FN = avgFN(i);
        test_results(i).FP = avgFP(i);
        test_results(i).TN = avgTN(i);
        test_results(i).specificity = avgSpecificity(i);
        test_results(i).sensitivity = avgSensitivity(i);
    end
    
    save([testFolder '/test_results.mat'], 'test_results');
    
end