% Auxiliar function
% Displays a figure to see the results of the test
function showFigureBars(method, names, num, tp, fn, fp, rounds, numTests, testFolder)

    colors = [  0.2706  0.6157  0.8078;
                0.2000  1.0000  0.2000;
                0.8000  0.2000  0;
                0.9686  0.6824  0.1294  ];

    x = names;
    y = [num; tp; fn; fp]';

    % Creates the figure
    fig_h = figure;
    bar_h = bar(1:length(x), y);
   
    
    % Set the X-Tick locations
    Xt = 1:length(x);
    Xl = [0 length(x)+1.5];
    set(gca,'XTick',Xt,'XLim',Xl);

    ax = axis; % Current axis limits
    axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
    Yl = ax(3:4); % Y-axis limits
    
    % Place the text labels
    t = text(Xt,Yl(1)*ones(1,length(Xt)), x);
    set(t,'HorizontalAlignment','center','VerticalAlignment','top','Rotation',0);
    
    % Remove the default labels
    set(gca,'XTickLabel','');
    
    % Sets the color to each bar
	for i = 1:length(bar_h)
        set(bar_h(i),'facecolor',colors(i,:))
    end
    
    legend('Total','Average TP','Average FN','Average FP');
    if(strcmp(method, 'AdaBoost'))
        title(['AdaBoost rounds: ' num2str(rounds) '  |  Number of random tests: ' num2str(numTests)]);
    elseif(strcmp(method, 'KNN'))
        title(['KNN test  |  Number of random tests: ' num2str(numTests)]);
    end

    saveas(fig_h, [testFolder '/graphic'], 'jpg');
    
end