
function compareFeaturesAdaBoost()
    %% Data initialization
    global classes;
    addpath('../auxCode');
    global app_path;
    app_path = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY';
    
    labels_cell = {}; % Stores the different labels of our images
    F = {}; % Stores a cell matrix with the list of features of for each label

    loadClasses();
    videos_path = [app_path '\result_files'];
    
    % First and last features related to the HOG
    firstHOGfeature = 4;
    lastHOGfeature = 84;
    
    % HOG dimensions
    HOG = [3 3 9];
    
    %%%%%%%%%% NP vs P vs SP
    mode = 1;
    classifier_path = '..\..\Labeling\Demo Labeling - WORKING COPY\AdaBoost classifier\Single Classifier\classifier.mat';
    ids = {'No Plate', 'Plate', 'Semi Plate'};
    classifier_labels = [1 2 3];
    
    %%%%%%%%%% NP vs P + SP
%     mode = 2;
%     classifier_path = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY\AdaBoost classifier\Combined Classifier\NPvsP+SP\classifier.mat';
%     ids = {'No Plate', 'Plate & Semi Plate'};
%     joined_labels = [2 3];

    %%%%%%%%%% P vs SP
%     mode = 3;
%     classifier_path = 'C:\Users\Marc\Desktop\Treball Final de Grau\Labeling\Demo Labeling - WORKING COPY\AdaBoost classifier\Combined Classifier\PvsSP\classifier.mat';
%     ids = {'Plate', 'Semi Plate'};
%     classifier_labels = [2 3];
    
    
    num_features = 5;
    
    classifier = load(classifier_path);
    classifier = classifier.trainedClassifiers;
    
    
    %% Gets the best and the worse features for each sub-classifier
    best = {};
    worst = {};
    allOrdered = {};
    for i = 1:length(classifier)
        
        best{i} = [];
        worst{i} = [];
        allOrdered{i} = [];
        for j = 1:num_features
            best{i} = [best{i}; classifier{i}(j).feature];
        end
        for j = length(classifier{i}):-1:(length(classifier{i}) - num_features + 1)
            worst{i} = [worst{i}; classifier{i}(j).feature];
        end
        for j = 1:length(classifier{i})
            if(~any(allOrdered{i}==classifier{i}(j).feature))
                allOrdered{i} = [allOrdered{i}; classifier{i}(j).feature];
            end
        end
        
    end
    
    
    %% Loads the data from the labeled samples
    
    % Gets the dir list
    fileList = dir([videos_path]);
    dirList = {};
    len = length(fileList);
    for i = 3:len
        if(isdir([videos_path '\' fileList(i).name]))
            dirList = [dirList fileList(i).name];
        end
    end
    
    % Eliminar?
    dirList = {
            'Dishes images_renamed_1to100_slides-part1-part1_89x120'; 'Dishes images_renamed_1to100_slides-part1-part2_89x120'; 'Dishes images_renamed_1to100_slides-part2-part1_89x120'; 'Dishes images_renamed_1to100_slides-part2-part2_89x120'; ...
            '0BC25B01-7420-DD20-A1C8-3B2BD6C87CB0_3to62_slides-part1_89x120'; '0BC25B01-7420-DD20-A1C8-3B2BD6C87CB0_3to62_slides-part2_89x120'; '0BC25B01-7420-DD20-A1C8-3B2BD6C87CB0_3to62_slides-part3_89x120'; ...
            '6FD1B048-A2F2-4CAB-1EFE-266503F59CD3_81to120_slides-part1_89x120'; '6FD1B048-A2F2-4CAB-1EFE-266503F59CD3_81to120_slides-part2_89x120'; ...
            '650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part1_89x120'; '650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part2_89x120'; '650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part3_89x120'; '650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part4_89x120'; '650EA48B-AB7B-4BA5-2FA1-34F3D1B3CE9D_11to91_slides-part5_89x120'; ...
            'D165DFFA-B41D-26BC-4C16-BFB23F981BE8_3783to3868_slides-part1_89x120'; 'D165DFFA-B41D-26BC-4C16-BFB23F981BE8_3783to3868_slides-part2_89x120'; 'D165DFFA-B41D-26BC-4C16-BFB23F981BE8_3783to3868_slides-part3_89x120'; ...
            'EE6B5EA5-9ABF-32DA-9709-AAFEB23BB51E_150to350_slides-part1_89x120'; 'EE6B5EA5-9ABF-32DA-9709-AAFEB23BB51E_150to350_slides-part2_89x120'; 'EE6B5EA5-9ABF-32DA-9709-AAFEB23BB51E_150to350_slides-part3_89x120'; 'EE6B5EA5-9ABF-32DA-9709-AAFEB23BB51E_150to350_slides-part4_89x120'; ...
            'FD214597-9360-9CA1-9393-914D9B7BB726_3844to3903_slides-part1_89x120'; 'FD214597-9360-9CA1-9393-914D9B7BB726_3844to3903_slides-part2_89x120'; 'FD214597-9360-9CA1-9393-914D9B7BB726_3844to3903_slides-part3_89x120'
            };
    
    % Gets a cell with all the classes names
    lenClasses = length(ids);
    for i = 1:lenClasses
        labels_cell(i) = {['label_' num2str(ids{i})]};
    end
    
    % Counts the number of images for each label
    lenFiles = length(dirList);
    vecNumImgs = zeros(lenClasses,1);
    idxClasses = {};
    for i = 1:lenClasses
        idxClasses{i} = [];
    end
    totalLength = 1;
    for i = 1:lenFiles
        labels_result = load([videos_path '\' dirList{i} '\labels_result_' dirList{i} '.mat']);
        labels_result = labels_result.labels_result;
        partialLen = size(labels_result, 2);
        
        for j = 1:partialLen
            label = labels_result(j).label;
            if(mode == 2) % Combined Classifier1
                if(any(joined_labels == label))
                    label = joined_labels(1);
                end
            elseif(mode == 3) % Combined Classifier2
                if(any(classifier_labels ~= label))
                    label = 0;
                else
                    label = label-1;
                end
            end
            
            if(label ~= 0)
                idxClasses{label} = [idxClasses{label} totalLength];
                vecNumImgs(label) = vecNumImgs(label) + 1;
                totalLength = totalLength+1;
            end
            
        end
    end

    % Loads one features file to know the needed length of the vector
    % We eliminate the features related to the Time (6 components)
    sizeTime = 6;
    features = load([videos_path '\' dirList{1} '\features.mat']);
    lenFeatures = size(features.F, 2);
    for i = 1:lenClasses
        F{i} = zeros(vecNumImgs(i),lenFeatures - sizeTime);
    end
    
    % Creates the cell to prepare the data
    countTotal = 1;
    vecCountNumImgs = ones(lenClasses,1);
    for i = 1:lenFiles
        labels_result = load([videos_path '\' dirList{i} '\labels_result_' dirList{i} '.mat']);
        labels_result = labels_result.labels_result;
        partialLen = size(labels_result, 2);
        
        features = load([videos_path '\' dirList{i} '\features.mat']);
        features = features.F;
        
        for j = 1:partialLen
            label_id = labels_result(j).label;
            if(mode == 2) % Combined Classifier1
                if(any(joined_labels == label_id))
                    label_id = joined_labels(1);
                end
            elseif(mode == 3) % Combined Classifier2
                if(any(classifier_labels == label_id))
                    label_id = label_id-1;
                else
                    label_id = 0;
                end
            end
            
            if(label_id ~= 0)
                F{label_id}(vecCountNumImgs(label_id),:) = [features(j,(sizeTime+1):lenFeatures)];
                vecCountNumImgs(label_id) = vecCountNumImgs(label_id) + 1;
            end
            
            countTotal = countTotal + 1;
            
        end
    end
    
    
    %% Creates and shows the graphics
    combos = combnk(1:lenClasses, 2);
    
    % For each pair of classes
    for i = 1:size(combos,1)
        % We create a graphic for the best features and another one for the worse ones
        for j = 1:2
            
            % We get the data from the best features
            if(j == 1)
                features = best{i};
                type_features = 'Best';
            % We get the data from the worse features
            elseif(j == 2)
                features = worst{i};
                type_features = 'Worst';
            end
            
            % Average feature value for each feature and for each class
            f_list = zeros(2, num_features);
            % Calculates the average for each class and each feature
            for k = 1:2
                for l = 1:num_features
                    % For each element on that class
                    lenElems = length(F{combos(i, k)});
                    for m = 1:lenElems
                        f_list(k, l) = f_list(k, l) + F{combos(i, k)}(m, features(l));
                    end
                    f_list(k, l) = f_list(k, l) / lenElems;
                end
            end
            
            
            %% Draws the figure
            dif = [];
            labels = {};
            for k = 1:num_features
                dif = [dif; f_list(1, k)-f_list(2, k)];
                dif(k) = ((100*f_list(1, k)) / f_list(2, k)) - 100;
                labels{k} = [num2str(features(k)) ' (' num2str(dif(k)) ')'];
            end
            
            x = labels;
            y = f_list';

            % Creates the figure
            fig_h = figure;
            bar_h = bar(1:length(x), y);
            
            % Set the X-Tick locations
            Xt = 1:length(x);
            Xl = [0 length(x)+1.5];
            set(gca,'XTick',Xt,'XLim',Xl);

            ax = axis; % Current axis limits
            axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
            Yl = ax(3:4); % Y-axis limits

            % Place the text labels
            t = text(Xt,Yl(1)*ones(1,length(Xt)), x);
            set(t,'HorizontalAlignment','center','VerticalAlignment','top','Rotation',0);

            % Remove the default labels
            set(gca,'XTickLabel','');
            
            class_names = {ids{combos(i, 1)}; ids{combos(i, 2)}};
            legend(class_names);
            
            title([type_features ' defining features (% difference 1vs2)  |  ' class_names{1} ' vs ' class_names{2}]);
            
        end
    end
    
    
    %% Creates the HOG gradients image
    
    % Gets only the HOG-related features
    for i = 1:length(allOrdered)
        aux = [];
        for j = 1:length(allOrdered{i})
            if(allOrdered{i}(j) >= firstHOGfeature && allOrdered{i}(j) <= lastHOGfeature)
                aux = [aux; (allOrdered{i}(j) - firstHOGfeature + 1)];
            end
        end
        allOrdered{i} = aux;
    end
    
    % Creates an image for each classifier
    for i = 1:length(allOrdered)
       
        order = allOrdered{i};
        scale = 150;
        base_angle = 220;
        increment_angle = 360/HOG(3);
        
        lenHOG = HOG(1)*HOG(2)*HOG(3);
        intensity = lenHOG - 1;
        increment = 255/intensity;
        img = zeros(HOG(1)*scale, HOG(2)*scale, 3);
        img(:,:,2) = ones(HOG(1)*scale, HOG(2)*scale)*180;
        img(:,:,1) = ones(HOG(1)*scale, HOG(2)*scale)*180;
        
        figure
        imshow(uint8(img));
        title(['Classifier ' ids{combos(i,1)} ' vs ' ids{combos(i,2)}]);
        
        % For each feature
        for j = 1:length(order)
            
            id = order(j);
            
            % Gets position in quadrant
            p = mod(id, HOG(3));
            if(p == 0)
                pos = HOG(3)-1;
                p = HOG(3);
            else
                pos = p-1;
            end
            % Gets Quadrant
            quad = (id - p) / HOG(3) + 1;
            quad_x = mod(quad, HOG(1));
            if(quad_x == 0)
                quad_x = HOG(1);
            end
            quad_y = ceil(quad / HOG(2));
            
            rot = mod(base_angle+(pos*increment_angle), 360);
            int = intensity*increment/255;
            text(scale*quad_x - scale/2, scale*quad_y - scale/2,'\rightarrow','rotation',rot, 'color', [int int int]);

            intensity = intensity-1;
        end
        
    end
    
end