function comparisonsPrecVsLH()

    %% Parameters and initializations
    
    % 10-fold Join Labels
%     tests_file = '\\vmware-host\Shared Folders\Mark Mac\Documents\Dropbox\Universitat Assignatures\Treball Fi de Grau\Resultats\TFG Resultats\Classificators Test Results\10-fold Join_Labels tests\NP vs (P + SP)';

    % 10-fold 2 Labels
    tests_file = '\\vmware-host\Shared Folders\Mark Mac\Documents\Dropbox\Universitat Assignatures\Treball Fi de Grau\Resultats\TFG Resultats\Classificators Test Results\10-fold 2 labels\P vs SP';
    
    % 10-fold
%     tests_file = '\\vmware-host\Shared Folders\Mark Mac\Documents\Dropbox\Universitat Assignatures\Treball Fi de Grau\Resultats\TFG Resultats\Classificators Test Results\10-fold tests';
    
    resolution = '89x120';
    method = 'AdaBoost';
%     K = [5 9 15 21];
    K = [50 1500];
    balanced = true;
    
    marginsLH = 0:0.05:1;
    
    
    if(balanced)
        balanced = 'Balanced';
    else
        balanced = 'NonBalanced';
    end
    
    %% Finds all the folders that accomplish the prerequisites
    folders = dir(tests_file);
    folders = folders(3:end);
    lenFolders = length(folders);
    plot_folders = {};
    
    count = 1;
    for i = 1:lenFolders
       if(isdir([tests_file '/' folders(i).name]))
           
           elems = regexp(folders(i).name, ' ', 'split');
           nn = regexp(elems{3}, '=', 'split');
           nn = str2num(nn{2});
           
           if(strcmp(elems{1}, resolution) && strcmp(elems{2}, method) && any(K==nn) && strcmp(elems{5}, balanced))
               plot_folders{count} = folders(i).name;
               count = count+1;
           end
           
       end
    end
    

    %% Gets the info from all the folders to show the graphics
    lenFolders = length(plot_folders);
    folders_file = {};
    folders_name = {};
    
    count = 1;
    for i = 1:lenFolders
        precVSlh_file = [tests_file '/' plot_folders{i} '/precVSlh.mat'];
        if(exist(precVSlh_file))
            
            precVSlh = load(precVSlh_file);
            folders_file{count} = precVSlh.precVSlh;
            folders_name{count} = plot_folders{i};
            
            
            count = count+1;
            
        end
    end
    
    %% We only continue if at least one of the folders had the precVSlh.mat file
    lenFiles = length(folders_file);
    if(lenFiles > 0)
        
        numClasses = length(folders_file{1});
        
        test_results = load([tests_file '/' plot_folders{1} '/test_results.mat']);
        test_results = test_results.test_results;
        ids = {};
        for i = 1:length(test_results)
            ids{i} = test_results(i).class_name;
        end
        
        marginsLabels = [];
        for i = 1:length(marginsLH)-1
            marginsLabels = [marginsLabels; {[num2str(marginsLH(i)) ' - ' num2str(marginsLH(i+1))]}];
        end
        
        for i = 1:numClasses
            fig_h = figure;

            for j = 1:lenFiles
            
                likelihood = folders_file{j}(i).likelihood;
                precision = folders_file{j}(i).precision;
                
                plot(likelihood, precision);
                hold all;
                
            end

                x = likelihood;
                % Set the X-Tick locations
                Xt = likelihood';
                Xl = [0 marginsLH(end)];
                set(gca,'XTick',Xt,'XLim',Xl);

                % Reduce the size of the axis so that all the labels fit in the figure.
                pos = get(gca,'Position');
                set(gca,'Position',[pos(1), 0.2, pos(3) .7])

                ax = axis; % Current axis limits
                axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
                Yl = ax(3:4); % Y-axis limits

                % Place the text labels
%                 t = text(Xt,Yl(1)*ones(1,length(Xt)), resol);
%                 set(t,'HorizontalAlignment','right','VerticalAlignment','top','Rotation',45);
            
                t = text(Xt,Yl(1)*ones(1,length(precision)), marginsLabels');
                set(t,'HorizontalAlignment','right','VerticalAlignment','middle','Rotation',90);

                % Remove the default labels
                set(gca,'XTickLabel','');


                title({'Precision vs Likelihood'; ids{i}});
                ylabel('Precision');
                
                leg = legend(folders_name{:});


        end
        
        
    end
    
end