
function test_marc()

    install();
    clear all,clc;
    
    global join_labels;
    global numNearestNeighboursKNN;
    
    global classNoPlate;
    global classPlate;
    global classSemiplate;
    
    join_labels = [2 3];
    numNearestNeighboursKNN = 15;
    classNoPlate.id = 1;
    classPlate.id = 2;
    classSemiplate.id = 3;
    
    load('test_data.mat');
    addpath('../Labeling/Demo Labeling - WORKING COPY/stable');
    
    uniqueLabels = unique(all_labels);
    
    
    
    %% Balances the training data
    count = zeros(length(uniqueLabels), 1);
    posElems = {};
    for i = 1:length(uniqueLabels)
        posElems{i} = [];
    end
    for i = 1:(lenSeen+lenUnseen)
        pos = find(uniqueLabels==all_labels(i));
        count(pos) = count(pos) +1;
        posElems{pos} = [posElems{pos} i];
    end
    numPicks = min(count);
    chosen_features = [];
    chosen_labels = [];
    for i = 1:length(uniqueLabels)
        % Picks the random indx to train
        M = posElems{i};
        p = randperm(length(M)); % Reshuffle their order randomly
        chosen_features = [chosen_features; all_features(M(p(1:numPicks)), :)]; % Choose the first "numPicks" of these
        chosen_labels = [chosen_labels; all_labels(M(p(1:numPicks)))];
    end
    
    
    %% LMNN without previous PCA
    minDim = 2;
    maxDim = 80;
    iters = 3;
    k = 3;
    
    results = zeros(maxDim-minDim, iters);
    for dim = minDim:maxDim
        
        for iter = 1:iters
            
            % LMNN
            [L, Det] = lmnn2(chosen_features', chosen_labels', k, 'outdim', dim, 'quiet', 1, 'maxiter', 500);
            L = L';
            trans_features = elems_features * L;

            % KNN
            new_labels = [];
            for i = 1:length(seen_labels)
                I = [1:(i-1) (i+1):length(seen_labels)];
                new_labels = [new_labels; KNN_for_tree([], seen_labels(I), trans_features(I,:), trans_features(i,:))];
            end
            
            results(dim-minDim+1,iter) = sum(new_labels == seen_labels);
            
        end
        
    end
    
    save(['results' num2str(minDim) 'to' num2str(maxDim) 'Dim_' num2str(k) 'K.mat'], 'results');
    disp(' ');
    disp('DONE');
    
end